function [control_points,knots,t_parameter]=bspline_interpolation(interpolated_P)



[row_interpolated_P col]= size(interpolated_P);


%%%%%% *   *    *    *   *   *    *    *   *   *    *    *   *   *    *
%%PARAMETER GENERATION
%%%CHORD LENGTH
length = 0;
count = 1;
for i=1:(row_interpolated_P-1)
    count = count+1;
    vector = interpolated_P(i+1,:)-interpolated_P(i,:) ;
    length(count,1) = length(count-1,1) + (dot(vector,vector)^0.5);
end
t_parameter = (length/length(count,:));
[row_t_parameter col]= size(t_parameter);


%%KNOT VECTOR GENERATION
number_of_knots = row_interpolated_P+3+1;
internal_knots=number_of_knots-8;
if internal_knots == 0
    knots = [0;0;0;0;1;1;1;1];
else
    [row_t_parameter col]= size(t_parameter);
    t_parameter_dummy = t_parameter;    
    t_parameter_dummy(row_t_parameter,:)=[];
    t_parameter_dummy(1,:) = [];
    row_t_parameter = row_t_parameter-2;
    count = 0;
    for i=1:(row_t_parameter-3+1)
        count = count+1;
        average(count,1) = (t_parameter_dummy(i,:)+t_parameter_dummy(i+1,:)+t_parameter_dummy(i+2,:))/3;
    end    
    knots = [0;0;0;0;average;1;1;1;1];
end

[rowknots col] = size(knots);
[row_t_parameter col]= size(t_parameter);

count_t = 0;
for loop_of_t = 1:row_t_parameter
    t = t_parameter(loop_of_t,1);
    count_t = count_t+1;
    count = 0;
     for i=1:(rowknots-1)
        awal_knots_line = knots(i,1);
        akhir_knots_line = knots(i+1,1);
        if (awal_knots_line<=t) & (t<=akhir_knots_line)
            count =  count + 1;
            B_01_all(count,1) = 1;
        else
            count =  count + 1;
            B_01_all(count,1) = 0  ;     
        end
     end
    
    count =0;
    for j=1:1:(rowknots-2)
        count= count+1;
        B_01 = B_01_all(j,1);
        B_11 = B_01_all(j+1,1);
        loc_i = knots(j,1);
        loc_i1 = knots(j+1,1);
        loc_i2 = knots(j+2,1);
        if (loc_i1==loc_i) & (loc_i==loc_i2)
            B_02 = 0;
        else
            if  loc_i2 == loc_i1
                B_02 = (t-loc_i)*B_01/(loc_i1-loc_i);
            elseif loc_i1 == loc_i
                B_02 = (loc_i2-t)*B_11/(loc_i2-loc_i1);
            else
                B_02 = (t-loc_i)*B_01/(loc_i1-loc_i) + (loc_i2-t)*B_11/(loc_i2-loc_i1);        
            end
        end
        if B_02>1
           B_02 =1;
        end
        
        B_02_all(count,1) = B_02;
    end
    
    count =0;
    for k=1:1:(rowknots-3)
        count= count+1;
        B_02 = B_02_all(k,1);
        B_12 = B_02_all(k+1,1);
        loc_i = knots(k,1);
        loc_i1 = knots(k+1,1);
        loc_i2 = knots(k+2,1);
        loc_i3 = knots(k+3,1);
        if (loc_i==loc_i1 & loc_i1==loc_i2) & (loc_i2==loc_i3)
            B_03 = 0;
        else
            if  loc_i2==loc_i
                B_03 = (loc_i3-t)*B_12/(loc_i3-loc_i1) ; 
            elseif loc_i3==loc_i1
                B_03 = (t-loc_i)*B_02/(loc_i2-loc_i) ; 
            else
                B_03 = (t-loc_i)*B_02/(loc_i2-loc_i) + (loc_i3-t)*B_12/(loc_i3-loc_i1) ;           
            end
        end        
        B_03_all(count,1) = B_03;
    end  
   
    
    count =0;
    for l=1:1:(rowknots-4)
        count= count+1;
        B_03 = B_03_all(l,1);
        B_13 = B_03_all(l+1,1);
        loc_i = knots(l,1);
        loc_i1 = knots(l+1,1);
        loc_i3 = knots(l+3,1);
        loc_i4 = knots(l+4,1);
        if (loc_i==loc_i1 & loc_i1==loc_i3) & (loc_i3==loc_i4)
            B_04 = 0;
        else
            if  loc_i3==loc_i
                B_04 = (loc_i4-t)*B_13/(loc_i4-loc_i1) ; 
            elseif loc_i4==loc_i1
                B_04 = (t-loc_i)*B_03/(loc_i3-loc_i) ; 
            else
                B_04 = (t-loc_i)*B_03/(loc_i3-loc_i) + (loc_i4-t)*B_13/(loc_i4-loc_i1) ;           
            end
        end        
        B_04_all(count,1) = B_04;
    end
    if loop_of_t==1
        collection_B_04_all = [B_04_all];
    else
        collection_B_04_all = [collection_B_04_all B_04_all];
    end
    t_all(1,count_t) = t;
end

[rowB04 col] = size(collection_B_04_all);

