function [bezier_coordinates] = drawing_bezier_3D(bezier)

[rowb col] = size(bezier);
count = 0;
for i=1:4:rowb
    P0=bezier(i,:);
    P1=bezier(i+1,:);
    P2=bezier(i+2,:);
    P3=bezier(i+3,:);
    t_3_x = -P0(1,1) + 3*P1(1,1) - 3*P2(1,1) + P3(1,1);
    t_2_x = 3*P0(1,1) - 6*P1(1,1) + 3*P2(1,1);
    t_1_x = -3*P0(1,1) + 3*P1(1,1);
    t_0_x = P0(1,1);
 
    t_3_y = -P0(1,2) + 3*P1(1,2) - 3*P2(1,2) + P3(1,2);
    t_2_y = 3*P0(1,2) - 6*P1(1,2) +3*P2(1,2);
    t_1_y = -3*P0(1,2) + 3*P1(1,2);
    t_0_y = P0(1,2);
 
    t_3_z = -P0(1,3) + 3*P1(1,3) - 3*P2(1,3) + P3(1,3);
    t_2_z = 3*P0(1,3) - 6*P1(1,3) +3*P2(1,3);
    t_1_z = -3*P0(1,3) + 3*P1(1,3);
    t_0_z = P0(1,3);
    
    for j=0:0.1:0.9
    count=count+1;
    x(count,1)=( j^3)*t_3_x + ( j^2 )*t_2_x + ( j )*t_1_x + t_0_x;
    y(count,1)=( j^3)*t_3_y + ( j^2 )*t_2_y + ( j )*t_1_y + t_0_y;
    z(count,1)=( j^3)*t_3_z + ( j^2 )*t_2_z + ( j )*t_1_z + t_0_z;
    end
end



bezier_coordinates = [x y z];