function [sample_rays_inserted] = interpolated_sampling_vector(arm_vector,start_value,end_value)

% % clear all
% % arm_vector =[0.00000000000	236.20451765602	-81.63453079903  0.00000000000	-129.46678356383	152.71834733082];
% % arm_vector = [0  242.5427  -89.8904         0 -224.2350   55.5987];
% % start_value =[0.6000];
% % end_value =[0.9000];
% 'IN INTERPOLATES SAMPLING VECTOR'

    unit_UA_vector = arm_vector(1,2:3)/(dot(arm_vector(1,2:3),arm_vector(1,2:3))^0.5);
    unit_LA_vector = arm_vector(1,5:6)/(dot(arm_vector(1,5:6),arm_vector(1,5:6))^0.5);
    angle_UA_LA = acos(dot(unit_UA_vector,unit_LA_vector));
    angle_elbow_interpolation = -(pi-angle_UA_LA);
    UA_sampling_vector = [0 unit_UA_vector]*[1  0  0;0  cos(-pi/2)  sin(-pi/2);0 -sin(-pi/2)  cos(-pi/2)];
    LA_sampling_vector = [0 unit_LA_vector]*[1  0  0;0  cos(pi/2)  sin(pi/2);0 -sin(pi/2)  cos(pi/2)];
    vector = UA_sampling_vector*[1  0  0;0  cos(angle_elbow_interpolation)  sin(angle_elbow_interpolation);0 -sin(angle_elbow_interpolation)  cos(angle_elbow_interpolation)];
    angle_converge = (acos(dot(vector,LA_sampling_vector)))*180/pi;
    if angle_converge<0.01
        sampling_vector = UA_sampling_vector;
    else
        sampling_vector = LA_sampling_vector;
    end
    
    count = 0;
    for j = start_value:0.1:end_value
            angle = angle_elbow_interpolation*j;
            count = count+1;
            vector = sampling_vector*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
            sample_rays_inserted(count,1:4) = [0 0 vector(1,2:3)];
    end
 
%  'OUT INTERPOLATES SAMPLING VECTOR'   
    