function [E_CS] = determine_E_CS_for_any_posture(vector_UA,vector_LA)

%% this will not determine the E_CS for neutral posture
load 'C:\MATLAB7\work\OUTPUT\race.mat';
if race == 0
   m = 0.517;
   b = -5.1738;
else
   m = 0.5132;
   b = -5.2313;
end

[row col] = size(vector_LA);
for i=1:row
    %% the only thing needs to be changed is sum vector
    %% step: 1.calculate the angle for E CS
    %%       2.calculate the vector (to replace sum vector) for E CS
    %% calculate angle for E CS at 135,90 and max (default as 35)
    %% this angle is the projected angle at Y-Z plane
    cross_vector = cross(vector_UA,vector_LA(i,:));
    cross_vector= cross_vector/(dot(cross_vector,cross_vector)^0.5);
    last_vector = cross(cross_vector,vector_UA);
    last_vector= last_vector/(dot(last_vector,last_vector)^0.5);
    UA_basis = [cross_vector;vector_UA;last_vector];   
    %% rotation about X axis
    UA_LA_angle = acos(dot(vector_UA,vector_LA(i,:)))*180/pi;
    angle_between_UA_E = m*UA_LA_angle + b;
    rotated_y = [0 1 0]*[1  0  0;0  cos(angle_between_UA_E*pi/180)  sin(angle_between_UA_E*pi/180);0 -sin(angle_between_UA_E*pi/180)  cos(angle_between_UA_E*pi/180)];
    rotated_y = rotated_y*UA_basis;
    %% projecting rotated y towards YZ plane and calculate the angle with
    %% projected UA
    projected_rotated_y = rotated_y(:,2:3)/(dot(rotated_y(:,2:3),rotated_y(:,2:3))^0.5);
    projected_UA = vector_UA(:,2:3)/(dot(vector_UA(:,2:3),vector_UA(:,2:3))^0.5);
    actual_UA_E_angle = acos(dot(projected_rotated_y,projected_UA))*180/pi;
    iteration = actual_UA_E_angle-angle_between_UA_E;
    while abs(iteration) > 0.1
       if iteration > 0
          step = 0.01;
       else
          step = -0.01;
       end
       angle_between_UA_E = angle_between_UA_E + step;
       rotated_y = [0 1 0]*[1  0  0;0  cos(angle_between_UA_E*pi/180)  sin(angle_between_UA_E*pi/180);0 -sin(angle_between_UA_E*pi/180)  cos(angle_between_UA_E*pi/180)];
       rotated_y = rotated_y*UA_basis;
       projected_rotated_y = rotated_y(:,2:3)/(dot(rotated_y(:,2:3),rotated_y(:,2:3))^0.5);
       projected_UA = vector_UA(:,2:3)/(dot(vector_UA(:,2:3),vector_UA(:,2:3))^0.5);
       actual_UA_E_angle_second_iteration = acos(dot(projected_rotated_y,projected_UA))*180/pi;
       iteration = actual_UA_E_angle-angle_between_UA_E;
    end
    sum_vector = rotated_y;
    %% end of change
    sum_vector = sum_vector/(dot(sum_vector,sum_vector)^0.5);
    cross_vector = cross(vector_LA(i,:),vector_UA);
    cross_vector= cross_vector/(dot(cross_vector,cross_vector)^0.5);
    normal_vector = cross(cross_vector,sum_vector);
    normal_vector= normal_vector/(dot(normal_vector,normal_vector)^0.5);
    z_vector = cross([1 0 0],normal_vector);
    z_vector = z_vector/(dot(z_vector,z_vector)^0.5);
    x_vector = cross(normal_vector,z_vector);
    x_vector = x_vector/(dot(x_vector,x_vector)^0.5);
    E_CS((3*i-2):(3*i),:) = [x_vector;normal_vector;z_vector];
end


% for i=1:row
%     sum_vector = vector_UA + vector_LA(i,:);
%     sum_vector = sum_vector/(dot(sum_vector,sum_vector)^0.5);
%     cross_vector = cross(vector_LA(i,:),vector_UA);
%     cross_vector= cross_vector/(dot(cross_vector,cross_vector)^0.5);
%     normal_vector = cross(cross_vector,sum_vector);
%     normal_vector= normal_vector/(dot(normal_vector,normal_vector)^0.5);
%     z_vector = cross([1 0 0],normal_vector);
%     z_vector = z_vector/(dot(z_vector,z_vector)^0.5);
%     x_vector = cross(normal_vector,z_vector);
%     x_vector = x_vector/(dot(x_vector,x_vector)^0.5);
%     E_CS((3*i-2):(3*i),:) = [x_vector;normal_vector;z_vector];
% end
