function [sample_rays]= create_sampling_vector_final(joint_length_files,arm_vector)

[index] = find(joint_length_files==0);
[unused total_length] = size(joint_length_files);

if isempty(index)
    upper_arm_point = joint_length_files;
    size_joint_length_files = total_length;
    process_UA_only = 1;
elseif total_length>index
    upper_arm_point = joint_length_files(1,1:index);
    [unused size_joint_length_files_upper] = size(upper_arm_point);
    lower_arm_point = joint_length_files(1,index:total_length);
    [unused size_joint_length_files_lower] = size(lower_arm_point);
    process_UA_only = 0;
else
    upper_arm_point = joint_length_files;
    size_joint_length_files = total_length;
    process_UA_only = 0.5;
end

if process_UA_only ==1
   unit_arm_vector = arm_vector(1,1:3)/(dot(arm_vector(1,1:3),arm_vector(1,1:3))^0.5);
   count = 0;
   for i= 1:(size_joint_length_files-1)
       total_segment_length = joint_length_files(1,i+1)-joint_length_files(1,i);
       for j = 0:0.1:1
           count = count+1;
           center_point = unit_arm_vector*(j*total_segment_length + joint_length_files(1,i));
           angle = -pi/2;
           vector = unit_arm_vector*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
           sample_rays(count,1:4) = [center_point(1,2:3) vector(1,2:3)];
       end
   end
end

if process_UA_only ==0.5
   unit_arm_vector = arm_vector(1,1:3)/(dot(arm_vector(1,1:3),arm_vector(1,1:3))^0.5);
   count = 0;
   for i= 1:(size_joint_length_files-1)
       total_segment_length = joint_length_files(1,i+1)-joint_length_files(1,i);
       for j = 0:0.1:1
           count = count+1;
           center_point = unit_arm_vector*(j*total_segment_length + joint_length_files(1,i));
           angle = -pi/2;
           vector = unit_arm_vector*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
           sample_rays_upper(count,1:4) = [center_point(1,2:3) vector(1,2:3)];
       end
   end
   start_value = 0.1;
   end_value = 0.5;
   [sample_rays_inserted] = interpolated_sampling_vector(arm_vector,start_value,end_value);
   sample_rays = [sample_rays_upper;sample_rays_inserted];
end

if process_UA_only ==0
   unit_arm_vector = arm_vector(1,1:3)/(dot(arm_vector(1,1:3),arm_vector(1,1:3))^0.5);
   count = 0;
   for i= 1:(size_joint_length_files_upper-1)
       total_segment_length = upper_arm_point(1,i+1)-upper_arm_point(1,i);
       for j = 0:0.1:1
           count = count+1;
           center_point = unit_arm_vector*(j*total_segment_length + upper_arm_point(1,i));
           angle = -pi/2;
           vector = unit_arm_vector*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
           sample_rays_upper(count,1:4) = [center_point(1,2:3) vector(1,2:3)];
       end
   end
   unit_arm_vector = (arm_vector(1,4:6)/(dot(arm_vector(1,4:6),arm_vector(1,4:6))^0.5));
   count = 0;
   for i= 1:(size_joint_length_files_lower-1)
       total_segment_length = lower_arm_point(1,i+1)-lower_arm_point(1,i);
       for j = 0:0.1:1
           count = count+1;
           center_point = unit_arm_vector*(j*total_segment_length + lower_arm_point(1,i));
           angle = pi/2;
           vector = unit_arm_vector*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
           sample_rays_lower(count,1:4) = [center_point(1,2:3) vector(1,2:3)];
       end
   end
   angle_at_elbow = acos(dot(sample_rays_lower(count,3:4),sample_rays_upper(1,3:4)));   
   count = 0;
   for i= 1:(size_joint_length_files_lower-1)
       total_segment_length = lower_arm_point(1,i+1)-lower_arm_point(1,i);
       for j = 0.1:0.1:0.9
           count = count+1;
           angle = angle_at_elbow*j;
           vector = [0 sample_rays_lower(1,3:4)]*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
           sample_rays_inserted(count,1:4) = [0 0 vector(1,2:3)];
       end
   end
   sample_rays = [sample_rays_upper;sample_rays_inserted;sample_rays_lower];
end

