clear all
'START***************************************************************************************'

profile_points_files = dir(fullfile(matlabroot,'work\Profile Data_FDM_phase_1\Profile points\*.vda'))
joint_length_files = dir(fullfile(matlabroot,'work\Profile Data_FDM_phase_1\Joint length\*.txt')) 

%% joint length files contain: 1. UA/LA vector, 2. flesh deformation area 3. UA/LA length

[row_joint col] = size(joint_length_files);
[row_profile col] = size(profile_points_files);

start_k = 0.1;
end_k = 0.9;
step_k = 0.1;
alt_loc_prev_segment =[]; 
for i=1:6   %% loop as many as the segments (6)
    error_unchanged = 0;
    count_error_unchanged = 0;
    alternative_location =[ ]; %% to signify that the alternative location hasn't been calculated.
    while error_unchanged == 0 %% loop as many as until additional point doesn't make difference to the error level
        count_error_unchanged = count_error_unchanged + 1;
        for j = 1:row_joint %% to cover all subjects
            joint_length_per_subject = read_joint_length_files(joint_length_files(j).name);
            joint_length_files(j).name;
            for k = start_k:step_k:end_k
                if k == start_k
                    count_k = 0;
                end
                count_k = count_k + 1;
                max_error = 0;
                for l=1:(row_profile/row_joint)
                    joint_length_per_key_posture = joint_length_per_subject(l,7:13);
                    arm_vector = joint_length_per_subject(l,1:6);                   
                    segment = i;
                    [unused col_joint_length_per_key_posture] = size(joint_length_per_key_posture);
                    [all_locations] = combine_k_in_one_segment(k,alternative_location,segment);
                    if isempty(alt_loc_prev_segment) == 0
                        all_locations = [alt_loc_prev_segment all_locations];
                    end
                    [sampling_all]= vector_prev_segment(joint_length_per_key_posture,arm_vector,all_locations);
                    fid = fopen(char(fullfile(matlabroot,'work\Profile Data_FDM_phase_1\Profile points\',profile_points_files((j-1)*4 + l).name)));
                    [coordinates] = read_txt_vda(fid);
                    
                    %% find the intersection between profile and the sampling vector
                    bezier = bspline_to_bezier(coordinates(:,2:3));
                    sampled_points = multiple_sampling_new_version(bezier,sampling_all); 
                   
                    [sampling_vector_final]= create_sampling_vector_final(joint_length_per_key_posture(1,1:(segment+1)),arm_vector);
                  
                    actual_points = multiple_sampling_new_version(bezier,sampling_vector_final);
                    bezier = bspline_to_bezier(sampled_points);
                    [bezier_coordinates] = drawing_bezier(bezier);
                    approximated_points = multiple_sampling_new_version(bezier,sampling_vector_final); 
                    
                    [row_error col] = size(approximated_points);
                    for v = 1:row_error
                        error(v,1) = abs(dot(actual_points(v,:),actual_points(v,:))^0.5-dot(approximated_points(v,:),approximated_points(v,:))^0.5);
                    end
                    max_error = max_error + max(error); 
                end
                all_subjects(j,count_k) = max_error;
            end
        end
    
        %% for all subjects, choose the minimum one. 
        %% outcome: new alternative location, choose the minimum one, tag with the corresponding segment
        %% use the outcome to be added to the next alternative locations loop. if
        %% the error doesn't differ compred to the previous one, break the loop and
        %% move on to the next segments
        %% sort the values
        [unused col_all_subjects] = size(all_subjects);
        for m = 1:col_all_subjects
            sum_all_subjects(1,m) = sum(all_subjects(:,m));
        end
        if count_error_unchanged == 1
            error_prev = min(sum_all_subjects);
            min(sum_all_subjects);
            [val index] = min(sum_all_subjects);
            alternative_location(1,1) = index*step_k;
        else
            [val index] = min(sum_all_subjects);
            error_difference = abs(error_prev-min(sum_all_subjects));
            index*step_k
            match_alternative_location = find(alternative_location(1,:) == (index*step_k));
            already_recorded = isempty(match_alternative_location);
            if (error_difference < 0.5 | already_recorded == 0)
                error_unchanged = 1;
            end
            if isempty(match_alternative_location)
                alternative_location_using_step = index*step_k ;
                alternative_location = [alternative_location (index*step_k)]; 
            end
            if min(sum_all_subjects)<error_prev
                error_prev = min(sum_all_subjects);
            end
        end 
    end
    [unused col_alternative_location] = size(alternative_location);
    if i==1
        alt_loc_prev_segment = [alternative_location;ones(1,col_alternative_location)*i];
    else
        alt_loc_prev_segment = [alt_loc_prev_segment [alternative_location;ones(1,col_alternative_location)*i]];
    end
end

%% save alt_loc_prev_segment
all_locations_fda = alt_loc_prev_segment;
save ('C:\MATLAB7\work\INITIAL INPUT\all_locations_fda','all_locations_fda')
