function [final_matrix_transformed,eigen_vectors_used,mean_matrix] = PCA_for_database(final_matrix)

final_matrix = final_matrix';

[row col]= size(final_matrix);
covariance_matrix = zeros(col,col);
for i=1:(col-1)
    matrix_1 = final_matrix(:,i);
    matrix_2 = final_matrix(:,i+1);
    covariance_matrix(i:i+1,i:i+1) = cov(matrix_1,matrix_2);
end


for i=1:(col-2)
    for j = (i+2):col
    matrix_1 = final_matrix(:,i);
    matrix_2 = final_matrix(:,j);
    delete_later = cov(matrix_1,matrix_2);
    delete_later_element = delete_later(1,2);
    clear delete_later
    covariance_matrix(i,j) = delete_later_element;
    covariance_matrix(j,i) = delete_later_element;
    clear delete_later_element
    end
end

[eigen_vectors,eigen_values]=eig(covariance_matrix);

%% AUTOMATIC EIGEN VALUES DETERMINATION
[row_eigen col_eigen] = size(eigen_vectors);

eigen_values_total = 0;
for i=1:col_eigen
    eigen_values_total = eigen_values_total+eigen_values(i,i);
end

temp_eigen_values_total = 0;
number_of_eigen_values = 0;
for i=col_eigen:-1:1
    temp_eigen_values_total = temp_eigen_values_total+eigen_values(i,i);
    ratio = temp_eigen_values_total/eigen_values_total;
    number_of_eigen_values = number_of_eigen_values+1;
    if ratio >= 0.90
        break
    end
end

eigen_vectors_used = zeros(row_eigen,number_of_eigen_values);
n = 0;
for i=1:number_of_eigen_values
    eigen_vectors_used(:,i) = eigen_vectors(:,col_eigen+(i-1)*n );
    n = -1;
end


clear row_eigen col_eigen
%% END OF AUTOMATIC EIGEN VALUES DETERMINATION

final_matrix_adjusted = final_matrix;
[row col]= size(final_matrix);
mean_all = zeros(row,col);
for i=1:col
    mean_all (:,i) = mean(final_matrix(:,i))*ones(row,1);
    final_matrix_adjusted(:,i) = final_matrix(:,i)-mean_all (:,i);
end

mean_matrix = mean_all(1,:);
final_matrix_transformed = ((eigen_vectors_used)')*((final_matrix_adjusted)');