load ('C:\MATLAB7\work\INITIAL INPUT\sub_unit_vector.mat');

% note: xls file is arranged as: participant 1.. n
%                                   UAF
%                                   UAM
%                                   LAM
%                                   LAF

for i = 1:4
    if i==1
        raw_data = xlsread('C:\MATLAB7\work\CS RAW DATA\Cross Section per gender and race\Asian Female 135.xlsx');
    elseif i == 2
        raw_data = xlsread('C:\MATLAB7\work\CS RAW DATA\Cross Section per gender and race\Asian Male 135.xlsx');
    elseif i == 3
        raw_data = xlsread('C:\MATLAB7\work\CS RAW DATA\Cross Section per gender and race\Caucasian Female 135.xlsx');
    elseif i == 4
        raw_data = xlsread('C:\MATLAB7\work\CS RAW DATA\Cross Section per gender and race\Caucasian Male 135.xlsx');
    end
    [row_CS_distances participants] = size(raw_data);
    for j = 1:participants
        count = 0;
        for k = 1:row_CS_distances
            count = count+1;
            if count <= 16
                n = count;
            else
                n = rem(count,16);
                if n == 0
                   n = 16;
                end
            end
            coordinates_CS(k,1:3) = raw_data(k,j)*unit_vector_for_subfunction(n,:);
        end
        if j == 1
           coordinates_CS_all =  coordinates_CS;
        else
           coordinates_CS_all = [coordinates_CS_all coordinates_CS] ;
        end
    end
    if i == 1
        coordinates_asian_female_neu = coordinates_CS_all;
    elseif i == 2
        coordinates_asian_male_neu = coordinates_CS_all;
    elseif i == 3
        coordinates_caucasian_female_neu = coordinates_CS_all;
    elseif i == 4
        coordinates_caucasian_male_neu = coordinates_CS_all;
    end
end

number_of_loop = row_CS_distances/16;
for i = 1:4
    if i == 1
        coordinates_neu = coordinates_asian_female_neu;
    elseif i == 2
        coordinates_neu = coordinates_asian_male_neu;
    elseif i == 3
        coordinates_neu = coordinates_caucasian_female_neu;
    elseif i == 4
        coordinates_neu = coordinates_caucasian_male_neu;
    end
    [unused number_of_columns] = size(coordinates_neu);
    participants = (number_of_columns/3);
    for j = 1 : participants
        for m = 1:number_of_loop
            interpolated_P = coordinates_neu( (m*16-15):(m*16) , (3*j-2):(3*j) );
            interpolated_P = [interpolated_P;interpolated_P(1,:)];
            [control_points,knots,t_parameter]=bspline_interpolation(interpolated_P);
            [coordinates_bspline] = drawing_bspline_3D(knots,control_points);
            if m==1
                UAF_x_1 = max(coordinates_bspline(:,1));
                UAF_x_2 = min(coordinates_bspline(:,1));
                UAF_x = UAF_x_1-UAF_x_2;
                UAF_y_1 = max(coordinates_bspline(:,2));
                UAF_y_2 = min(coordinates_bspline(:,2));
                UAF_y = UAF_y_1-UAF_y_2;
            elseif m == 2
                UAM_x_1 = max(coordinates_bspline(:,1));
                UAM_x_2 = min(coordinates_bspline(:,1));
                UAM_x = UAM_x_1-UAM_x_2;
                UAM_y_1 = max(coordinates_bspline(:,2));
                UAM_y_2 = min(coordinates_bspline(:,2));
                UAM_y = UAM_y_1-UAM_y_2;
            elseif m == 3
                LAM_x_1 = max(coordinates_bspline(:,1));
                LAM_x_2 = min(coordinates_bspline(:,1));
                LAM_x = LAM_x_1-LAM_x_2;
                LAM_y_1 = max(coordinates_bspline(:,2));
                LAM_y_2 = min(coordinates_bspline(:,2));
                LAM_y = LAM_y_1-LAM_y_2;
            elseif m == 4
                LAF_x_1 = max(coordinates_bspline(:,1));
                LAF_x_2 = min(coordinates_bspline(:,1));
                LAF_x = LAF_x_1-LAF_x_2;
                LAF_y_1 = max(coordinates_bspline(:,2));
                LAF_y_2 = min(coordinates_bspline(:,2));
                LAF_y = LAF_y_1-LAF_y_2;
            end
        end
        if j == 1
           dimension_135_UAFUAM = [UAF_x_1; UAF_x_2; UAF_y_1; UAF_y_2; UAM_x_1; UAM_x_2; UAM_y_1; UAM_y_2];
           dimension_135_LAFLAM = [LAM_x_1; LAM_x_2; LAM_y_1; LAM_y_2; LAF_x_1; LAF_x_2; LAF_y_1; LAF_y_2];
        else
           dimension_135_UAFUAM = [dimension_135_UAFUAM [UAF_x_1; UAF_x_2; UAF_y_1; UAF_y_2; UAM_x_1; UAM_x_2; UAM_y_1; UAM_y_2]];
           dimension_135_LAFLAM = [dimension_135_LAFLAM [LAM_x_1; LAM_x_2; LAM_y_1; LAM_y_2; LAF_x_1; LAF_x_2; LAF_y_1; LAF_y_2]];
        end
    end
    if i == 1
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_UAFUAM_asian_female.mat','dimension_135_UAFUAM');
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_LAFLAM_asian_female.mat','dimension_135_LAFLAM');
    elseif i == 2
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_UAFUAM_asian_male.mat','dimension_135_UAFUAM');
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_LAFLAM_asian_male.mat','dimension_135_LAFLAM');
    elseif i == 3
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_UAFUAM_caucasian_female.mat','dimension_135_UAFUAM');
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_LAFLAM_caucasian_female.mat','dimension_135_LAFLAM');
    elseif i == 4
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_UAFUAM_caucasian_male.mat','dimension_135_UAFUAM');
        save ('C:\MATLAB7\work\INITIAL INPUT\dimension_135_LAFLAM_caucasian_male.mat','dimension_135_LAFLAM');
    end
end

       
