clear all

load('C:\MATLAB7\work\OUTPUT\all_locations.mat');

for k=1:4 
    if k == 1
        load('C:\MATLAB7\work\OUTPUT\profile_distance_per_subject_original_AF.mat');
    elseif k == 2
        load('C:\MATLAB7\work\OUTPUT\profile_distance_per_subject_original_AM.mat');
    elseif k == 3
        load('C:\MATLAB7\work\OUTPUT\profile_distance_per_subject_original_CF.mat');
    else
        load('C:\MATLAB7\work\OUTPUT\profile_distance_per_subject_original_CM.mat');
    end

    new_profile_distance_original_all = profile_distance_all; 

    [row_original unused] = size(new_profile_distance_original_all)
    final_matrix = new_profile_distance_original_all(1:(row_original/4),:)

    LAF_W = find(all_locations(2,:) == 6);
    S_UAF = find(all_locations(2,:) == 1);
    [unused col_LAF_W] = size(LAF_W)
    [unused col_S_UAF] = size(S_UAF)

    %% obtain profile for neutral
    for o = 1:2
        if o == 1
            final_matrix = final_matrix((col_S_UAF+2):(row_original/4-col_LAF_W-1),:);
            size(final_matrix)
        else
            %% 135
            matrix_135 = new_profile_distance_original_all((row_original/4+1):(2*row_original/4),:)
            matrix_135 = matrix_135((col_S_UAF+2):(row_original/4-col_LAF_W-1),:); 
            %% 90
            matrix_90 = new_profile_distance_original_all((2*row_original/4+1):(3*row_original/4),:)
            matrix_90 = matrix_90((col_S_UAF+2):(row_original/4-col_LAF_W-1),:); 
            %% max
            matrix_max = new_profile_distance_original_all((3*row_original/4+1):row_original,:)
            matrix_max = matrix_max((col_S_UAF+2):(row_original/4-col_LAF_W-1),:); 
            final_matrix = [matrix_135;matrix_90;matrix_max];
            size(final_matrix)    
        end

        % % %begin to process
        final_matrix = final_matrix';

        [row col]= size(final_matrix);
        covariance_matrix = zeros(col,col);
        for m_1=1:(col-1)
            matrix_1 = final_matrix(:,m_1);
            matrix_2 = final_matrix(:,m_1+1);
            covariance_matrix(m_1:m_1+1,m_1:m_1+1) = cov(matrix_1,matrix_2);
        end

        for i=1:(col-2)
            for j = (i+2):col
                matrix_1 = final_matrix(:,i);
                matrix_2 = final_matrix(:,j);
                delete_later = cov(matrix_1,matrix_2);
                delete_later_element = delete_later(1,2);
                clear delete_later
                covariance_matrix(i,j) = delete_later_element;
                covariance_matrix(j,i) = delete_later_element;
                clear delete_later_element
            end
        end

        [eigen_vectors,eigen_values]=eig(covariance_matrix);

        %% AUTOMATIC EIGEN VALUES DETERMINATION
        [row_eigen col_eigen] = size(eigen_vectors);

        eigen_values_total = 0;
        for m_2=1:col_eigen
            eigen_values_total = eigen_values_total+eigen_values(m_2,m_2);
        end

        temp_eigen_values_total = 0;
        number_of_eigen_values = 0;
        for m_3=col_eigen:-1:1
            temp_eigen_values_total = temp_eigen_values_total+eigen_values(m_3,m_3);
            ratio = temp_eigen_values_total/eigen_values_total;
            number_of_eigen_values = number_of_eigen_values+1;
            if ratio >= 0.95
                break
            end
        end

        eigen_vectors_used = zeros(row_eigen,number_of_eigen_values);
        size(eigen_vectors_used);
        n = 0;
        for m_4=1:number_of_eigen_values
            eigen_vectors_used(:,m_4) = eigen_vectors(:,col_eigen+(m_4-1)*n );
            n = -1;
        end    
   
        clear row_eigen col_eigen
        %% END OF AUTOMATIC EIGEN VALUES DETERMINATION

        final_matrix_adjusted = final_matrix;
        [row col]= size(final_matrix);
        mean_all = zeros(row,col);
        for m_5=1:col
            mean_all (:,m_5) = mean(final_matrix(:,m_5))*ones(row,1);
            final_matrix_adjusted(:,m_5) = final_matrix(:,m_5)-mean_all (:,m_5);
        end

        final_matrix_transformed = ((eigen_vectors_used)')*((final_matrix_adjusted)');              
        
        if o == 1
            PCA_profile_neu = final_matrix_transformed';
            PCA_profile_neu_eigen_vector = eigen_vectors_used;
            PCA_profile_neu_mean = mean_all (1,:);
            if k==1
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_AF','PCA_profile_neu')
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_AF','PCA_profile_neu_eigen_vector') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_AF','PCA_profile_neu_mean') 
            elseif k == 2
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_AM','PCA_profile_neu')
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_AM','PCA_profile_neu_eigen_vector') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_AM','PCA_profile_neu_mean') 
            elseif k == 3
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_CF','PCA_profile_neu') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_CF','PCA_profile_neu_eigen_vector') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_CF','PCA_profile_neu_mean') 
            else
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_CM','PCA_profile_neu') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_CM','PCA_profile_neu_eigen_vector') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_CM','PCA_profile_neu_mean') 
            end
        else
            PCA_profile = final_matrix_transformed';
            PCA_profile_eigen_vector = eigen_vectors_used;
            PCA_profile_mean = mean_all (1,:);
            if k==1
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_AF','PCA_profile') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_AF','PCA_profile_eigen_vector')
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_AF','PCA_profile_mean') 
            elseif k == 2
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_AM','PCA_profile') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_AM','PCA_profile_eigen_vector')
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_AM','PCA_profile_mean') 
            elseif k == 3
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_CF','PCA_profile') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_CF','PCA_profile_eigen_vector') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_CF','PCA_profile_mean') 
            else
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_CM','PCA_profile') 
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_CM','PCA_profile_eigen_vector')
                save('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_CM','PCA_profile_mean') 
            end
        end
    end
end
