function [Transform_toCS,Tranform_tooriginal] = CS_alignment(template_skeleton)

template_skeleton_mod = template_skeleton;

%bring X mod to X-Y plane*****************************************
cross_product = cross([template_skeleton_mod(1,1) 0 template_skeleton_mod(1,3)],[1 0 0 ]);
template_xzlength = (template_skeleton_mod(1,1)^2 + template_skeleton_mod(1,3)^2)^0.5;
dot_product = dot([template_skeleton_mod(1,1) 0 template_skeleton_mod(1,3)],[1 0 0 ])/(template_xzlength);

if cross_product(1,2)> 0
    Y_rotation = [cos(acos(dot_product))  0  -sin(acos(dot_product))   0;0      1    0      0;sin(acos(dot_product))  0  cos(acos(dot_product))    0;0      0    0     1];   
else
    Y_rotation = [cos(-acos(dot_product)) 0  -sin(-acos(dot_product)) 0;0      1    0      0;sin(-acos(dot_product))  0  cos(-acos(dot_product))    0;0      0    0     1];
end

template_skeleton_mod = cat(2,template_skeleton_mod,ones(3,1))*Y_rotation;

%aligning X mod to X axis******************************************
cross_product = cross([template_skeleton_mod(1,1) template_skeleton_mod(1,2) 0],[1 0 0 ]);
template_xylength = (template_skeleton_mod(1,1)^2 + template_skeleton_mod(1,2)^2)^0.5;
dot_product = dot([template_skeleton_mod(1,1) template_skeleton_mod(1,2) 0 ],[1 0 0 ])/(template_xylength);

if cross_product(1,3)> 0
    Z_rotation = [cos(acos(dot_product))  sin(acos(dot_product))  0  0;-sin(acos(dot_product))  cos(acos(dot_product))  0  0; 0        0    1  0; 0        0    0  1];
else
    Z_rotation = [cos(-acos(dot_product))  sin(-acos(dot_product))  0  0;-sin(-acos(dot_product))  cos(-acos(dot_product))  0  0; 0        0    1  0; 0        0    0  1];
end

template_skeleton_mod = template_skeleton_mod*Z_rotation;

%%aligning Y mod and Z mod to X and Z axis***************************
cross_product = cross([0 template_skeleton_mod(3,2) template_skeleton_mod(3,3)],[0 0 1]);
template_xylength = (template_skeleton_mod(3,2)^2 + template_skeleton_mod(3,3)^2)^0.5;
dot_product = dot([0 template_skeleton_mod(3,2) template_skeleton_mod(3,3)],[0 0 1])/(template_xylength);

if cross_product(1,1)> 0
    X_rotation = [1  0  0  0;0  cos(acos(dot_product))  sin(acos(dot_product))  0;0 -sin(acos(dot_product))  cos(acos(dot_product)) 0;0  0  0  1];
else
    X_rotation = [1  0  0  0;0  cos(-acos(dot_product))  sin(-acos(dot_product))  0;0 -sin(-acos(dot_product))  cos(-acos(dot_product)) 0;0  0  0  1];
end

template_skeleton_mod = template_skeleton_mod*X_rotation;

Transform_toCS = Y_rotation*Z_rotation*X_rotation;
Transform_toCS = Transform_toCS(1:3,1:3);
Tranform_tooriginal = inv(Z_rotation)*inv(Y_rotation)*inv(X_rotation);
Tranform_tooriginal = Tranform_tooriginal(1:3,1:3);