function [profile_in,profile_out,lower_point] = WRL_profile_front(coordinates,index_height)


profile_out = zeros(max(index_height),3);

for i = min(index_height):max(index_height)
    list = find(index_height == i);
    [row col] = size(list);
    coordinates_list = zeros(row,3);
    for j = 1:row
        coordinates_list(j,:) = coordinates(list(j,1),:);
    end
    [val index_min] = min(coordinates_list(:,1));
    profile_in(i,1:3) = [coordinates_list(index_min,1) coordinates_list(index_min,2) 0];
    
    [val index_max] = max(coordinates_list(:,1));
    profile_out(i,1:3) = [coordinates_list(index_max,1) coordinates_list(index_max,2) 0];
end

list = find(profile_in(:,2)>0);
[row col] = size(list);
limit_angle = 160*(pi/180);
lower_point_found = 0;
for i=1:(row-2)
    v_1 = profile_in(list(i+2,:),1:2) - profile_in(list(i+1,:),1:2);
    v_1 = v_1/((dot(v_1,v_1))^0.5);
    v_2 = profile_in(list(i,:),1:2) - profile_in(list(i+1,:),1:2);
    v_2 = v_2/((dot(v_2,v_2))^0.5);
    angle = abs(acos(dot(v_1,v_2)));
    if angle < limit_angle
       lower_point = profile_in(list(i,:),:);
       new_list = list(i+1:row,1);
       lower_point_found = 1;
    break
    end
end

if lower_point_found == 0
    lower_point = profile_in(list(1,:),:);
    new_list = list(1+1:row,1);
end




