function [UAF_distance_neutral,LAF_distance_neutral,UAM_distance_neutral,LAM_distance_neutral,race] = flesh_deformation_area_version_2(profile_left, profile_right,input_skeleton,length_UA_LA)

%% USING ARM LENGTH AND BMI

'Instruction: 1. Asian Male; 2. Asian Female; 3. Caucasian Male; 4. Caucasian Female'
val = input ('Enter the appropriate value for the corresponding subject: '); 
BMI = input ('Enter the BMI value for the corresponding subject: '); 

if val <= 2
   race = 0;
else
   race = 1;
end

load ('C:\MATLAB7\work\INITIAL INPUT\race_gender_table.mat');
UAF_distance_neutral = race_gender_table(val,1)*length_UA_LA(1,1) + race_gender_table(val,2)*BMI + race_gender_table(val,3);
ratio_UAF_distance_neutral = UAF_distance_neutral/length_UA_LA(1,1);
if ratio_UAF_distance_neutral>0.47
    UAF_distance_neutral = length_UA_LA(1,1)*0.47;
end

LAF_distance_neutral = UAF_distance_neutral/(race_gender_table(val,4));
UAF_distance_max = UAF_distance_neutral + race_gender_table(val,5)*length_UA_LA(1,1) + race_gender_table(val,6)*BMI + race_gender_table(val,7);

LAF_distance_max = UAF_distance_max/(race_gender_table(val,8));

arm_angle = acos(dot((input_skeleton(1,:)/length_UA_LA(1,:)),(input_skeleton(3,:)/length_UA_LA(2,:))))*180/pi;

UAM_coef = [race_gender_table(val,9) race_gender_table(val,10) race_gender_table(val,11)];
LAM_coef = [race_gender_table(val,12) race_gender_table(val,13) race_gender_table(val,14)];
UAM_distance_neutral = polyval(UAM_coef,arm_angle)*UAF_distance_neutral;
LAM_distance_neutral = polyval(LAM_coef,arm_angle)*LAF_distance_neutral;

normal_plane = cross((input_skeleton(1,:)/length_UA_LA(1,:)),[0 0 1]);
max_carrying_angle = asin(dot(normal_plane,input_skeleton(3,:))/(dot(normal_plane,normal_plane)^0.5*length_UA_LA(2,:)))*180/pi

female_carrying_angle = [11.9 9.1 -0.7 4.6];
male_carrying_angle = [4.2 10.9 -1.1 5.8];

if val == 1 | val == 3 %% Male
    ratio = abs((max_carrying_angle - male_carrying_angle(1,1))/(male_carrying_angle(1,2)));
    min_carrying_angle = ratio*male_carrying_angle(1,4) + male_carrying_angle(1,3)
else %% Female
    ratio = abs((max_carrying_angle - female_carrying_angle(1,1))/(female_carrying_angle(1,2)));
    min_carrying_angle = ratio*female_carrying_angle(1,4) + female_carrying_angle(1,3)
end

carrying_angle = [min_carrying_angle max_carrying_angle];
save('C:\MATLAB7\work\OUTPUT\CS_distance.mat','UAF_distance_neutral','LAF_distance_neutral','UAM_distance_neutral','LAM_distance_neutral','UAF_distance_max','LAF_distance_max','UAM_coef','LAM_coef','carrying_angle','arm_angle');
save('C:\MATLAB7\work\OUTPUT\BMI.mat','BMI');

if val == 1
    gender = 1;
elseif val == 2
    gender = 0;
elseif val == 3
    gender = 1;
else
    gender = 0;
end
save('C:\MATLAB7\work\OUTPUT\gender.mat','gender')





