function [min_index,max_index,vertices_partial] = partial_retrieve(vertices,coordinates)

%% the area for possible elbow sampling is 1/4 of the upper arm
upper_limit = 1/4*max(coordinates(:,2));
lower_limit = -upper_limit;

%% finding the coordinates for possible elbow sampling (between 1/4 of
%% upper arm and 1/4 of lower arm, elbow as the center)
coordinates_index = [find(0 <= coordinates(:,2) & coordinates(:,2)<=upper_limit);find(lower_limit <= coordinates(:,2) & coordinates(:,2)<=0)];
max_index = max(coordinates_index);
min_index = min(coordinates_index);

%% retrieving the vertices which contain all of the coordinates above
min_indexv = min(find(vertices(:,1) >= min_index & vertices(:,2) >= min_index & vertices(:,3) >= min_index));
max_indexv = max(find(vertices(:,1) <= max_index & vertices(:,2) <= max_index & vertices(:,3) <= max_index));
vertices_partial = vertices(min_indexv:max_indexv,:);





