function [vector] = spline_flat_line(points)

[rowid col] = size(points);

for i=1:(9-2)
    v_1 = points(i+1,:)-points(i,:);
    v_2 = points(i+2,:)-points(i+1,:);
    v_1 = v_1/(dot(v_1,v_1)^0.5);
    v_2 = v_2/(dot(v_2,v_2)^0.5);
    angle(i,:) = acos(dot(v_1,v_2))*180/pi;
end

[val index] = min(angle);
coord = points(index+1,:);
v_2 = points(index+2,:)- points(index+1,:);
v_2 = v_2/(dot(v_2,v_2)^0.5);
x = v_2(1,1)*cos(pi/2) - v_2(1,3)*sin(pi/2);
z = v_2(1,3)*cos(pi/2) + v_2(1,1)*sin(pi/2);
vector = [x 0 z];


