function [col_closest_subject,closest_subject,LAF_neu,LAM_neu,LAF_neu_max_dimension, LAM_neu_max_dimension] = LAM_closest_subject(LAM_dist,LAF_dist,race,gender)

%% 1. reconstruct the cross sections (LAF and LAM)
load ('C:\MATLAB7\work\INITIAL INPUT\sub_unit_vector.mat');

for n=1:16
    LAM_neu(n,1:3) = LAM_dist(n,1)*unit_vector_for_subfunction(n,:);
end

for n=1:16
    LAF_neu(n,1:3) = LAF_dist(n,1)*unit_vector_for_subfunction(n,:); 
end

%% 2. open LAF LAM ratio
if race == 0
   if gender == 0
       load ('C:\MATLAB7\work\INITIAL INPUT\LAF_LAM_ratio_asian_female.mat')
   else
       load ('C:\MATLAB7\work\INITIAL INPUT\LAF_LAM_ratio_asian_male.mat')
   end
else
   if gender == 0
       load ('C:\MATLAB7\work\INITIAL INPUT\LAF_LAM_ratio_caucasian_female.mat')
   else
       load ('C:\MATLAB7\work\INITIAL INPUT\LAF_LAM_ratio_caucasian_male.mat')
   end
end

%% 3. determine LAF LAM ratio of the reconstructed cross sections
interpolated_P = [LAF_neu;LAF_neu(1,:)];
[control_points,knots,t_parameter]=bspline_interpolation(interpolated_P);
[spline_LAF] = drawing_bspline_3D(knots,control_points);
interpolated_P = [LAM_neu;LAM_neu(1,:)];
[control_points,knots,t_parameter]=bspline_interpolation(interpolated_P);
[spline_LAM] = drawing_bspline_3D(knots,control_points);

LAF_LAM_ratio_neu_x = (max(spline_LAF(:,1))-min(spline_LAF(:,1)))/(max(spline_LAM(:,1))-min(spline_LAM(:,1)));
LAF_neu_x_1 = max(spline_LAF(:,1));
LAF_neu_x_2 = min(spline_LAF(:,1));
LAM_neu_x_1 = max(spline_LAM(:,1));
LAM_neu_x_2 = min(spline_LAM(:,1));
LAF_LAM_ratio_neu_y = (max(spline_LAF(:,2))-min(spline_LAF(:,2)))/(max(spline_LAM(:,2))-min(spline_LAM(:,2)));
LAF_neu_y_1 = max(spline_LAF(:,2));
LAF_neu_y_2 = min(spline_LAF(:,2));
LAM_neu_y_1 = max(spline_LAM(:,2));
LAM_neu_y_2 = min(spline_LAM(:,2));
LAF_neu_max_dimension = [LAF_neu_x_1; LAF_neu_x_2; LAF_neu_y_1; LAF_neu_y_2];
LAM_neu_max_dimension = [LAM_neu_x_1; LAM_neu_x_2; LAM_neu_y_1; LAM_neu_y_2];

[row_LAF_LAM_ratio col] = size(LAF_LAM_ratio);

for i=1:col
   vector = [LAF_LAM_ratio_neu_x LAF_LAM_ratio_neu_y]-(LAF_LAM_ratio(:,i)');
   val = (dot(vector,vector))^0.5;
   val_all(i,1) = val
   if i == 1
      val_min = val;
      closest_subject = 1;
   else
      if val<val_min
         val_min = val;
         closest_subject = i;
      end
   end   
end
col_closest_subject = 1;


