function [col_closest_subject,closest_subject,UAF_neu,UAM_neu,UAF_neu_max_dimension, UAM_neu_max_dimension] = UAM_closest_subject(UAM_dist,UAF_dist,race,gender)

%% 1. reconstruct the cross sections (UAF and UAM)
load ('C:\MATLAB7\work\INITIAL INPUT\sub_unit_vector.mat');

for n=1:16
    UAM_neu(n,1:3) = UAM_dist(n,1)*unit_vector_for_subfunction(n,:);
end

for n=1:16
    UAF_neu(n,1:3) = UAF_dist(n,1)*unit_vector_for_subfunction(n,:); 
end

%% 2. open UAF UAM ratio
if race == 0
   if gender == 0
       load ('C:\MATLAB7\work\INITIAL INPUT\UAF_UAM_ratio_asian_female.mat');
   else
       load ('C:\MATLAB7\work\INITIAL INPUT\UAF_UAM_ratio_asian_male.mat');
   end
else
   if gender == 0
       load ('C:\MATLAB7\work\INITIAL INPUT\UAF_UAM_ratio_caucasian_female.mat');
   else
       load ('C:\MATLAB7\work\INITIAL INPUT\UAF_UAM_ratio_caucasian_male.mat');
   end
end

%% 3. determine UAF UAM ratio of the reconstructed cross sections
interpolated_P = [UAF_neu;UAF_neu(1,:)];
[control_points,knots,t_parameter]=bspline_interpolation(interpolated_P);
[spline_UAF] = drawing_bspline_3D(knots,control_points);
interpolated_P = [UAM_neu;UAM_neu(1,:)];
[control_points,knots,t_parameter]=bspline_interpolation(interpolated_P);
[spline_UAM] = drawing_bspline_3D(knots,control_points);

UAF_UAM_ratio_neu_x = (max(spline_UAF(:,1))-min(spline_UAF(:,1)))/(max(spline_UAM(:,1))-min(spline_UAM(:,1)));
UAF_neu_x_1 = max(spline_UAF(:,1));
UAF_neu_x_2 = min(spline_UAF(:,1));
UAM_neu_x_1 = max(spline_UAM(:,1));
UAM_neu_x_2 = min(spline_UAM(:,1));
UAF_UAM_ratio_neu_y = (max(spline_UAF(:,2))-min(spline_UAF(:,2)))/(max(spline_UAM(:,2))-min(spline_UAM(:,2)));
UAF_neu_y_1 = max(spline_UAF(:,2));
UAF_neu_y_2 = min(spline_UAF(:,2));
UAM_neu_y_1 = max(spline_UAM(:,2));
UAM_neu_y_2 = min(spline_UAM(:,2));
UAF_neu_max_dimension = [UAF_neu_x_1; UAF_neu_x_2; UAF_neu_y_1; UAF_neu_y_2];
UAM_neu_max_dimension = [UAM_neu_x_1; UAM_neu_x_2; UAM_neu_y_1; UAM_neu_y_2];

[row_UAF_UAM_ratio col] = size(UAF_UAM_ratio);
for i=1:col
   vector = [UAF_UAM_ratio_neu_x UAF_UAM_ratio_neu_y]-(UAF_UAM_ratio(:,i)');
   val = (dot(vector,vector))^0.5;
   val_all(i,1) = val;
   if i == 1
      val_min = val;
      closest_subject = 1;
   else
      if val<val_min
         val_min = val;
         closest_subject = i;
      end
   end   
end
col_closest_subject = 1;



