function [UAF_new_points,optimum_angle] = aligning_CS_LAF(UAF_new_points,UAF_max_point,UAF_min_point)

[row col] = size(UAF_new_points);
UAF_new_points = [UAF_new_points(:,1) zeros(32,1) UAF_new_points(:,2)];
major_axis = UAF_max_point(:,1)-UAF_min_point(:,1);
minor_axis = UAF_max_point(:,3)-UAF_min_point(:,3);

count = 0;
for  i=(-0.25*pi):(0.1*pi/180):(0.25*pi)
    for j=1:32
        Y_rotation = [cos(i)  0  -sin(i);0      1    0;sin(i)  0  cos(i)];           
        list_new_UAF(j,1:3) = UAF_new_points(j,:)*Y_rotation;
    end
    [list_new_UAF,UAF_center_point,UAF_max_point,UAF_min_point] = cross_section_centered(list_new_UAF);
    major_axis = UAF_max_point(:,1)-UAF_min_point(:,1);
    minor_axis = UAF_max_point(:,3)-UAF_min_point(:,3);
    for k=1:32
        A = major_axis;  
        B = minor_axis; 
        x = 0;
        y = 0;
        line_vector = list_new_UAF(k,:)/(dot(list_new_UAF(k,:),list_new_UAF(k,:))^0.5);
        a = line_vector(1,1);
        b = line_vector(1,3);
        coef_1 = (B^2)*(a^2) + (A^2)*(b^2);
        coef_2 = 2*(B^2)*x*a + 2*(A^2)*y*b;
        coef_3 = -(A^2)*(B^2) + (B^2)*(x^2) + (A^2)*(y^2);
        t = roots([coef_1 coef_2 coef_3]);
        ellipse_points = max(t)*line_vector;
        list_ellipse_points(k,1:3) = ellipse_points;     
    end
    %% scaling down the ellipse
    scaled_ellipse = major_axis/(max(list_ellipse_points(:,1))-min(list_ellipse_points(:,1)));
    list_ellipse_points=list_ellipse_points*scaled_ellipse;
    for l=1:32
        length_UAF_new_points = dot(list_new_UAF(l,:),list_new_UAF(l,:))^0.5;
        length_ellipse_points = dot(list_ellipse_points(l,:),list_ellipse_points(l,:))^0.5;
        error(l,1) = abs(length_UAF_new_points-length_ellipse_points);
    end
    count = count+1;
    list_error(count,1:4) = [sum(error) i major_axis minor_axis];
    error(k,1) = abs(length_UAF_new_points-length_ellipse_points);
end

[val index]=min(list_error(:,1));
optimum_angle = list_error(index,2);
for j=1:32
        Y_rotation = [cos(optimum_angle)  0  -sin(optimum_angle);0      1    0;sin(optimum_angle)  0  cos(optimum_angle)];           
        UAF_new_points(j,:) = UAF_new_points(j,:)*Y_rotation;
end
[UAF_new_points,UAF_center_point,UAF_max_point,UAF_min_point] = cross_section_centered(UAF_new_points);
[UAF_new_points] = resample_cross_secs_16([UAF_new_points(:,1) UAF_new_points(:,3)]);


