function [UAF_3D,UAM_3D,E_3D,LAM_3D,LAF_3D,new_UAF_CS,LAF_CS_all,E_CS_all] = creating_3D_all_postures(distances_135,distances_90,distances_max,UAF,UAM,E,LAM,LAF)

load ('C:\MATLAB7\work\OUTPUT\CS_distance.mat')
load ('C:\MATLAB7\work\OUTPUT\CS.mat')

UAF_distance_135 = distances_135(1,1);
UAM_distance_135 = distances_135(2,1);
LAM_distance_135 = distances_135(3,1);
LAF_distance_135 = distances_135(4,1);
UAF_distance_90 = distances_90(1,1);
UAM_distance_90 = distances_90(2,1);
LAM_distance_90 = distances_90(3,1);
LAF_distance_90 = distances_90(4,1);
UAM_distance_max = distances_max(1,1);
LAM_distance_max = distances_max(2,1);

[UAF_3D] = Cross_sec_2D_to_3D(UAF,UAF_CS,[UAF_distance_neutral UAF_distance_135 UAF_distance_90 UAF_distance_max]);
[UAM_3D] = Cross_sec_2D_to_3D(UAM,UAF_CS,[UAM_distance_neutral UAM_distance_135 UAM_distance_90 UAM_distance_max]);

%% For LAM and LAF, the following procedure has to be done.
%% 1. Create new_UAF_CS to transform back the local LAF of other key postures to the world CS
%%    (UAF_CS can't be used because the carrying angle is
%%    measured with the plane created from [0 0 1] and UAF_CS(2,:).
%%    new UAF_CS (steps):
%%    1. normal vector of the plane created between (UAF_CS(2,:) and [0 0 1 ]
%%    2. normal vector is the new X part of UAF_CS
%%    3. calculate the last vector (Z part)
%% 2. determine carrying angle and flexion angle for all postures
%% 3. create the matrix for euler rotation and rotate [0 -1 0].then
%%    transform to the world CS. 
%% 4. create local CS for other key postures and use them to change 2D to
%%    3D
%% 5. use other ket posture local CS to create new local CS for E and use
%%    them to change 2D to 3D

%% part 1
new_X = cross(UAF_CS(2,:),[0 0 1]);
new_X = new_X/(dot(new_X,new_X)^0.5);
new_Z = cross(new_X,UAF_CS(2,:));
new_Z = new_Z/(dot(new_Z,new_Z)^0.5);
new_UAF_CS = [new_X;UAF_CS(2,:);new_Z];

%% part 2
[carrying_angle_135,flexion_angle_135] = calculate_carrying_and_flexion(carrying_angle,arm_angle,135);
[carrying_angle_90,flexion_angle_90] = calculate_carrying_and_flexion(carrying_angle,arm_angle,90);
[carrying_angle_max,flexion_angle_max] = calculate_carrying_and_flexion(carrying_angle,arm_angle,35);

%% part 3
[euler_matrix] = create_euler_matrix(flexion_angle_135,carrying_angle_135,0);
new_vector_LA_135 = [0 -1 0]*euler_matrix*new_UAF_CS;
[euler_matrix] = create_euler_matrix(flexion_angle_90,carrying_angle_90,0);
new_vector_LA_90 = [0 -1 0]*euler_matrix*new_UAF_CS;
[euler_matrix] = create_euler_matrix(flexion_angle_max,carrying_angle_max,0);
new_vector_LA_max = [0 -1 0]*euler_matrix*new_UAF_CS;

%% part 4
[LAF_CS_all]= local_CS_other_key_postures ([new_vector_LA_135;new_vector_LA_90;new_vector_LA_max]);

[LAM_3D_neutral] = Cross_sec_2D_to_3D(LAM(:,1:3),LAF_CS,LAM_distance_neutral);
[LAM_3D_135] = Cross_sec_2D_to_3D(LAM(:,4:6),LAF_CS_all(1:3,:),LAM_distance_135);
[LAM_3D_90] = Cross_sec_2D_to_3D(LAM(:,7:9),LAF_CS_all(4:6,:),LAM_distance_90);
[LAM_3D_max] = Cross_sec_2D_to_3D(LAM(:,10:12),LAF_CS_all(7:9,:),LAM_distance_max);

[LAF_3D_neutral] = Cross_sec_2D_to_3D(LAF(:,1:3),LAF_CS,LAF_distance_neutral);
[LAF_3D_135] = Cross_sec_2D_to_3D(LAF(:,4:6),LAF_CS_all(1:3,:),LAF_distance_135);
[LAF_3D_90] = Cross_sec_2D_to_3D(LAF(:,7:9),LAF_CS_all(4:6,:),LAF_distance_90);
[LAF_3D_max] = Cross_sec_2D_to_3D(LAF(:,10:12),LAF_CS_all(7:9,:),LAF_distance_max);

LAM_3D = [LAM_3D_neutral LAM_3D_135 LAM_3D_90 LAM_3D_max];
LAF_3D = [LAF_3D_neutral LAF_3D_135 LAF_3D_90 LAF_3D_max];  

%% part 5
[E_CS_all] = determine_E_CS_for_any_posture(UAF_CS(2,:),[new_vector_LA_135;new_vector_LA_90;new_vector_LA_max]);
[E_3D_neutral] = Cross_sec_2D_to_3D(E(:,1:3),E_CS,0);
[E_3D_135] = Cross_sec_2D_to_3D(E(:,4:6),E_CS_all(1:3,:),0);
[E_3D_90] = Cross_sec_2D_to_3D(E(:,7:9),E_CS_all(4:6,:),0);
[E_3D_max] = Cross_sec_2D_to_3D(E(:,10:12),E_CS_all(7:9,:),0);

E_3D = [E_3D_neutral E_3D_135 E_3D_90 E_3D_max];


