clear all

load ('C:\MATLAB7\work\OUTPUT\CS_points.mat')
load ('C:\MATLAB7\work\OUTPUT\race.mat')
load ('C:\MATLAB7\work\OUTPUT\gender.mat')

%% _________________ coord: [x 0 z] _______________________________________
%% find the center for each cross section and translate the cross section.
[UAF_points,UAF_center_point,UAF_max_point,UAF_min_point] = cross_section_centered(UAF_points);
[UAM_points,UAM_center_point,UAM_max_point,UAM_min_point] = cross_section_centered(UAM_points);
[E_points,E_center_point,E_max_point,E_min_point] = cross_section_centered(E_points);
[LAM_points,LAM_center_point,LAM_max_point,LAM_min_point] = cross_section_centered(LAM_points);
[LAF_points,LAF_center_point,LAF_max_point,LAF_min_point] = cross_section_centered(LAF_points);

% % _________________ coord: [-x z 0] ______________________________________
% % resample the points (same E_rays i.e. rotating z axis,started from 0
% % degree)
% % reason for this:[-UAF_points(:,1) UAF_points(:,3)]--> to match with
% % template orientation!!!

[UAF_new_points] = resample_cross_secs_16([-UAF_points(:,1) UAF_points(:,3)]);
[UAM_new_points] = resample_cross_secs_16([-UAM_points(:,1) UAM_points(:,3)]);
[E_new_points] = resample_cross_secs_16([-E_points(:,1) E_points(:,3)]);
[LAM_new_points] = resample_cross_secs_32([-LAM_points(:,1) LAM_points(:,3)]);
[LAF_new_points] = resample_cross_secs_32([-LAF_points(:,1) LAF_points(:,3)]);

[LAM_new_points_aligned,optimum_angle_LAM] = aligning_CS_LAF(LAM_new_points,LAM_max_point,LAM_min_point);
[LAF_new_points_aligned,optimum_angle_LAF] = aligning_CS_LAF(LAF_new_points,LAF_max_point,LAF_min_point);
 
LAM_aligned =[LAM_new_points_aligned(:,1)  LAM_new_points_aligned(:,2) zeros(16,1)]
LAF_aligned =[LAF_new_points_aligned(:,1)  LAF_new_points_aligned(:,2) zeros(16,1)]

[UAF_points_lengths] = cross_secs_points_length(UAF_new_points);
[UAM_points_lengths] = cross_secs_points_length(UAM_new_points);
[E_points_lengths] = cross_secs_points_length(E_new_points);
[LAM_points_lengths] = cross_secs_points_length(LAM_new_points_aligned);
[LAF_points_lengths] = cross_secs_points_length(LAF_new_points_aligned);

[UAF,UAM,E,LAM,LAF] = PCA_prediction_version_2(UAF_points_lengths,UAM_points_lengths,E_points_lengths,LAM_points_lengths,LAF_points_lengths,race,gender,optimum_angle_LAF);

for i = 1
    for j=1:16
        Y_rotation = [cos(-optimum_angle_LAM)  0  -sin(-optimum_angle_LAM);0      1    0;sin(-optimum_angle_LAM)  0  cos(-optimum_angle_LAM)];           
        output = [LAM(j,(3*i-2)) LAM(j,(3*i)) LAM(j,(3*i-1)) ]*Y_rotation;
        LAM(j,(3*i-2):3*i) = [output(1,1) output(1,3) output(1,2)];
    end
end

for i = 1
    for j=1:16
        Y_rotation = [cos(-optimum_angle_LAF)  0  -sin(-optimum_angle_LAF);0      1    0;sin(-optimum_angle_LAF)  0  cos(-optimum_angle_LAF)];           
        output = [LAF(j,(3*i-2)) LAF(j,(3*i)) LAF(j,(3*i-1)) ]*Y_rotation;
        LAF(j,(3*i-2):3*i) = [output(1,1) output(1,3) output(1,2)];
    end
end

% % % add CS 2D of the neutral posture
[UAM_new_points] = resample_cross_secs_16([-UAM_points(:,1) UAM_points(:,3)]);
[LAM_new_points] = resample_cross_secs_16([-LAM_points(:,1) LAM_points(:,3)]);
[LAF_new_points] = resample_cross_secs_16([-LAF_points(:,1) LAF_points(:,3)]);

UAF = [UAF_new_points zeros(16,1) UAF];
UAM = [UAM_new_points zeros(16,1) UAM];
E = [E_new_points zeros(16,1) E];
LAM = [LAM_new_points zeros(16,1) LAM];
LAF = [LAF_new_points zeros(16,1) LAF];

% % _________________ coord: [x z 0] _______________________________________
% % translate the group CS above so that CS groups centered at the bones.
% Altering the sign of x back to positive for all points.
[UAF] = translating_cross_secs_group_points([UAF_center_point(1,1) UAF_center_point(1,3) UAF_center_point(1,2)],UAF);
[UAM] = translating_cross_secs_group_points([UAM_center_point(1,1) UAM_center_point(1,3) UAM_center_point(1,2)],UAM);
[E] = translating_cross_secs_group_points([E_center_point(1,1) E_center_point(1,3) E_center_point(1,2)],E);
[LAM] = translating_cross_secs_group_points([LAM_center_point(1,1) LAM_center_point(1,3) LAM_center_point(1,2)],LAM);
[LAF] = translating_cross_secs_group_points([LAF_center_point(1,1) LAF_center_point(1,3) LAF_center_point(1,2)],LAF);

% _________________ coord: [x 0 z] _______________________________________
% final resampling. Has to be done because the previous coords are sampled
% from the CS center points instead of CS bones.

[UAF]=resample_cross_secs_group(UAF);
[UAM]=resample_cross_secs_group(UAM);
[E]= resample_cross_secs_group(E);
[LAM]= resample_cross_secs_group(LAM);
[LAF]= resample_cross_secs_group(LAF);

% _________determine Cross Section distance of other key postures ________
[distances_135,distances_90,distances_max] = calculate_distance_other_key_postures;

% _________________bring Cross Section into 3D world _____________________
[UAF_3D,UAM_3D,E_3D,LAM_3D,LAF_3D,new_UAF_CS,LAF_CS_all,E_CS_all] = creating_3D_all_postures(distances_135,distances_90,distances_max,UAF,UAM,E,LAM,LAF);

save('C:\MATLAB7\work\OUTPUT\UAF_3D.mat','UAF_3D')
save('C:\MATLAB7\work\OUTPUT\UAM_3D.mat','UAM_3D')
save('C:\MATLAB7\work\OUTPUT\E_3D.mat','E_3D')
save('C:\MATLAB7\work\OUTPUT\LAM_3D.mat','LAF_3D')
save('C:\MATLAB7\work\OUTPUT\LAF_3D.mat','LAM_3D')
save('C:\MATLAB7\work\OUTPUT\new_UAF_CS.mat','new_UAF_CS')
save('C:\MATLAB7\work\OUTPUT\LAF_CS_all.mat','LAF_CS_all')
save('C:\MATLAB7\work\OUTPUT\E_CS_all.mat','E_CS_all')

 
