function [new_points] = resample_cross_secs_group(UAF_points)

UAF_points = [UAF_points;UAF_points(1,:)]; %% to make a full circle for the cross section
[row col] = size(UAF_points);

count = 0;
for i=1:3:col
    count = count+1;
    [control_points,knots,t_parameter]=bspline_interpolation([UAF_points(:,i) UAF_points(:,i+1)]);
    [ext_knots,bezier_control_points] = knot_insertion(knots,control_points);
    bezier_control_points_all(:,(2*count-1):(2*count)) = bezier_control_points;
end

clear bezier_control_points;

vector = [0 1 0];
original_point = [0 0];
for i=1:16
    [sampling_vector] = rotation_about_Z_axis(vector,-(2*pi/16)*(i-1));
    for j = 1:4
        [intersection,sub_bezier_with_int] = bezier_line_intersection(bezier_control_points_all(:,(2*j-1):(2*j)),sampling_vector(1,1:2));
        new_points(i,(3*j-2):(3*j))= [intersection(1,1) 0 intersection(1,2)];
    end
end