
clear all

%% 1. Calculate the CS for each key posture
[new_UAF_CS,LAF_CS_all,E_CS_all] = calculate_arm_CS;
load('C:\MATLAB7\work\OUTPUT\CS.mat')

%% 2. Locations of the cross sections for neutral posture
load('C:\MATLAB7\work\OUTPUT\CS_distance.mat')

%% 3. Establishing joint length and arm vector for neutral posture
load('C:\MATLAB7\work\OUTPUT\skeleton_length.mat')
S = UAF_CS(2,:)*length_UA_LA(1,:);;
W = LAF_CS(2,:)*length_UA_LA(2,:);
joint_length_neu = [length_UA_LA(1,:) length_UA_LA(1,:)*2/3 length_UA_LA(1,:)*1/3      0   length_UA_LA(2,:)*1/3 length_UA_LA(2,:)*2/3 length_UA_LA(2,:)];
arm_vector = [S W];

%% 3. Calculating sampled points of the profile for the neutral posture 
load('C:\MATLAB7\work\OUTPUT\profile.mat')
load('C:\MATLAB7\work\OUTPUT\all_locations.mat');

LAF_W = find(all_locations(2,:) == 6); 
S_UAF = find(all_locations(2,:) == 1); 
[unused col_LAF_W] = size(LAF_W); 
[unused col_S_UAF] = size(S_UAF); 

[sampling_all]= vector_prev_segment(joint_length_neu,arm_vector,all_locations);
bezier = bspline_to_bezier(profile_right(:,2:3));
sampled_points = multiple_sampling_new_version(bezier,sampling_all);

%% 4. Calculating distances from WRL file
[row_sampled unused] = size(sampled_points) 
distance_vector = sampled_points-sampling_all(:,1:2);  
for n=1:row_sampled  
    WRL_distance(n,1) = ((dot(distance_vector(n,:),distance_vector(n,:)))^0.5);  
end   

WRL_distance = WRL_distance((col_S_UAF+2):(row_sampled-col_LAF_W-1),:) ; 
[row_sampled_WRL unused] = size(WRL_distance) ;

%% 5.  Calculating PCA of WRL file
load ('C:\MATLAB7\work\OUTPUT\race.mat')
load ('C:\MATLAB7\work\OUTPUT\gender.mat')
if race == 0
    if gender == 0
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_AF') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_AF')  
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_AF') 
    else        
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_AM') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_AM') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_AM')
    end
else
    if gender == 0
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_CF')
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_CF')  
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_CF')
    else
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_CM')
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_eigen_vector_CM')  
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_neu_mean_CM')
    end
end

distance_magnitude = WRL_distance'; 

for i=1:row_sampled_WRL 
    distance_magnitude_adjusted(1,i) = distance_magnitude(:,i)-PCA_profile_neu_mean(:,i);    
end 

PCA_value = ((PCA_profile_neu_eigen_vector)')*((distance_magnitude_adjusted)');
 
%% 6. KNN for the establised PCA value
[row_PCA_database col] = size(PCA_profile_neu);
load ('C:\MATLAB7\work\OUTPUT\BMI.mat')

if race == 0
    if gender == 0
        all_subjects_BMI = xlsread('C:\MATLAB7\work\INITIAL INPUT\BMI_AF.xlsx');
    else
        all_subjects_BMI = xlsread('C:\MATLAB7\work\INITIAL INPUT\BMI_AM.xlsx');
    end
else
    if gender == 0
        all_subjects_BMI = xlsread('C:\MATLAB7\work\INITIAL INPUT\BMI_CF.xlsx');
    else
        all_subjects_BMI = xlsread('C:\MATLAB7\work\INITIAL INPUT\BMI_CM.xlsx');
    end
end

for i=1:row_PCA_database
   vector = PCA_profile_neu(i,:)-PCA_value';
   val = (dot(vector,vector))^0.5+ abs(all_subjects_BMI(i,1)-BMI);
   val_all(i,1) = [val];
   if i == 1
      val_min = val;
      closest_subject = i;
   else
      if val<val_min
         val_min = val;
         closest_subject = i;
      end
   end   
end

%% 8. Modify distance of the template and sampled points to capture 2/3 of
%% UA and 2/3 of LA
reduced_sampled_points = sampled_points((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);  
sampled_points = reduced_sampled_points;  
reduced_sampling_all = sampling_all((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);  
sampling_all = reduced_sampling_all;  
[row_reduced_sampled unused] = size(sampled_points) ; 
profile_distances_neu = WRL_distance;

%% 9. Establishing joint length and arm vector for other key posture
[distances_135,distances_90,distances_max] = calculate_distance_other_key_postures;

%% *** 135
S = UAF_CS(2,:)*length_UA_LA(1,:);
W = LAF_CS_all(2,:)*length_UA_LA(2,:);
joint_length_135 = [length_UA_LA(1,:) length_UA_LA(1,:)*2/3 length_UA_LA(1,:)*1/3      0   length_UA_LA(2,:)*1/3 length_UA_LA(2,:)*2/3 length_UA_LA(2,:)];
arm_vector_135 = [S W];
[sampling_all_135]= vector_prev_segment(joint_length_135,arm_vector_135,all_locations);

if race == 0
    if gender == 0
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_AF') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_AF') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_AF') 
    else
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_AM') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_AM')
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_AM')
    end
else
    if gender == 0
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_CF') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_CF') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_CF')
    else
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_CM')
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_eigen_vector_CM') 
        load('C:\MATLAB7\work\OUTPUT\PCA_profile_mean_CM')
    end
end

%% transform back the values
profile_distance_all = [PCA_profile_eigen_vector]*(PCA_profile)' ;
new_profile_distance_original_all = profile_distance_all;
closest_subject_distance = new_profile_distance_original_all(:,closest_subject)+(PCA_profile_mean)';

profile_distance_neu_all = [PCA_profile_neu_eigen_vector]*(PCA_profile_neu)' ;
closest_subject_distance_neu = profile_distance_neu_all(:,closest_subject)+(PCA_profile_neu_mean)';

[row_database_closest unused]=size(closest_subject_distance);
closest_subject_distance_135 = closest_subject_distance(1:(row_database_closest/3),:);
sampling_all_135 = sampling_all_135((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);

%% ______________________________________________________SHOULDER ELBOW
%% additional distance for shoulder
difference_closest_subject = closest_subject_distance_135(1,:) -closest_subject_distance_neu(1,:);
difference_WRL = closest_subject_distance_135(1,:)-WRL_distance(1,:);
added_for_shoulder = difference_closest_subject-difference_WRL;

%% additional distance for elbow
S_E_WRL = find((all_locations(2,:)<=3)& (all_locations(2,:)>=2));
[unused col_S_E_WRL] = size(S_E_WRL);
added_for_elbow = WRL_distance(col_S_E_WRL+2+5,:)-closest_subject_distance_neu(col_S_E_WRL+2+5,:);

%% obtain coordinates for S and E
index_S_E = [1 col_S_E_WRL+2+5];
added_to_closest_subject_distance_135 = [added_for_shoulder added_for_elbow];
count = 0;
for j = index_S_E
    count = count+1;
    total_distance = closest_subject_distance_135(j,:)+added_to_closest_subject_distance_135(1,count);
    added_to_closest_subject_distance_135(1,count);
    S_E_135(count,:) = sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
end

%%% ADDED FOR PICS ON PROFILE
count = 0;
for j = 1:(col_S_E_WRL+2+5)
    count = count+1;
    total_distance = profile_distances_neu(j,:);
    WRL_upper_arm_profile(count,:) = sampling_all(j,1:2)+sampling_all(j,3:4)*total_distance;
end

count = 0;
for j = (col_S_E_WRL+2+5):row_reduced_sampled
    count = count+1;
    total_distance = profile_distances_neu(j,:);
    WRL_lower_arm_profile(count,:) = sampling_all(j,1:2)+sampling_all(j,3:4)*total_distance;
end

for j = 1:col_S_E_WRL+2+5
    total_distance = closest_subject_distance_135(j,:);
    S_E_profile_135_closest_subject(j,:) = sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
end

%% obtain distance between S and E coordinates
vector_S_E = S_E_135(1,:)-S_E_135(2,:);
distance_S_E = dot(vector_S_E,vector_S_E)^0.5;

%% obtain coordinates for closest_subject_distance_135
for j = 1:col_S_E_WRL+2+5
    total_distance = closest_subject_distance_135(j,:);
    S_E_profile_135_closest_subject(j,:) = sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
end

%% obtain distance between S and E coordinates for closest_subject_distance_135
[0 S_E_profile_135_closest_subject(1,:); 0 S_E_profile_135_closest_subject(col_S_E_WRL+2+5,:)];
vector_S_E = S_E_profile_135_closest_subject(1,:)-S_E_profile_135_closest_subject(col_S_E_WRL+2+5,:);
distance_S_E_135_closest_subject = dot(vector_S_E,vector_S_E)^0.5;

%% adjust coordinates of closest_subject_distance_135 so that S and E will have equal distance as that of S and E for the VRML
ratio = distance_S_E/distance_S_E_135_closest_subject;
for j = 1:col_S_E_WRL+2+5
    S_E_profile_135_closest_subject(j,:) = ratio*(S_E_profile_135_closest_subject(j,:)-S_E_profile_135_closest_subject(col_S_E_WRL+2+5,:))+S_E_profile_135_closest_subject(col_S_E_WRL+2+5,:);
end

%% translate S_E_profile_135_closest_subject so that mid E coincides with [0 0 0]
for j = 1:col_S_E_WRL+2+5
    S_E_profile_135_closest_subject(j,:) = S_E_profile_135_closest_subject(j,:)-S_E_profile_135_closest_subject(col_S_E_WRL+2+5,:);
end

%% translate S and E of VRML so that mid E coincides with [0 0 0]
translated_S_VRML = S_E_135(1,:)-S_E_135(2,:);

%% rotate S_E_profile_135_closest_subject so that its S coincides with S of VRML
vector_VRML = translated_S_VRML/(dot(translated_S_VRML,translated_S_VRML)^0.5);
vector_closest = S_E_profile_135_closest_subject(1,:)/(dot(S_E_profile_135_closest_subject(1,:),S_E_profile_135_closest_subject(1,:)))^0.5;
angle = acos(dot(vector_VRML,vector_closest));
angle_in_degree = angle*180/pi;

test = [cos(angle) -sin(angle);sin(angle) cos(angle)]*transpose(vector_closest);
test_angle = acos(dot(transpose(test),vector_VRML));
test_angle_in_degree = test_angle*180/pi;

if test_angle_in_degree>= 0.5
    angle = -angle;
end

%% rotation
final = [cos(angle) -sin(angle);sin(angle) cos(angle)]*transpose(S_E_profile_135_closest_subject);
final = transpose(final);
for j = 1:col_S_E_WRL+2+5
    S_E_profile_135_closest_subject(j,:) = final(j,:)+S_E_135(2,:);
end

%% SHOULDER WRIST
%% additional distance for wrist
E_W_WRL = find((all_locations(2,:)<=5)& (all_locations(2,:)>=4));
[unused col_E_W_WRL] = size(E_W_WRL);
difference_closest_subject = closest_subject_distance_135(row_reduced_sampled,:) -(closest_subject_distance_neu(row_reduced_sampled,:)+added_for_elbow);
difference_WRL = closest_subject_distance_135(row_reduced_sampled,:)-WRL_distance(row_reduced_sampled,:);
added_for_wrist = difference_closest_subject-difference_WRL;

%% obtain coordinates for W and E
index_E_W = [col_S_E_WRL+2+5 row_reduced_sampled];
added_to_closest_subject_distance_135 = [added_for_elbow added_for_wrist];
count = 0;
for j = index_E_W
    count = count+1;
    total_distance = closest_subject_distance_135(j,:) + added_to_closest_subject_distance_135(1,count);
    E_W_135(count,:) = sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
end

%% obtain distance between S and E coordinates
vector_E_W = E_W_135(1,:)-E_W_135(2,:);
distance_E_W = dot(vector_E_W,vector_E_W)^0.5;

%% obtain coordinates for closest_subject_distance_135
count = 0;
for j = col_S_E_WRL+2+5:row_reduced_sampled
    count = count+1;
    total_distance = closest_subject_distance_135(j,:);
    E_W_profile_135_closest_subject(count,:) = sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
end

%% obtain distance between S and E coordinates for closest_subject_distance_135
vector_E_W = E_W_profile_135_closest_subject(1,:)-E_W_profile_135_closest_subject(count,:);
distance_E_W_135_closest_subject = dot(vector_E_W,vector_E_W)^0.5;

%% adjust coordinates of closest_subject_distance_135 so that S and E will have equal distance as that of S and E for the VRML
ratio = distance_E_W/distance_E_W_135_closest_subject
for j = 1:count
    E_W_profile_135_closest_subject(j,:) = ratio*(E_W_profile_135_closest_subject(j,:)-E_W_profile_135_closest_subject(1,:))+E_W_profile_135_closest_subject(1,:);
end

%% translate S_E_profile_135_closest_subject so that mid E coincides with [0 0 0]
E_profile_135_closest_subject = E_W_profile_135_closest_subject(1,:)
for j = 1:count
    E_W_profile_135_closest_subject(j,:) = E_W_profile_135_closest_subject(j,:)-E_profile_135_closest_subject;
end

%% translate S and E of VRML so that mid E coincides with [0 0 0]
translated_W_VRML = E_W_135(2,:)-E_W_135(1,:);

%% rotate S_E_profile_135_closest_subject so that its S coincides with S of VRML
vector_VRML = translated_W_VRML/(dot(translated_W_VRML,translated_W_VRML)^0.5);
vector_closest = E_W_profile_135_closest_subject(count,:)/(dot(E_W_profile_135_closest_subject(count,:),E_W_profile_135_closest_subject(count,:)))^0.5;
angle = acos(dot(vector_VRML,vector_closest));
angle_in_degree = angle*180/pi;

test = [cos(angle) -sin(angle);sin(angle) cos(angle)]*transpose(vector_closest);
test_angle = acos(dot(transpose(test),vector_VRML));
test_angle_in_degree = test_angle*180/pi;

if test_angle_in_degree>= 0.5
    angle = -angle;
end

%% rotation
final = [cos(angle) -sin(angle);sin(angle) cos(angle)]*transpose(E_W_profile_135_closest_subject);
final = transpose(final);
for j = 1:count
    E_W_profile_135_closest_subject(j,:) = final(j,:)+E_W_135(1,:);
end

profile_135 = [S_E_profile_135_closest_subject;E_W_profile_135_closest_subject(2:count,:)];

bezier_135 = bspline_to_bezier(profile_135);
[row_sampling_all_135 unused] = size(sampling_all_135);
sampled_points_135 = multiple_sampling_new_version(bezier_135,sampling_all_135(2:(row_sampling_all_135-1),:));
[row_profile_135 unused] = size(profile_135);
sampled_points_135 = [profile_135(1,:);sampled_points_135;profile_135(row_profile_135,:)];


for i=1:row_reduced_sampled
    vector = sampled_points_135(i,:)-sampling_all_135(i,1:2);
    new_135_distance(i,:) = dot(vector,vector)^0.5;
end
profile_coordinates_135 = [zeros(row_reduced_sampled,1) profile_135]
profile_distances_135 = new_135_distance;

% 90
S = UAF_CS(2,:)*length_UA_LA(1,:);
W = LAF_CS_all(5,:)*length_UA_LA(2,:);
joint_length_90 = [length_UA_LA(1,:) length_UA_LA(1,:)*2/3 length_UA_LA(1,:)*1/3      0   length_UA_LA(2,:)*1/3 length_UA_LA(2,:)*2/3 length_UA_LA(2,:)];
arm_vector_90 = [S W];
[sampling_all_90]= vector_prev_segment(joint_length_90,arm_vector_90,all_locations);

closest_subject_distance_90 = closest_subject_distance((row_database_closest/3+1):(2*row_database_closest/3),:);
sampling_all_90 = sampling_all_90((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);

count = 0;
for j=1:row_reduced_sampled
    count = count+1;
    total_distance = new_135_distance(j,1)+(closest_subject_distance_90(j,1)-closest_subject_distance_135(j,1)); 
    profile_coordinates(j,:) = sampling_all_90(j,1:2)+sampling_all_90(j,3:4)*total_distance;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
    new_90_distance(count,1) = total_distance;
end

profile_distances_90 = new_90_distance;
profile_coordinates_90 = [zeros(row_reduced_sampled,1) profile_coordinates]


% %%% max  ************** RERUN*****************************
S = UAF_CS(2,:)*length_UA_LA(1,:);
W = LAF_CS_all(8,:)*length_UA_LA(2,:);
joint_length_max = [length_UA_LA(1,:) length_UA_LA(1,:)*2/3 length_UA_LA(1,:)*1/3      0   length_UA_LA(2,:)*1/3 length_UA_LA(2,:)*2/3 length_UA_LA(2,:)];
arm_vector_max = [S W];
[sampling_all_max]= vector_prev_segment(joint_length_max,arm_vector_max,all_locations);

closest_subject_distance_max = closest_subject_distance((2*row_database_closest/3+1):row_database_closest,:);
sampling_all_max = sampling_all_max((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);

count = 0;
for j=1:row_reduced_sampled
    count = count+1;
    total_distance = new_135_distance(j,1)+(closest_subject_distance_max(j,1)-closest_subject_distance_135(j,1)); 
    profile_coordinates(j,:) = sampling_all_max(j,1:2)+sampling_all_max(j,3:4)*total_distance;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
    new_max_distance(count,1) = total_distance;
end

profile_distances_max = new_max_distance;
profile_coordinates_max = [zeros(row_reduced_sampled,1) profile_coordinates];


save('C:\MATLAB7\work\OUTPUT\profile_coordinates_max.mat','profile_coordinates_max');
save('C:\MATLAB7\work\OUTPUT\profile_coordinates_90.mat','profile_coordinates_90');
save('C:\MATLAB7\work\OUTPUT\profile_coordinates_135.mat','profile_coordinates_135');

[FDA_neu,FDA_135,FDA_90,FDA_max,sampled_points_neu,sampled_points_135,sampled_points_90,sampled_points_max] = KNN_subfunction(new_UAF_CS,LAF_CS_all,E_CS_all,profile_coordinates_135,profile_coordinates_90,profile_coordinates_max);

save('C:\MATLAB7\work\INITIAL INPUT\profile_distances_neu.mat','profile_distances_neu')
save('C:\MATLAB7\work\INITIAL INPUT\profile_distances_max.mat','profile_distances_max')
save('C:\MATLAB7\work\INITIAL INPUT\profile_distances_90.mat','profile_distances_90')
save('C:\MATLAB7\work\INITIAL INPUT\profile_distances_135.mat','profile_distances_135')
