function [FDA_neu,FDA_135,FDA_90,FDA_max,sampled_points_neu,sampled_points_135,sampled_points_90,sampled_points_max] = KNN_subfunction(new_UAF_CS,LAF_CS_all,E_CS_all,profile_coordinates_135,profile_coordinates_90,profile_coordinates_max)

%% 1. Calculate the CS for each key posture
load('C:\MATLAB7\work\OUTPUT\CS.mat')

%% 2. Locations of the cross sections for neutral posture
load('C:\MATLAB7\work\OUTPUT\CS_distance.mat')

%% 3. Establishing joint length and arm vector for neutral posture
load('C:\MATLAB7\work\OUTPUT\skeleton_length.mat')
S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_neutral;
UAM = UAF_CS(2,2:3)*UAM_distance_neutral;
LAM = LAF_CS(2,2:3)*LAM_distance_neutral;
LAF = LAF_CS(2,2:3)*LAF_distance_neutral;
W = LAF_CS(2,:)*length_UA_LA(2,:);
joint_length_neu = [(dot(S(2:3),S(2:3)))^0.5  (dot(UAF,UAF))^0.5   (dot(UAM,UAM))^0.5  0  (dot(LAM,LAM))^0.5   (dot(LAF,LAF))^0.5 (dot(W(2:3),W(2:3)))^0.5];
arm_vector = [S W];

%% 3. Calculating sampled points of the profile for the neutral posture 
load('C:\MATLAB7\work\OUTPUT\profile.mat')
load('C:\MATLAB7\work\INITIAL INPUT\all_locations_fda.mat');
[sampling_all]= vector_prev_segment(joint_length_neu,arm_vector,all_locations_fda);
bezier = bspline_to_bezier(profile_right(:,2:3));
sampled_points = multiple_sampling_new_version(bezier,sampling_all);

%% 7. Recording the sampled points location beyond the FDA (flesh deformation area) 
LAF_W = find(all_locations_fda(2,:) == 6);
S_UAF = find(all_locations_fda(2,:) == 1);
[unused col_LAF_W] = size(LAF_W);
[unused col_S_UAF] = size(S_UAF);
[row_sampled unused] = size(sampled_points)

%% 8. Modify distance of the template and sampled points to capture FDA only
reduced_sampled_points = sampled_points((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
sampled_points_neu = reduced_sampled_points;
[row_reduced_sampled unused] = size(sampled_points_neu)
reduced_sampling_all = sampling_all((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
sampling_all = reduced_sampling_all;
distance_vector = sampled_points_neu-sampling_all(:,1:2);
for n=1:row_reduced_sampled
    FDA_neu(n,1) = ((dot(distance_vector(n,:),distance_vector(n,:)))^0.5);
end

%% 9. Establishing joint length and arm vector for other key posture
[distances_135,distances_90,distances_max] = calculate_distance_other_key_postures;

%% *** 135
UAF_distance_135 = distances_135(1,1);
UAM_distance_135 = distances_135(2,1);
LAM_distance_135 = distances_135(3,1);
LAF_distance_135 = distances_135(4,1);
S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_135;
UAM = UAF_CS(2,2:3)*UAM_distance_135;
LAM = LAF_CS_all(2,2:3)*LAM_distance_135;
LAF = LAF_CS_all(2,2:3)*LAF_distance_135;
W = LAF_CS_all(2,:)*length_UA_LA(2,:);
joint_length_135 = [(dot(S(2:3),S(2:3)))^0.5  (dot(UAF,UAF))^0.5   (dot(UAM,UAM))^0.5  0  (dot(LAM,LAM))^0.5   (dot(LAF,LAF))^0.5 (dot(W(2:3),W(2:3)))^0.5];
arm_vector_135 = [S W];
[sampling_all_135]= vector_prev_segment(joint_length_135,arm_vector_135,all_locations_fda);
bezier_135 = bspline_to_bezier(profile_coordinates_135(:,2:3));
reduced_sampling_all_135 = sampling_all_135((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
sampling_all_135 = reduced_sampling_all_135;
sampled_points_135 = multiple_sampling_new_version(bezier_135,sampling_all_135);


distance_vector = sampled_points_135-sampling_all_135(:,1:2);
for n=1:row_reduced_sampled
    FDA_135(n,1) = ((dot(distance_vector(n,:),distance_vector(n,:)))^0.5);
end

%% *****90
UAF_distance_90 = distances_90(1,1);
UAM_distance_90 = distances_90(2,1);
LAM_distance_90 = distances_90(3,1);
LAF_distance_90 = distances_90(4,1);
S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_90;
UAM = UAF_CS(2,2:3)*UAM_distance_90;
LAM = LAF_CS_all(5,2:3)*LAM_distance_90;
LAF = LAF_CS_all(5,2:3)*LAF_distance_90;
W = LAF_CS_all(5,:)*length_UA_LA(2,:);
joint_length_90 = [(dot(S(2:3),S(2:3)))^0.5  (dot(UAF,UAF))^0.5   (dot(UAM,UAM))^0.5  0  (dot(LAM,LAM))^0.5   (dot(LAF,LAF))^0.5 (dot(W(2:3),W(2:3)))^0.5];
arm_vector_90 = [S W];
[sampling_all_90]= vector_prev_segment(joint_length_90,arm_vector_90,all_locations_fda);
bezier_90 = bspline_to_bezier(profile_coordinates_90(:,2:3));
reduced_sampling_all_90 = sampling_all_90((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
sampling_all_90 = reduced_sampling_all_90;
sampled_points_90 = multiple_sampling_new_version(bezier_90,sampling_all_90);


distance_vector = sampled_points_90-sampling_all_90(:,1:2);
for n=1:row_reduced_sampled
    FDA_90(n,1) = ((dot(distance_vector(n,:),distance_vector(n,:)))^0.5);
end 


%% *****max
UAM_distance_max = distances_max(1,1);
LAM_distance_max = distances_max(2,1);
S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_max;
UAM = UAF_CS(2,2:3)*UAM_distance_max;
LAM = LAF_CS_all(8,2:3)*LAM_distance_max;
LAF = LAF_CS_all(8,2:3)*LAF_distance_max;
W = LAF_CS_all(8,:)*length_UA_LA(2,:);
joint_length_max = [(dot(S(2:3),S(2:3)))^0.5  (dot(UAF,UAF))^0.5   (dot(UAM,UAM))^0.5  0  (dot(LAM,LAM))^0.5   (dot(LAF,LAF))^0.5 (dot(W(2:3),W(2:3)))^0.5];
arm_vector_max = [S W];
[sampling_all_max]= vector_prev_segment(joint_length_max,arm_vector_max,all_locations_fda);
bezier_max = bspline_to_bezier(profile_coordinates_max(:,2:3));
reduced_sampling_all_max = sampling_all_max((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
sampling_all_max = reduced_sampling_all_max;
sampled_points_max = multiple_sampling_new_version(bezier_max,sampling_all_max);


distance_vector = sampled_points_max-sampling_all_max(:,1:2);
for n=1:row_reduced_sampled
    FDA_max(n,1) = ((dot(distance_vector(n,:),distance_vector(n,:)))^0.5);
end 
