function [sample_rays]= vector_segment_no_alt_points(joint_length_segment,arm_vector,k,segment)

[index] = find(joint_length_segment==0);

if isempty(index)
    interpolated_vector = 0;
else
    interpolated_vector = 1;
end

[unused used] = size(k);
for i = 1:used
    inserted_value(1,i) = k(1,i)*(joint_length_segment(1,2)-joint_length_segment(1,1))+joint_length_segment(1,1);
end

if segment>3
   unit_arm_vector = arm_vector(1,4:6)/(dot(arm_vector(1,4:6),arm_vector(1,4:6))^0.5);
   new_joint_length_segment = sort([joint_length_segment inserted_value],'ascend');
   angle = pi/2;
else
   unit_arm_vector = arm_vector(1,1:3)/(dot(arm_vector(1,1:3),arm_vector(1,1:3))^0.5);
   new_joint_length_segment = sort([joint_length_segment inserted_value],'descend');
   angle = -pi/2;
end   

for i=1:(used+2)
    center_point = unit_arm_vector*new_joint_length_segment(1,i);
    vector = unit_arm_vector*[1  0  0;0  cos(angle)  sin(angle);0 -sin(angle)  cos(angle)];
    sample_rays(i,1:4) = [center_point(1,2:3) vector(1,2:3)];
end

if interpolated_vector == 1
    if segment>3
        start_value = 0.6;
        end_value = 0.9;
    else
        start_value = 0.1;
        end_value = 0.5;
    end
    [sample_rays_inserted] = interpolated_sampling_vector(arm_vector,start_value,end_value);
    if segment>3
        sample_rays(1,:)=[];
        sample_rays = [sample_rays_inserted;sample_rays];
    else
        [row_sample_rays unused] = size(sample_rays);
        sample_rays(row_sample_rays,:) = [];
        sample_rays = [sample_rays;sample_rays_inserted];
    end
end


