function [reduced_length_LA] = LAM_LAF_final_side_adjustments(distances_135,LAF_CS_all,bspline_135_max)


load ('C:\MATLAB7\work\OUTPUT\profile.mat')
LAF_bone_point_135 = LAF_CS_all(2,:)*distances_135(4,:);

m_base = LAF_CS_all(2,2)/LAF_CS_all(2,3);
b_base = LAF_bone_point_135(1,2) - m_base*LAF_bone_point_135(1,3);
m_CS = -1/m_base;

%% calculate intersection point between LAF CS point max at the left and the lower arm bone 
b_CS = bspline_135_max(5,3) - m_CS*bspline_135_max(5,4);
z = (b_CS-b_base)/(m_base-m_CS);
y = m_CS*z + b_CS;
base_LAF_outside = [y z];

%% calculate distance between intersection point above and the LAF CS point max 
distance_lower = bspline_135_max(5,3:4)- base_LAF_outside;
distance_lower = (dot(distance_lower,distance_lower))^0.5;

%% calculate intersection point between LAF CS point max at the right and the lower arm bone 
b_CS = bspline_135_max(5,1) - m_CS*bspline_135_max(5,2);
z = (b_CS-b_base)/(m_base-m_CS);
y = m_CS*z + b_CS;
base_LAF_inside = [y z];

%% calculate distance between intersection point above and the LAF CS point max 
distance_upper = bspline_135_max(5,1:2)- base_LAF_inside;
distance_upper = (dot(distance_upper,distance_upper))^0.5;
distance_LAF_total = distance_upper+distance_lower;

%% calculate intersection point between the profile and location of LAF at
%% the bone
load ('C:\MATLAB7\work\OUTPUT\CS.mat')
m = -1/(LAF_CS(2,2)/LAF_CS(2,3));
LAF_bone_neu_135_distance = LAF_CS(2,:)*distances_135(4,:)
b = LAF_bone_neu_135_distance(1,2)-m*LAF_bone_neu_135_distance(1,3);
% 
[row col] = size(profile_left);
for i=1:(row-1)
    m2= (profile_left(i+1,2)-profile_left(i,2))/(profile_left(i+1,3)-profile_left(i,3));
    b2 = profile_left(i,2)-m2*profile_left(i,3);
    z = (b2-b)/(m-m2);
    y = m2*z + b2;
    test = [0 y z] - profile_left(i,:);
    actual = profile_left(i+1,:) - profile_left(i,:);
    length_xy = (dot(test,test))^0.5;
    length_actual = (dot(actual,actual))^0.5;
    if length_xy<length_actual
       intersection_point_left = [0 y z];
    break
    end
end

[row col] = size(profile_right);
for i=1:(row-1)
    m2= (profile_right(i+1,2)-profile_right(i,2))/(profile_right(i+1,3)-profile_right(i,3));
    b2 = profile_right(i,2)-m2*profile_right(i,3);
    z = (b2-b)/(m-m2);
    y = m2*z + b2;
    test = [0 y z] - profile_right(i,:);
    actual = profile_right(i+1,:) - profile_right(i,:);
    length_xy = (dot(test,test))^0.5;
    length_actual = (dot(actual,actual))^0.5;
    if length_xy<length_actual
        intersection_point_right = [0 y z];
    break
    end
end

%% calculate width of LAF profile i.e. the intersection between bone of LAF
%% and profile
distance_profile_LAF_side = intersection_point_right-intersection_point_left;
distance_profile_LAF_side = (dot(distance_profile_LAF_side,distance_profile_LAF_side))^0.5;

%% subtract to find the length difference
reduced_length_LA = distance_LAF_total-distance_profile_LAF_side ;
