function [reduced_length_by] = check_90_E_LAM_LAF_angle(LAF_CS_all,bspline_max)

%% USE ANGLE
LAF_CS_all_90 = LAF_CS_all(4:6,:);

vector_1 = bspline_max(3,1:2)-bspline_max(4,1:2);
vector_1_unit = vector_1/(dot(vector_1,vector_1)^0.5);
vector_2 = bspline_max(5,1:2)-bspline_max(4,1:2);
vector_2_unit = vector_2/(dot(vector_2,vector_2)^0.5);
test_angle = acos(dot(vector_1_unit,vector_2_unit))*180/pi
vector_base = bspline_max(3,1:2)-bspline_max(5,1:2);
m_base = vector_base(:,1)/vector_base(:,2)
b_base = bspline_max(3,1) - m_base*bspline_max(3,2);
vector_CS = LAF_CS_all_90(3,2:3);
m_CS = vector_CS(:,1)/vector_CS(:,2);
b_CS = bspline_max(4,1) - m_CS*bspline_max(4,2);
z = (b_CS-b_base)/(m_base-m_CS);
y = m_CS*z + b_CS;

%%% check where bspline_max(4,1:2) is located with respect to [0 y z]
% % if bspline_max(4,1:2) is higher: inflection
% % else deflection the only difference would be the direction
if test_angle < 176
    if bspline_max(4,1) > y
        vector_difference = bspline_max(4,1:2)- [y z];
        vector_difference_unit = vector_difference/(dot(vector_difference,vector_difference)^0.5);
        distance_vector_difference = dot(vector_difference,vector_difference)^0.5;
        new_distance_difference =  (180-180)/(test_angle-180)*distance_vector_difference;
        new_bspline_LAM = LAF_CS_all_90(3,2:3)*new_distance_difference + [y z];
        vector_1 = bspline_max(3,1:2)-new_bspline_LAM;
        vector_1_unit = vector_1/(dot(vector_1,vector_1)^0.5);
        vector_2 = bspline_max(5,1:2)-new_bspline_LAM;
        vector_2_unit = vector_2/(dot(vector_2,vector_2)^0.5);
        test_angle_2 = acos(dot(vector_1_unit,vector_2_unit))*180/pi;
        if abs(test_angle_2-180)<0.5
            reduced_length_by = distance_vector_difference-new_distance_difference;
        end
    else
        'DEFLECTION'
        vector_difference = bspline_max(4,1:2)- [y z];
        vector_difference_unit = vector_difference/(dot(vector_difference,vector_difference)^0.5);
        distance_vector_difference = dot(vector_difference,vector_difference)^0.5;
        new_distance_difference =  (180-180)/(test_angle-180)*distance_vector_difference;
        new_bspline_LAM = LAF_CS_all_90(3,2:3)*new_distance_difference + [y z];
        vector_1 = bspline_max(3,1:2)-new_bspline_LAM;
        vector_1_unit = vector_1/(dot(vector_1,vector_1)^0.5);
        vector_2 = bspline_max(5,1:2)-new_bspline_LAM;
        vector_2_unit = vector_2/(dot(vector_2,vector_2)^0.5);
        test_angle_2 = acos(dot(vector_1_unit,vector_2_unit))*180/pi;
        if abs(test_angle_2-180)<0.5
            reduced_length_by = -distance_vector_difference-new_distance_difference;
        end
    end
else
    reduced_length_by = 0;
end