clear all

load 'C:\MATLAB7\work\OUTPUT\CS.mat';
load 'C:\MATLAB7\work\OUTPUT\CS_distance.mat';
load('C:\MATLAB7\work\OUTPUT\skeleton_length.mat');
load('C:\MATLAB7\work\OUTPUT\all_locations.mat');

correct_value = 0;
while correct_value == 0    
    arm_angle_text = num2str(arm_angle);
    any_angle = input(['Enter any angle. (The value must be between: 35 and ',arm_angle_text,') ']);
    if any_angle<35 | any_angle>arm_angle
        ['Value is not correct, the value must be between: 35 and ',arm_angle_text]
    else
        correct_value = 1;
    end
end


load('C:\MATLAB7\work\OUTPUT\CrossSec_magnitudes.mat');

if any_angle >= 135
    load('C:\MATLAB7\work\INITIAL INPUT\profile_distances_neu.mat');
    load('C:\MATLAB7\work\INITIAL INPUT\profile_distances_135.mat');
    ratio = (any_angle-arm_angle)/(135-arm_angle);
    base_distance = profile_distances_neu;
    upper_bound_distance = profile_distances_135;
    base_magnitude = magnitude_CrossSec_neutral;
    upper_bound_magnitude = magnitude_CrossSec_135;
elseif (any_angle >=90 & any_angle <=135)
    load('C:\MATLAB7\work\INITIAL INPUT\profile_distances_135.mat');
    load('C:\MATLAB7\work\INITIAL INPUT\profile_distances_90.mat');
    ratio = (any_angle-135)/(90-135);
    base_distance = profile_distances_135;
    upper_bound_distance = profile_distances_90;
    base_magnitude = magnitude_CrossSec_135;
    upper_bound_magnitude = magnitude_CrossSec_90;
else  
    load('C:\MATLAB7\work\INITIAL INPUT\profile_distances_90.mat');
    load('C:\MATLAB7\work\INITIAL INPUT\profile_distances_max.mat');
    ratio = (any_angle-90)/(35-90);
    base_distance = profile_distances_90;
    upper_bound_distance = profile_distances_max;
    base_magnitude =magnitude_CrossSec_90;
    upper_bound_magnitude = magnitude_CrossSec_max;
end

[UAF_distance_any] = lin_int_distance(UAF_distance_neutral,UAF_distance_max,arm_angle,any_angle);
[UAM_distance_any] = non_lin_int_distance(UAM_coef,UAF_distance_neutral,any_angle);
[LAM_distance_any] = non_lin_int_distance(LAM_coef,LAF_distance_neutral,any_angle);
[LAF_distance_any] = lin_int_distance(LAF_distance_neutral,LAF_distance_max,arm_angle,any_angle);
distances_any = [UAF_distance_any;UAM_distance_any;LAM_distance_any;LAF_distance_any];

if abs(any_angle - arm_angle)>0.001
    %% part 1
    new_X = cross(UAF_CS(2,:),[0 0 1]);
    new_X = new_X/(dot(new_X,new_X)^0.5);
    new_Z = cross(new_X,UAF_CS(2,:));
    new_Z = new_Z/(dot(new_Z,new_Z)^0.5);
    new_UAF_CS = [new_X;UAF_CS(2,:);new_Z];

    %% part 2
    [carrying_angle_any,flexion_angle_any] = calculate_carrying_and_flexion(carrying_angle,arm_angle,any_angle);

    %% part 3
    [euler_matrix] = create_euler_matrix(flexion_angle_any,carrying_angle_any,0);
    new_vector_LA_any = [0 -1 0]*euler_matrix*new_UAF_CS;

    %% part 4
    [LAF_CS_any]= local_CS_other_key_postures (new_vector_LA_any);

    %% part 5
    [E_CS_any] = determine_E_CS_for_any_posture(new_UAF_CS(2,:),new_vector_LA_any)
else
    new_UAF_CS = UAF_CS;
    LAF_CS_any = LAF_CS;
    E_CS_any = E_CS;
    distances_any = [UAF_distance_neutral;UAM_distance_neutral;LAM_distance_neutral;LAF_distance_neutral];
end

LAF_W = find(all_locations(2,:) == 6);
S_UAF = find(all_locations(2,:) == 1);
[unused col_LAF_W] = size(LAF_W);
[unused col_S_UAF] = size(S_UAF);

S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_any;
UAM = UAF_CS(2,2:3)*UAM_distance_any;
LAM = LAF_CS_any(2,2:3)*LAM_distance_any;
LAF = LAF_CS_any(2,2:3)*LAF_distance_any;
W = LAF_CS_any(2,:)*length_UA_LA(2,:);

joint_length_any = [length_UA_LA(1,:) length_UA_LA(1,:)*2/3 length_UA_LA(1,:)*1/3      0   length_UA_LA(2,:)*1/3 length_UA_LA(2,:)*2/3 length_UA_LA(2,:)];
arm_vector_any = [S W];
[sampling_all_any]= vector_prev_segment(joint_length_any,arm_vector_any,all_locations);
[row_sampled unused] = size(sampling_all_any);
reduced_sampling_all_any = sampling_all_any((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
sampling_all_any = reduced_sampling_all_any;
[row_reduced_sampled unused] = size(sampling_all_any);

for j=1:row_reduced_sampled
    total_distance =  ratio*(upper_bound_distance(j,1)-base_distance(j,1))+base_distance(j,1);
    profile_coordinates(j,:) = sampling_all_any(j,1:2)+sampling_all_any(j,3:4)*total_distance;
    list_total_distance(j,:) = total_distance;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
end

profile_coordinates_any = [zeros(row_reduced_sampled,1) profile_coordinates];

%% SAVE THE FILE OF SAMPLING ANY CENTER AND VECTOR
savefile = strcat('C:\MATLAB7\work\PROFILE VALIDATION\PROFILE PREDICTION\sampling_all_any_',num2str(any_angle),'.mat')
save(savefile,'sampling_all_any')

load('C:\MATLAB7\work\INITIAL INPUT\unit_vector.mat')

if (any_angle<=91 & any_angle>=36)
    for i = 1:5
        if i <= 2
            CS_transform = new_UAF_CS;
            translation_distance = distances_any(i,:);
        elseif i==3
            CS_transform = E_CS_any;
            translation_distance = 0;
        else
            CS_transform = LAF_CS_any;
            translation_distance = distances_any(i-1,:);
        end        
        
        if i ~= 3
            for j=1:16 
                total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
                Cross_Sec_coordinates_scaled(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude;
            end     
            ratio
            for j=1:16  
                ratio_zero = 0;
                total_magnitude =  ratio_zero*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
                Cross_Sec_coordinates_unscaled(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude;
            end  
            for j = 1:2
                if j == 1
                    index = [2 3 4 5 6 7 8];
                    old_length = max(Cross_Sec_coordinates_unscaled(:,1));
                    new_length = max(Cross_Sec_coordinates_scaled(:,1));
                else
                    index = [10 11 12 13 14 15 16];
                    old_length = min(Cross_Sec_coordinates_unscaled(:,1));
                    new_length = min(Cross_Sec_coordinates_scaled(:,1));
                end
                    ratio_front_view = new_length/old_length
                for k = index
                    Cross_Sec_coordinates_unscaled(k,1) = Cross_Sec_coordinates_unscaled(k,1)*ratio_front_view;
                end
            end            
            for j=1:16  
                Cross_Sec_coordinates(j,:) = Cross_Sec_coordinates_unscaled(j,:)*CS_transform + CS_transform(2,:)*translation_distance;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
            end
        else         
            for j=1:16  
                total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
                Cross_Sec_coordinates(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude*CS_transform + CS_transform(2,:)*translation_distance;
            end
        end
        
        if i==1
            all_Cross_Sec_coordinates = Cross_Sec_coordinates;
        else
            all_Cross_Sec_coordinates = [all_Cross_Sec_coordinates Cross_Sec_coordinates];
        end
        
    end    
else
    for i = 1:5
        if i <= 2
            CS_transform = new_UAF_CS;
            translation_distance = distances_any(i,:);
        elseif i==3
            CS_transform = E_CS_any;
            translation_distance = 0;
        else
            CS_transform = LAF_CS_any;
            translation_distance = distances_any(i-1,:);
        end 
        for j=1:16
            total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
            Cross_Sec_coordinates(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude*CS_transform + CS_transform(2,:)*translation_distance;
        end
        if i==1
            all_Cross_Sec_coordinates = Cross_Sec_coordinates;
        else
            all_Cross_Sec_coordinates = [all_Cross_Sec_coordinates Cross_Sec_coordinates];
        end
    end
end
all_Cross_Sec_coordinates
%%%_____________________________ TRANSLATION CS_____________________________________  
[CS_bspline_any,center_any] = creating_CS_bspline(all_Cross_Sec_coordinates(:,1:3),all_Cross_Sec_coordinates(:,4:6),all_Cross_Sec_coordinates(:,7:9),all_Cross_Sec_coordinates(:,10:12),all_Cross_Sec_coordinates(:,13:15));
[bspline_any_max] = bspline_max_side_view(CS_bspline_any,new_UAF_CS,E_CS_any,LAF_CS_any,distances_any);

if any_angle >35 
    vector_coordinates_sytem = [new_UAF_CS(3,:)  new_UAF_CS(3,:)  E_CS_any(3,:)  LAF_CS_any(3,:)  LAF_CS_any(3,:)];
    bone_coordinates_system = [new_UAF_CS(2,:)  new_UAF_CS(2,:)  0 0 0  LAF_CS_any(2,:)  LAF_CS_any(2,:)];
    [vector_coordinates_sytem] = modify_vector_coordinates_sytem(vector_coordinates_sytem,profile_coordinates_any,bspline_any_max); 
    [all_Cross_Sec_coordinates,new_center_135,new_CS_bspline_135_max,translation_magnitude_135] = translating_CS(profile_coordinates_any,vector_coordinates_sytem,bspline_any_max(:,3:4),all_Cross_Sec_coordinates,bspline_any_max,center_any);
    [CS_bspline_any,center_any] = creating_CS_bspline(all_Cross_Sec_coordinates(:,1:3),all_Cross_Sec_coordinates(:,4:6),all_Cross_Sec_coordinates(:,7:9),all_Cross_Sec_coordinates(:,10:12),all_Cross_Sec_coordinates(:,13:15));
    [bspline_any_max,bspline_max_index] = bspline_max_side_view(CS_bspline_any,new_UAF_CS,E_CS_any,LAF_CS_any,distances_any);

    UAF_profile_point = CS_bspline_any(bspline_max_index(1,2),1:3)
    UAM_profile_point = CS_bspline_any(bspline_max_index(2,2),4:6)
    E_profile_point = CS_bspline_any(bspline_max_index(3,2),7:9)
    LAM_profile_point = CS_bspline_any(bspline_max_index(4,2),10:12)
    LAF_profile_point = CS_bspline_any(bspline_max_index(5,2),13:15)
    attach_profile = [UAF_profile_point;UAM_profile_point;E_profile_point;LAM_profile_point;LAF_profile_point];
else
    [CS_bspline_any,center_any] = creating_CS_bspline(all_Cross_Sec_coordinates(:,1:3),all_Cross_Sec_coordinates(:,4:6),all_Cross_Sec_coordinates(:,7:9),all_Cross_Sec_coordinates(:,10:12),all_Cross_Sec_coordinates(:,13:15));
    [bspline_any_max,bspline_max_index] = bspline_max_side_view(CS_bspline_any,new_UAF_CS,E_CS_any,LAF_CS_any,distances_any);

    UAF_profile_point = CS_bspline_any(bspline_max_index(1,2),1:3)
    UAM_profile_point = CS_bspline_any(bspline_max_index(2,2),4:6)
    E_profile_point = CS_bspline_any(bspline_max_index(3,2),7:9)
    LAM_profile_point = CS_bspline_any(bspline_max_index(4,2),10:12)
    LAF_profile_point = CS_bspline_any(bspline_max_index(5,2),13:15)
    attach_profile = [UAF_profile_point;UAM_profile_point;E_profile_point;LAM_profile_point;LAF_profile_point] ;  
end

save('C:\MATLAB7\work\OUTPUT\attach_profile.mat','attach_profile')
save('C:\MATLAB7\work\OUTPUT\all_Cross_Sec_coordinates.mat','all_Cross_Sec_coordinates')
vector_coordinates_system = [new_UAF_CS E_CS_any  LAF_CS_any];
save('C:\MATLAB7\work\OUTPUT\vector_coordinates_system.mat','vector_coordinates_system')
save('C:\MATLAB7\work\OUTPUT\distances_any.mat','distances_any')
save('C:\MATLAB7\work\OUTPUT\sampling_all_any.mat','sampling_all_any')
save('C:\MATLAB7\work\OUTPUT\profile_coordinates_any.mat','profile_coordinates_any')

[bone_intersection_1] = additional_profile_points_form_CS(attach_profile(1,:),new_UAF_CS);
[bone_intersection_2] = additional_profile_points_form_CS(attach_profile(2,:),new_UAF_CS);
bone_intersection_3 = [0 0 0];
[bone_intersection_4] = additional_profile_points_form_CS(attach_profile(4,:),LAF_CS_any);
[bone_intersection_5] = additional_profile_points_form_CS(attach_profile(5,:),LAF_CS_any);

list_points_at_elbow = find(sampling_all_any(:,1) == 0);
[profile_coordinates_any,sampling_all_any] = delete_part_profile_lower(list_points_at_elbow,profile_coordinates_any,attach_profile,sampling_all_any,bone_intersection_5);
[profile_coordinates_any,sampling_all_any] = delete_part_profile_upper(list_points_at_elbow,profile_coordinates_any,attach_profile,sampling_all_any,bone_intersection_1);

%%inserting LAM
[row_profile_coordinates_any  unused] = size(profile_coordinates_any);
list_points_at_elbow = find(sampling_all_any(:,1) == 0);

[profile_coordinates_any,sampling_all_any,insertion_lower] = insert_part_profile_lower(list_points_at_elbow,profile_coordinates_any,attach_profile,sampling_all_any,bone_intersection_4);
[profile_coordinates_any,sampling_all_any,insertion_upper] = insert_part_profile_upper(list_points_at_elbow,profile_coordinates_any,attach_profile,sampling_all_any,bone_intersection_2);
insertion_lower = insertion_lower

list_points_at_elbow = find(sampling_all_any(:,1) == 0);
[row_list col_list] = size(list_points_at_elbow);
index_profile(1,1:2) = [1 list_points_at_elbow(1,1) + (row_list-rem(row_list,2))*0.5];
[row_profile_coordinates_any  unused] = size(profile_coordinates_any);
index_profile(2,1:2) = [index_profile(1,2)+1 row_profile_coordinates_any];
profile_coordinates_modified_any = profile_coordinates_any;

save('C:\MATLAB7\work\OUTPUT\profile_coordinates_modified_any.mat','profile_coordinates_modified_any')
save('C:\MATLAB7\work\OUTPUT\index_profile.mat','index_profile')
index_UAM_LAM = [insertion_upper;insertion_lower];
save('C:\MATLAB7\work\OUTPUT\index_UAM_LAM.mat','index_UAM_LAM')
save('C:\MATLAB7\work\OUTPUT\any_angle.mat','any_angle')


%%% SAVING FILE FOR CROSS SECTION VALIDATION PURPOSE 

all_Cross_Sec_coordinates_validation = [distances_any(1,:)*vector_coordinates_system(2,1:3)  distances_any(2,:)*vector_coordinates_system(2,1:3) 0 0 0   distances_any(3,:)*vector_coordinates_system(2,7:9)   distances_any(4,:)*vector_coordinates_system(2,7:9);all_Cross_Sec_coordinates];
save('C:\MATLAB7\work\CROSS SECS VALIDATION\all_Cross_Sec_coordinates_validation.mat','all_Cross_Sec_coordinates_validation')

