function [coefficient]=calculate_poly_bezier_quadratic(bezier)

[rowb col] = size(bezier);

    P0=bezier(1,:);
    P1=bezier(2,:);
    P2=bezier(3,:);
    t_2_x = P0(1,1) - 2*P1(1,1) + P2(1,1);
    t_1_x = -2*P0(1,1) + 2*P1(1,1);
    t_0_x = P0(1,1);
 
    t_2_y = P0(1,2) - 2*P1(1,2) + P2(1,2);
    t_1_y = -2*P0(1,2) + 2*P1(1,2);
    t_0_y = P0(1,2);
    
    t_2_z = P0(1,3) - 2*P1(1,3) + P2(1,3);
    t_1_z = -2*P0(1,3) + 2*P1(1,3);
    t_0_z = P0(1,3);
    
coefficient = [t_2_x t_1_x t_0_x; t_2_y t_1_y t_0_y; t_2_z t_1_z t_0_z];