clear all

[coordinates_UAF,coordinates_UAM,coordinates_E,coordinates_LAM,coordinates_LAF,attach_profile,bezier_loc_all,t_all,lngth_cum_all,lngth_index]  = preparing_cross_sec_for_flesh_deformation;
attach_profile = [attach_profile(1,:);attach_profile(3,:);attach_profile(5,:)] ;

vector_1 = attach_profile(1,:)-attach_profile(2,:);
vector_2 = attach_profile(3,:)-attach_profile(2,:);
N = cross(vector_1,vector_2);
l = (N(1,1)^2+ N(1,2)^2+ N(1,3)^2)^0.5;
N = N/l;
P3 = attach_profile(2,:);
d = dot(N,attach_profile(2,:));

for i=1:2
    if i==1
       coordinates_cross_section = coordinates_UAM;
       to_choose_bezier = sort([bezier_loc_all(2,:);bezier_loc_all(4,:)],'ascend');
    else
       VALUE_OF_K_2 = VALUE_OF_K;
       bezier_loc_add_2 = bezier_loc_add;
       coordinates_cross_section = coordinates_LAM;
       to_choose_bezier = sort([bezier_loc_all(4,:);bezier_loc_all(6,:) ],'ascend');
    end
    [bezier] = create_bezier(coordinates_cross_section);
    if to_choose_bezier(1,:) == to_choose_bezier(2,:)
        chosen_bezier = bezier((to_choose_bezier(1,:)-3):to_choose_bezier(1,:),:);
    else
        chosen_bezier = bezier((to_choose_bezier(1,:)-3):to_choose_bezier(2,:),:);
    end 
    [row col] =size(chosen_bezier)
    loop_on = 1;
    for j=1:4:row
       P1 = chosen_bezier(j,:); 
       P2 = chosen_bezier(j+3,:);
       u = dot(N,(P3-P1))/dot(N,(P2-P1));
       if u>=0 & u<=1
            [coefficient]=calculate_poly_bezier(chosen_bezier(j:j+3,:));
        if j==1
           bezier_loc_add = [(to_choose_bezier(1,:)-3);to_choose_bezier(1,:)];
        else
            [tf loc]=ismember(P1(1,3),bezier(:,3));
            bezier_loc_add = [loc;loc+3] ;
        end
        for k=0:0.1:1
            val = (coefficient)*[k^3;k^2;k;1];
            x = sum(val(1,:));
            y = sum(val(2,:));
            z = sum(val(3,:));
            compare_val = N(1,1)*x+N(1,2)*y+N(1,3)*z;
            if compare_val<d
                    tag = 0;
            else
                    tag = 1;
            end
            if k==0
                tag_prev = tag;
            end
            if tag~=tag_prev
               for m=(k-0.1):0.001:k
               val = (coefficient)*[m^3;m^2;m;1];
               x = sum(val(1,:));
               y = sum(val(2,:));
               z = sum(val(3,:));
               compare_val = N(1,1)*x+N(1,2)*y+N(1,3)*z;               
               difference = compare_val-d;
               if m~=(k-0.1) 
                  if abs(difference)>abs(difference_prev)
                      VALUE_OF_K = m-0.001;
                      loop_on = 0;
                      break
                  elseif abs(difference)<abs(difference_prev) & m==k
                      VALUE_OF_K = m-0.001;
                      loop_on = 0;
                  break
                  end
               end
               difference_prev = difference;
            end
         end
            tag_prev = tag;
         if loop_on ==0
            break
         end
        end
       end
    end 
end

bezier_loc_all = [bezier_loc_all(1:2,:);bezier_loc_add_2;bezier_loc_all(5:6,:);bezier_loc_add;bezier_loc_all(9:10,:)];
t_all = [t_all(1,:);VALUE_OF_K_2;t_all(3,:);VALUE_OF_K;t_all(5,:)];


% %%calculate the length for each cross section and find out the length for
%%each value of t
three_cross_sections = [coordinates_UAF coordinates_UAM coordinates_E coordinates_LAM coordinates_LAF];

[row col]=size(three_cross_sections);
result = zeros(row,col);
count = 0;
for i=1:3:col
    count = count+1;
    if i==1
        [rowbez colbez]=size(bezier);
    end
    [bezier] = create_bezier(three_cross_sections(1:row,i:i+2));
    lngth_cum = continuous_subdivision(bezier);
    [rowlngth collngth]=size(lngth_cum);
    total_cross_sec_lngth = lngth_cum(rowlngth,2);
    lngth_increment=lngth_cum(rowlngth,2)/18;
    loc_bezier_for_t = bezier_loc_all((count-1)*2+1,:);
    lngth_cum_partial = lngth_cum;
    [tf loc_start] = ismember((loc_bezier_for_t-4),lngth_cum_partial(:,3));
    [tf loc_end]   = ismember(loc_bezier_for_t,lngth_cum_partial(:,3));
    t = t_all(count,:);
    lngth_cum_partial = lngth_cum(loc_start+1:loc_end,:);
    [rowlngthpartial collngthpartial] = size(lngth_cum_partial);

    for j=1:rowlngthpartial
        if lngth_cum_partial(j,1)>t 
           if j==1
              line = 1
           else
              line = j-1
           end
           break
        end
    end

    if line==1
       ratio = t/lngth_cum_partial(1,1);
       lngth = lngth_cum(loc_start,2)+(lngth_cum_partial(1,2)-lngth_cum(loc_start,2))*ratio;
    else
        ratio = (t-lngth_cum_partial(line,1))/(lngth_cum_partial(line+1,1) - lngth_cum_partial(line,1));
       lngth = lngth_cum_partial(line,2)+(lngth_cum_partial(line+1,2)-lngth_cum_partial(line,2))*ratio;
    end
    
    added = lngth_cum(loc_start+1:loc_end,:);
    lngth_cum=[added;lngth_cum(loc_end+1:rowlngth,:);lngth_cum(1:loc_start,:)];
    
    count_2 = 0;
    for k=1:18
        if k == 18
           lngth_cum = [lngth_cum;added];
        end
        count_2 = count_2+1;
        lngth=lngth+lngth_increment;
        if lngth>=total_cross_sec_lngth
           lngth = lngth-total_cross_sec_lngth;
        end
        if k==1
           start_m = loc_bezier_for_t;
        elseif m == (rowbez-3)
           start_m = 1;  
        else
           start_m = m;
        end
        for m=start_m:4:72
            [tf loc_search_end] = ismember(m,lngth_cum(:,3));
            if k==1 & m==start_m
                loc_search_start = 1;
                val_lngth_min = lngth_cum(loc_search_start,2);
                val_lngth_max = lngth_cum(loc_search_end,2);
            elseif  m==1
                [tf loc_search_start] = ismember((rowbez-3),lngth_cum(:,3));
                val_lngth_min = lngth_cum(loc_search_start+1,2);
                val_lngth_max = lngth_cum(loc_search_end,2);
            else
                [tf loc_search_start] = ismember(m-4,lngth_cum(:,3));
                val_lngth_min = lngth_cum(loc_search_start,2);
                val_lngth_max = lngth_cum(loc_search_end,2);
            end  
            if lngth>=val_lngth_min & lngth<=val_lngth_max
               if loc_search_end < loc_search_start %in the case where the value is located between the last point and the first point
               lngth_cum_partial_2 = lngth_cum(loc_search_end-3:loc_search_end,:);     
               else
               lngth_cum_partial_2 = lngth_cum(loc_search_start+1:loc_search_end,:);  
               end
               [rowlngthpartial_2 collngthpartial_2] = size(lngth_cum_partial_2);
               for n=1:rowlngthpartial_2
                  if lngth_cum_partial_2(n,2)>lngth
                    if n==1
                        line_2 = 0;
                    else
                        line_2 = n-1;
                    end
                    break    
                  end
               end
               break
            end            
        end
        
        if line_2==0
            if lngth_cum(loc_search_start,2)<=lngth
                ratio = (lngth-lngth_cum(loc_search_start-1,2))/(lngth_cum_partial_2(1,2)-lngth_cum(loc_search_start-1,2));
                u = (lngth_cum_partial_2(1,1))*ratio;
            else

                ratio = lngth/(lngth_cum_partial_2(1,2));
                u = (lngth_cum_partial_2(1,1))*ratio;
            end    
        else
            ratio = (lngth-lngth_cum_partial_2(line_2,2))/(lngth_cum_partial_2(line_2+1,2) - lngth_cum_partial_2(line_2,2));
            u = lngth_cum_partial_2(line_2,1)+(lngth_cum_partial_2(line_2+1,1)-lngth_cum_partial_2(line_2,1))*ratio;
        end
        bezier_partial = bezier(lngth_cum_partial_2(1,3):(lngth_cum_partial_2(1,3)+3),:);
        [coefficient]=calculate_poly_bezier(bezier_partial);
        result(count_2,i:i+2) = transpose(coefficient*[u^3;u^2;u;1]);
    end
end    


clear lngth_cum_all lngth_cum

[rowcoord col]  = size(result); 
for h=1:2
    if h==1
       start_index = 1;
       three_cross_sections_partial =  [result(:,1:3) result(:,4:6) result(:,7:9)];
    else
       index_bezier = [start_index row];
       start_index = row+1;
       three_cross_sections_partial =  [result(:,7:9) result(:,10:12) result(:,13:15)];
    end
    for i=1:rowcoord
        [bezier,knots,t_parameter]=bspline_interpolation_quadratic([three_cross_sections_partial(i,1:3);three_cross_sections_partial(i,4:6);three_cross_sections_partial(i,7:9)]);
        [lngth_cum] = continuous_subdivision_quadratic(bezier);
        [rowlngth col] = size(lngth_cum);
        lngth_cum = [lngth_cum i*ones(rowlngth,1) h*ones(rowlngth,1)];
        [rowbez col] = size(bezier);
        bezier = [bezier i*ones(rowbez,1)];
        if h==1 & i==1
            bezier_all = bezier;
            lngth_cum_all = lngth_cum;
        else
            lngth_cum_all = [lngth_cum_all;lngth_cum];
            bezier_all = [bezier_all;bezier];
        end
    end
    [row col] = size(bezier_all);
end

index_bezier = [index_bezier;start_index row];

for h=1:2
    if k==1 & h==1
       factor = 1/3;
    elseif k==1 & h==2
       factor = 2/3;
    elseif k==2 & h==1
        factor = 2/3;
    elseif k==2 & h==2
        factor = 1/3;
    end        
    bezier_all_partial = bezier_all(index_bezier(h,1):index_bezier(h,2),:);
    if h==1
    [tf h_previous]= ismember(h,lngth_cum_all(:,5));
    lngth_cum_all_partial = lngth_cum_all(1:h_previous,:)  ;
    else
    start_h = h_previous+1;
    [tf h_previous]= ismember(h,lngth_cum_all(:,5));
    lngth_cum_all_partial = lngth_cum_all(start_h:h_previous,:) ;     
    end
    count_1 = 0;
    count_2 = 0;
    for i=1:rowcoord
    	[tf loc_end] = ismember(i,lngth_cum_all_partial(:,4));
    	if i==1
       		loc_start = 1 ;
       		loc_start_bezier = 1;
        else
       		[tf loc_start_bezier] = ismember((i-1),bezier_all_partial(:,4));
       		loc_start_bezier = loc_start_bezier+1;
       		[tf loc_start] = ismember((i-1),lngth_cum_all_partial(:,4));
       	loc_start = loc_start+1;
        end
    	lngth_cum_all_partial_2 = lngth_cum_all_partial(loc_start:loc_end,:);
    	if h==1
            [tf loc_start]= ismember(1,lngth_cum_all_partial_2(:,3));
            [loc_end unused] = size(lngth_cum_all_partial_2);
            origin_lngth = lngth_cum_all_partial_2(loc_start,2);
            lngth_total = lngth_cum_all_partial_2(loc_end,2)-lngth_cum_all_partial_2(loc_start,2);
    
            lngth_partial = factor*lngth_total+origin_lngth;
    		lngth_cum_all_partial_2 = lngth_cum_all_partial_2(loc_start+1:loc_end,:);
        else            
            [tf loc_start]= ismember(1,lngth_cum_all_partial_2(:,3));
            [loc_end unused] = size(lngth_cum_all_partial_2);
            origin_lngth = 0;
            lngth_total = lngth_cum_all_partial_2(loc_start,2);
     
            lngth_partial = factor*lngth_total;
            lngth_cum_all_partial_2 = lngth_cum_all_partial_2(1:loc_start,:);
        end
    	[loc_end unused] = size(lngth_cum_all_partial_2);
    	[tf loc_end_bezier] = ismember(i,bezier_all_partial(:,4));
    	bezier_all_partial_2 = bezier_all_partial(loc_start_bezier:loc_end_bezier,:);  
        for j=1:loc_end
            if lngth_cum_all_partial_2(j,2)>lngth_partial                
                if j==1
                    ratio = (lngth_partial-origin_lngth)/(lngth_cum_all_partial_2(j,2)-origin_lngth);
                    u = ratio*(lngth_cum_all_partial_2(j,1));
                else
                    ratio = (lngth_partial-lngth_cum_all_partial_2(j-1,2))/(lngth_cum_all_partial_2(j,2)-lngth_cum_all_partial_2(j-1,2));
                    u = ratio*(lngth_cum_all_partial_2(j,1)-lngth_cum_all_partial_2(j-1,1))+lngth_cum_all_partial_2(j-1,1) ;
                end
                if h==1 
                    chosen_bezier = bezier_all_partial_2(4:6,1:3);
                else
                    chosen_bezier = bezier_all_partial_2(1:3,1:3);
                end
                [coefficient]=calculate_poly_bezier_quadratic(chosen_bezier);
                additional_cross_sections(i,1:3) = transpose(coefficient*[u^2;u;1]);
                break
            end
        end
    end
    if h==1 
        additional_cross_sections_all = additional_cross_sections;
    else
        additional_cross_sections_all = [additional_cross_sections_all;additional_cross_sections];
    end
end
    if k ==1
    added_cross_sections = additional_cross_sections_all;;
    else
    added_cross_sections = [added_cross_sections;additional_cross_sections_all];;
    end
end


[row col] = size(added_cross_sections)
added_cross_sections = [added_cross_sections(1:row/4,:);added_cross_sections(row/2+1:3*row/4,:);added_cross_sections(3*row/4+1:row,:);added_cross_sections(row/4+1:row/2,:)];

load('C:\MATLAB7\work\OUTPUT\profile_coordinates_modified_any.mat')
load('C:\MATLAB7\work\OUTPUT\index_profile.mat')
[profile_additional_points] = bezier_for_profile_version_2;

load('C:\MATLAB7\work\OUTPUT\any_angle.mat')
if any_angle<135
[val index_max] = max(added_cross_sections(1:18,1));
[val index_min] = min(added_cross_sections(1:18,1));
additional_CS_1 = [added_cross_sections(10:index_max,:);profile_additional_points(1,:);added_cross_sections(index_min:9,:)]
[val index_max] = max(added_cross_sections(19:36,1));
[val index_min] = min(added_cross_sections(19:36,1));
additional_CS_2 = [added_cross_sections(28:index_max+18,:);profile_additional_points(2,:);added_cross_sections(index_min+18:27,:)]
[val index_max] = max(added_cross_sections(37:54,1));
[val index_min] = min(added_cross_sections(37:54,1));
additional_CS_3 = [added_cross_sections(46:index_max+36,:);profile_additional_points(3,:);added_cross_sections(index_min+36:45,:)]
[val index_max] = max(added_cross_sections(55:72,1));
[val index_min] = min(added_cross_sections(55:72,1));
additional_CS_4 = [added_cross_sections(64:index_max+54,:);profile_additional_points(4,:);added_cross_sections(index_min+54:63,:)]
else
additional_CS_1 = [added_cross_sections(10:18,:);profile_additional_points(1,:);added_cross_sections(1:9,:)]
additional_CS_2 = [added_cross_sections(28:36,:);profile_additional_points(2,:);added_cross_sections(19:27,:)]
additional_CS_3 = [added_cross_sections(46:54,:);profile_additional_points(3,:);added_cross_sections(37:45,:)]
additional_CS_4 = [added_cross_sections(64:72,:);profile_additional_points(4,:);added_cross_sections(55:63,:)]
end

coordinates_UAF = [result(10:18,1:3);result(1:9,1:3)]
coordinates_UAM = [result(10:18,4:6);result(1:9,4:6)]
coordinates_E = [result(10:18,7:9);result(1:9,7:9)]
coordinates_LAM = [result(10:18,10:12);result(1:9,10:12)]
coordinates_LAF = [result(10:18,13:15);result(1:9,13:15)]

