function [new_CrossSec_135,new_CrossSec_90,new_CrossSec_max] = adjusting_CrossSec_for_front_view_version_2(new_CrossSec_135,new_CrossSec_90,new_CrossSec_max,UAF_3D,UAM_3D,E_3D,LAM_3D,LAF_3D,distances_135,distances_90,distances_max,new_UAF_CS,E_CS,LAF_CS,E_CS_all,LAF_CS_all,profile_in, profile_out) 


[CS_bspline_neu,center_neu] = creating_CS_bspline(UAF_3D(:,1:3),UAM_3D(:,1:3),E_3D(:,1:3),LAM_3D(:,1:3),LAF_3D(:,1:3));
[CS_bspline_neu_max_front] = determining_front_view_inside_outside_points([CS_bspline_neu(:,1:2) CS_bspline_neu(:,4:5) CS_bspline_neu(:,7:8) CS_bspline_neu(:,10:11) CS_bspline_neu(:,13:14)],new_UAF_CS,E_CS,LAF_CS);
[CS_bspline_135,center_135] = creating_CS_bspline(new_CrossSec_135(:,1:3),new_CrossSec_135(:,4:6),new_CrossSec_135(:,7:9),new_CrossSec_135(:,10:12),new_CrossSec_135(:,13:15));
[CS_bspline_135_max_front] = determining_front_view_inside_outside_points([CS_bspline_135(:,1:2) CS_bspline_135(:,4:5) CS_bspline_135(:,7:8) CS_bspline_135(:,10:11) CS_bspline_135(:,13:14)],new_UAF_CS,E_CS_all(1:3,:),LAF_CS_all(1:3,:));
[CS_bspline_90,center_90] = creating_CS_bspline(new_CrossSec_90(:,1:3),new_CrossSec_90(:,4:6),new_CrossSec_90(:,7:9),new_CrossSec_90(:,10:12),new_CrossSec_90(:,13:15));
[CS_bspline_90_max_front] = determining_front_view_inside_outside_points([CS_bspline_90(:,1:2) CS_bspline_90(:,4:5) CS_bspline_90(:,7:8) CS_bspline_90(:,10:11) CS_bspline_90(:,13:14)],new_UAF_CS,E_CS_all(4:6,:),LAF_CS_all(4:6,:));
[CS_bspline_max,center_max] = creating_CS_bspline(new_CrossSec_max(:,1:3),new_CrossSec_max(:,4:6),new_CrossSec_max(:,7:9),new_CrossSec_max(:,10:12),new_CrossSec_max(:,13:15));
[CS_bspline_max_max_front] = determining_front_view_inside_outside_points([CS_bspline_max(:,1:2) CS_bspline_max(:,4:5) CS_bspline_max(:,7:8) CS_bspline_max(:,10:11) CS_bspline_max(:,13:14)],new_UAF_CS,E_CS_all(7:9,:),LAF_CS_all(7:9,:));

%% 2. Find the distance with the bone for UAF-UAM-E

[UAF_length_neu,UAM_length_neu,E_length_neu,bone_neu_points] = CS_length_front_view(CS_bspline_neu_max_front,new_UAF_CS,E_CS);
[UAF_length_135,UAM_length_135,E_length_135,bone_135_points] = CS_length_front_view(CS_bspline_135_max_front,new_UAF_CS,E_CS_all(1:3,:));
[UAF_length_90,UAM_length_90,E_length_90,bone_90_points] = CS_length_front_view(CS_bspline_90_max_front,new_UAF_CS,E_CS_all(4:6,:));
[UAF_length_max,UAM_length_max,E_length_max,bone_max_points] = CS_length_front_view(CS_bspline_max_max_front,new_UAF_CS,E_CS_all(7:9,:));

%% 135
UAF_135_bone_point = distances_135(1,1)*new_UAF_CS(2,:);
UAM_135_bone_point = distances_135(2,1)*new_UAF_CS(2,:);
[UAF_int_point_in_135,UAF_int_point_out_135] = calculate_profile_intersection_based_on_bone_points_original(UAF_135_bone_point,profile_in,profile_out);
[UAM_int_point_in_135,UAM_int_point_out_135] = calculate_profile_intersection_based_on_bone_points_original(UAM_135_bone_point,profile_in,profile_out);

%% 90
UAF_90_bone_point = distances_90(1,1)*new_UAF_CS(2,:);
UAM_90_bone_point = distances_90(2,1)*new_UAF_CS(2,:);
[UAF_int_point_in_90,UAF_int_point_out_90] = calculate_profile_intersection_based_on_bone_points_original(UAF_90_bone_point,profile_in,profile_out);
[UAM_int_point_in_90,UAM_int_point_out_90] = calculate_profile_intersection_based_on_bone_points_original(UAM_90_bone_point,profile_in,profile_out);

%% max
UAF_max_bone_point = distances_max(1,1)*new_UAF_CS(2,:)
UAM_max_bone_point = distances_max(2,1)*new_UAF_CS(2,:)
[UAF_int_point_in_max,UAF_int_point_out_max] = calculate_profile_intersection_based_on_bone_points_original(UAF_max_bone_point,profile_in,profile_out)
[UAM_int_point_in_max,UAM_int_point_out_max] = calculate_profile_intersection_based_on_bone_points_original(UAM_max_bone_point,profile_in,profile_out)


% %%% 3. Translating the CS (UAF, UAM, and E) to the middle of CS neu distance
UAF_length_neu = UAF_int_point_in_135-UAF_int_point_out_135;
UAF_length_neu = dot(UAF_length_neu,UAF_length_neu)^0.5;
UAM_length_neu = UAM_int_point_in_135-UAM_int_point_out_135;
UAM_length_neu = dot(UAM_length_neu,UAM_length_neu)^0.5;
CS_bspline_neu_max_front(1,1:2) = UAF_int_point_in_135(1,1:2);
CS_bspline_neu_max_front(2,1:2) = UAM_int_point_in_135(1,1:2);
[new_CrossSec_135] = CS_front_translation(UAF_length_135,UAF_length_neu,CS_bspline_neu_max_front(1,1:2),CS_bspline_135_max_front(1,1:2),new_UAF_CS,new_CrossSec_135,[1:3]);
[new_CrossSec_135] = CS_front_translation(UAM_length_135,UAM_length_neu,CS_bspline_neu_max_front(2,1:2),CS_bspline_135_max_front(2,1:2),new_UAF_CS,new_CrossSec_135,[4:6]);
[new_CrossSec_135] = CS_front_translation(E_length_135,E_length_neu,CS_bspline_neu_max_front(3,1:2),CS_bspline_135_max_front(3,1:2),E_CS_all(1:3,:),new_CrossSec_135,[7:9]);


UAF_length_neu = UAF_int_point_in_90-UAF_int_point_out_90;
UAF_length_neu = dot(UAF_length_neu,UAF_length_neu)^0.5;
UAM_length_neu = UAM_int_point_in_90-UAM_int_point_out_90;
UAM_length_neu = dot(UAM_length_neu,UAM_length_neu)^0.5;
CS_bspline_neu_max_front(1,1:2) = UAF_int_point_in_90(1,1:2);
CS_bspline_neu_max_front(2,1:2) = UAM_int_point_in_90(1,1:2);
[new_CrossSec_90] = CS_front_translation(UAF_length_90,UAF_length_neu,CS_bspline_neu_max_front(1,1:2),CS_bspline_90_max_front(1,1:2),new_UAF_CS,new_CrossSec_90,[1:3]);
[new_CrossSec_90] = CS_front_translation(UAM_length_90,UAM_length_neu,CS_bspline_neu_max_front(2,1:2),CS_bspline_90_max_front(2,1:2),new_UAF_CS,new_CrossSec_90,[4:6]);
[new_CrossSec_90] = CS_front_translation(E_length_90,E_length_neu,CS_bspline_neu_max_front(3,1:2),CS_bspline_90_max_front(3,1:2),E_CS_all(4:6,:),new_CrossSec_90,[7:9]);


UAF_length_neu = UAF_int_point_in_max-UAF_int_point_out_max;
UAF_length_neu = dot(UAF_length_neu,UAF_length_neu)^0.5;
UAM_length_neu = UAM_int_point_in_max-UAM_int_point_out_max;
UAM_length_neu = dot(UAM_length_neu,UAM_length_neu)^0.5;
CS_bspline_neu_max_front(1,1:2) = UAF_int_point_in_max(1,1:2);
CS_bspline_neu_max_front(2,1:2) = UAM_int_point_in_max(1,1:2);
[new_CrossSec_max] = CS_front_translation(UAF_length_max,UAF_length_neu,CS_bspline_neu_max_front(1,1:2),CS_bspline_max_max_front(1,1:2),new_UAF_CS,new_CrossSec_max,[1:3]);
[new_CrossSec_max] = CS_front_translation(UAM_length_max,UAM_length_neu,CS_bspline_neu_max_front(2,1:2),CS_bspline_max_max_front(2,1:2),new_UAF_CS,new_CrossSec_max,[4:6]);
[new_CrossSec_max] = CS_front_translation(E_length_max,E_length_neu,CS_bspline_neu_max_front(3,1:2),CS_bspline_max_max_front(3,1:2),E_CS_all(7:9,:),new_CrossSec_max,[7:9]);


%%% 4. Translating LAM and LAF according to E

[bspline_max_neu_new_basis,E_new_basis_neu,LAM_new_basis_neu,LAF_new_basis_neu] = determining_front_view_lower_arm([UAF_3D(:,1:3) UAM_3D(:,1:3) E_3D(:,1:3) LAM_3D(:,1:3) LAF_3D(:,1:3)],LAF_CS);
[bspline_max_135_new_basis,E_new_basis_135,LAM_new_basis_135,LAF_new_basis_135] = determining_front_view_lower_arm(new_CrossSec_135,LAF_CS_all(1:3,:));
[bspline_max_90_new_basis,E_new_basis_90,LAM_new_basis_90,LAF_new_basis_90] = determining_front_view_lower_arm(new_CrossSec_90,LAF_CS_all(4:6,:));
[bspline_max_max_new_basis,E_new_basis_max,LAM_new_basis_max,LAF_new_basis_max] = determining_front_view_lower_arm(new_CrossSec_max,LAF_CS_all(7:9,:));

E_length_neu = bspline_max_neu_new_basis(1,3) - bspline_max_neu_new_basis(1,1);
LAM_length_neu = bspline_max_neu_new_basis(2,3) - bspline_max_neu_new_basis(2,1);
LAF_length_neu = bspline_max_neu_new_basis(3,3) - bspline_max_neu_new_basis(3,1);

%%% 135
E_length_135 = bspline_max_135_new_basis(1,3) - bspline_max_135_new_basis(1,1);
LAM_length_135 = bspline_max_135_new_basis(2,3) - bspline_max_135_new_basis(2,1);
LAF_length_135 = bspline_max_135_new_basis(3,3) - bspline_max_135_new_basis(3,1);
[bspline_max_neu_new_basis_translated_135] = first_translation_of_lower_new_basis_FDM_phase_1(E_length_135,E_length_neu,bspline_max_neu_new_basis,bspline_max_135_new_basis);
[LAM_new_basis_135,LAF_new_basis_135] = final_translation_of_lower_new_basis(LAM_length_135,LAM_length_neu,LAF_length_135,LAF_length_neu,LAM_new_basis_135,LAF_new_basis_135,bspline_max_neu_new_basis_translated_135,bspline_max_135_new_basis);
new_CrossSec_135(:,10:12) = LAM_new_basis_135*LAF_CS_all(1:3,:);
new_CrossSec_135(:,13:15) = LAF_new_basis_135*LAF_CS_all(1:3,:);

%%% 90
E_length_90 = bspline_max_90_new_basis(1,3) - bspline_max_90_new_basis(1,1);
LAM_length_90 = bspline_max_90_new_basis(2,3) - bspline_max_90_new_basis(2,1);
LAF_length_90 = bspline_max_90_new_basis(3,3) - bspline_max_90_new_basis(3,1);
[bspline_max_neu_new_basis_translated_90] = first_translation_of_lower_new_basis_FDM_phase_1(E_length_90,E_length_neu,bspline_max_neu_new_basis,bspline_max_90_new_basis);
[LAM_new_basis_90,LAF_new_basis_90] = final_translation_of_lower_new_basis(LAM_length_90,LAM_length_neu,LAF_length_90,LAF_length_neu,LAM_new_basis_90,LAF_new_basis_90,bspline_max_neu_new_basis_translated_90,bspline_max_90_new_basis);
new_CrossSec_90(:,10:12) = LAM_new_basis_90*LAF_CS_all(4:6,:);
new_CrossSec_90(:,13:15) = LAF_new_basis_90*LAF_CS_all(4:6,:);

%%% max
E_length_max = bspline_max_max_new_basis(1,3) - bspline_max_max_new_basis(1,1);
LAM_length_max = bspline_max_max_new_basis(2,3) - bspline_max_max_new_basis(2,1);
LAF_length_max = bspline_max_max_new_basis(3,3) -  bspline_max_max_new_basis(3,1);
[bspline_max_neu_new_basis_translated_max] = first_translation_of_lower_new_basis_FDM_phase_1(E_length_max,E_length_neu,bspline_max_neu_new_basis,bspline_max_max_new_basis);
[LAM_new_basis_max,LAF_new_basis_max] = final_translation_of_lower_new_basis(LAM_length_max,LAM_length_neu,LAF_length_max,LAF_length_neu,LAM_new_basis_max,LAF_new_basis_max,bspline_max_neu_new_basis_translated_max,bspline_max_max_new_basis);
new_CrossSec_max(:,10:12) = LAM_new_basis_max*LAF_CS_all(7:9,:);
new_CrossSec_max(:,13:15) = LAF_new_basis_max*LAF_CS_all(7:9,:);