function [new_UAF_CS, LAF_CS_any, E_CS_any, profile_coordinates_any,all_Cross_Sec_coordinates,distances_any,carrying_angle_any] = calculation_of_each_key_posture_FDM_validation_phase_1(arm_angle_ext,arm_angle_flex,any_angle,joint_max,arm_angle_range,joint_neutral,subject_filename,length_UA_LA,input_skeleton,UAF_CS,E_CS,LAF_CS)

if (any_angle>=135)
    index_number_for_file = [1 2];
    ratio = (any_angle-arm_angle_range(1,1))/(135-arm_angle_range(1,1));
elseif (any_angle>90 & any_angle<135)
    index_number_for_file = [2 3];
    ratio = (any_angle-135)/(90-135);
else
    index_number_for_file = [3 4];
    ratio = (any_angle-90)/(arm_angle_range(2,1)-90);
end

cross_sec_mag_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Cross Section Magnitudes\*.txt')) ;
profile_mag_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Profile Magnitudes\*.txt')) ;
cross_sec_loc_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Cross Section Location\*.txt')) ;
[row col] = size(cross_sec_mag_files);
count = 0;
magnitude_CrossSec = zeros(80,2);
for i = 1:row
    file_to_read = (cross_sec_mag_files(i).name)
    if i == 1
       index_of_file = 1;
    else
       index_of_file = count + 1;
    end
    index_hyphen = findstr(file_to_read,'_');
    file_to_match = file_to_read(1,1:(index_hyphen-1));
    string_comparison = strcmp(subject_filename,file_to_match);
    index_to_match = str2num(file_to_read(1,index_hyphen+1:index_hyphen+2));
    if (string_comparison == 1 & ismember(index_to_match,index_number_for_file))
        count = count + 1;
        fid = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Cross Section Magnitudes\',file_to_read)));
        fid2 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Profile Magnitudes\',file_to_read)));
        fid3 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Cross Section Location\',file_to_read)));
        count_line = 0;
        while feof(fid) == 0
            count_line = count_line + 1;
            tline = fgetl(fid);
            magnitude_CrossSec(count_line, count) = str2num(tline);            
            if count_line == 80
            break
            fclose(fid);
            end
        end
        
        count_line2 = 0;
        while feof(fid2) == 0
            count_line2 = count_line2 + 1;
            tline2 = fgetl(fid2);
            profile_distances(count_line2, count) = str2num(tline2);
        end
        fclose(fid2);
        
        while feof(fid3) == 0
            tline3 = fgetl(fid3);
            cross_sec_loc(1:5, count) = str2num(tline3);
        end
        fclose(fid3);        
    end 
    if count == 2, break
    end
end

base_magnitude = [magnitude_CrossSec(1:16,1) magnitude_CrossSec(17:32,1) magnitude_CrossSec(33:48,1) magnitude_CrossSec(49:64,1) magnitude_CrossSec(65:80,1)] ;
upper_bound_magnitude = [magnitude_CrossSec(1:16,2) magnitude_CrossSec(17:32,2) magnitude_CrossSec(33:48,2) magnitude_CrossSec(49:64,2) magnitude_CrossSec(65:80,2)] ;
base_distance = profile_distances(:,1);
upper_bound_distance = profile_distances(:,2);

UAF_distance_any = ( cross_sec_loc(1,2)-cross_sec_loc(1,1) )*ratio + cross_sec_loc(1,1);
UAM_distance_any = ( cross_sec_loc(2,2)-cross_sec_loc(2,1) )*ratio + cross_sec_loc(2,1);
LAM_distance_any = ( cross_sec_loc(4,2)-cross_sec_loc(4,1) )*ratio + cross_sec_loc(4,1);
LAF_distance_any = ( cross_sec_loc(5,2)-cross_sec_loc(5,1) )*ratio + cross_sec_loc(5,1);
distances_any = [UAF_distance_any;UAM_distance_any;LAM_distance_any;LAF_distance_any];

normal_plane = cross((input_skeleton(1,:)/length_UA_LA(1,:)),[0 0 1]);
max_carrying_angle = asin(dot(normal_plane,input_skeleton(3,:))/(dot(normal_plane,normal_plane)^0.5*length_UA_LA(2,:)))*180/pi; 

length_UA_LA_max = [(joint_max(1,1)^2+joint_max(1,2)^2+joint_max(1,3)^2)^0.5;   (joint_max(1,4)^2+joint_max(1,5)^2+joint_max(1,6)^2)^0.5];
input_skeleton_max = [joint_max(1,1:3);0 0 0;joint_max(1,4:6)];
normal_plane = cross((input_skeleton_max(1,:)/length_UA_LA_max(1,:)),[0 0 1]);
min_carrying_angle = asin(dot(normal_plane,input_skeleton_max(3,:))/(dot(normal_plane,normal_plane)^0.5*length_UA_LA_max(2,:)))*180/pi; 
carrying_angle = [min_carrying_angle max_carrying_angle];

%% 9. calculate the carrying angle, flexion angle, CS for the wanted angle
if abs(any_angle - arm_angle_ext)>0.001
    %% part 1
    new_X = cross(UAF_CS(2,:),[0 0 1]);
    new_X = new_X/(dot(new_X,new_X)^0.5);
    new_Z = cross(new_X,UAF_CS(2,:));
    new_Z = new_Z/(dot(new_Z,new_Z)^0.5);
    new_UAF_CS = [new_X;UAF_CS(2,:);new_Z];

    %% part 2
    [carrying_angle_any,flexion_angle_any] = calculate_carrying_and_flexion_FDM_validation_phase_1(carrying_angle,arm_angle_range,any_angle);

    %% part 3
    [euler_matrix] = create_euler_matrix(flexion_angle_any,carrying_angle_any,0);
    new_vector_LA_any = [0 -1 0]*euler_matrix*new_UAF_CS;

    %% part 4
    [LAF_CS_any]= local_CS_other_key_postures (new_vector_LA_any);

    %% part 5
    [E_CS_any] = determine_E_CS_for_any_posture(new_UAF_CS(2,:),new_vector_LA_any);
else
    new_UAF_CS = UAF_CS;
    LAF_CS_any = LAF_CS;
    E_CS_any = E_CS;
    carrying_angle_any = max_carrying_angle;
end

load ('C:\MATLAB7\work\INITIAL INPUT\all_locations_fda')

LAF_W = find(all_locations_fda(2,:) == 6);
S_UAF = find(all_locations_fda(2,:) == 1);
[unused col_LAF_W] = size(LAF_W);
[unused col_S_UAF] = size(S_UAF);

S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_any;
UAM = UAF_CS(2,2:3)*UAM_distance_any;
LAM = LAF_CS_any(2,2:3)*LAM_distance_any;
LAF = LAF_CS_any(2,2:3)*LAF_distance_any;
W = LAF_CS_any(2,:)*length_UA_LA(2,:);
joint_length_any = [(dot(S(2:3),S(2:3)))^0.5  (dot(UAF,UAF))^0.5   (dot(UAM,UAM))^0.5  0  (dot(LAM,LAM))^0.5   (dot(LAF,LAF))^0.5 (dot(W(2:3),W(2:3)))^0.5]; 

arm_vector_any = [S W];

[sampling_all_any]= vector_prev_segment(joint_length_any,arm_vector_any,all_locations_fda);  
[row_sampled unused] = size(sampling_all_any);

for j=1:row_sampled
    total_distance =  ratio*(upper_bound_distance(j,1)-base_distance(j,1))+base_distance(j,1);
    profile_coordinates(j,:) = sampling_all_any(j,1:2)+sampling_all_any(j,3:4)*total_distance;
    list_total_distance(j,:) = total_distance;
end

reduced_profile_coordinates = profile_coordinates((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
[row_reduced_sampled unused] = size(reduced_profile_coordinates);

reduced_profile_coordinates_any = [zeros(row_reduced_sampled,1) reduced_profile_coordinates];
profile_coordinates_any = [zeros(row_sampled,1) profile_coordinates];

load('C:\MATLAB7\work\INITIAL INPUT\unit_vector_FDM_phase_1.mat')

if (any_angle<=91 & any_angle>=36)
    for i = 1:5
        if i <= 2
            CS_transform = new_UAF_CS;
            translation_distance = distances_any(i,:);
        elseif i==3
            CS_transform = E_CS_any;
            translation_distance = 0;
        else
            CS_transform = LAF_CS_any;
            translation_distance = distances_any(i-1,:);
        end        
        
        if i ~= 3
            for j=1:16  
                total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
                Cross_Sec_coordinates_scaled(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude;
            end              
            for j=1:16 
                Cross_Sec_coordinates(j,:) = Cross_Sec_coordinates_scaled(j,:)*CS_transform + CS_transform(2,:)*translation_distance;
            end
            
        else         
            for j=1:16
                total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
                Cross_Sec_coordinates(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude*CS_transform + CS_transform(2,:)*translation_distance;
            end
        end
        
        if i==1
            all_Cross_Sec_coordinates = Cross_Sec_coordinates;
        else
            all_Cross_Sec_coordinates = [all_Cross_Sec_coordinates Cross_Sec_coordinates];
        end
        
    end    
else
    for i = 1:5
        if i <= 2
            CS_transform = new_UAF_CS;
            translation_distance = distances_any(i,:);
        elseif i==3
            CS_transform = E_CS_any;
            translation_distance = 0;
        else
            CS_transform = LAF_CS_any;
            translation_distance = distances_any(i-1,:);
        end 
        for j=1:16
            total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
            Cross_Sec_coordinates(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude*CS_transform + CS_transform(2,:)*translation_distance;
        end
        if i==1
            all_Cross_Sec_coordinates = Cross_Sec_coordinates;
        else
            all_Cross_Sec_coordinates = [all_Cross_Sec_coordinates Cross_Sec_coordinates];
        end
    end
    all_Cross_Sec_coordinates
end
