% function [] = profile_any_posture_version_2()

%% for UAF and LAF, its location varies linearly.
%% for UAM and LAM, its location varies based on UAM and LAM equation.
%% Refer to doc about felsh deformation area determination.
%% angle_at_max = 35 degree (DEFAULT)
clear all

%% 1. requesting subject name or ID
subject_filename = input ('Subject ID:', 's');

%% 2. reading the file for the arm range (contains the fully extended and
%% flexed angle for the arm)
arm_angle_range_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Arm Angle Range\*.txt')); 
[row col] = size(arm_angle_range_files);

for i = 1:row
    file_to_read = (arm_angle_range_files(i).name);
    file_to_match = strcat(subject_filename,'.txt');
    string_comparison = strcmp(file_to_read,file_to_match);
    if string_comparison == 1
    fid = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Arm Angle Range\',file_to_read)));
    arm_angle_range = fscanf(fid,'%g %g ',[2,inf]);
    fclose(fid);
    fid2 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Joint length 3D\',file_to_read)));
    joint_neutral = fscanf(fid2,'%g %g %g %g %g %g',[6,inf]);
    joint_neutral = joint_neutral'
    fclose(fid2)
    fid3 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Joint Coordinates Maximum Flexion\',file_to_read)));
    joint_max = fscanf(fid3,'%g %g %g %g %g %g',[6,inf]);
    joint_max = joint_max'
    fclose(fid3)
    profile_in_read = strcat(subject_filename,'_1.txt')
    fid4 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Profile Front View\',profile_in_read)));
    profile_in = fscanf(fid4, '%g %g %g',[3,inf]);
    profile_in = profile_in'
    fclose(fid4)
    profile_out_read = strcat(subject_filename,'_2.txt')
    fid5 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Profile Front View\',profile_out_read)));
    profile_out = fscanf(fid5, '%g %g %g',[3,inf]);
    profile_out = profile_out'
    fclose(fid5)
    break
    end
end

%% 3. calculating CS for joint neutral and skeleton length
length_UA_LA = [(joint_neutral(1,1)^2+joint_neutral(1,2)^2+joint_neutral(1,3)^2)^0.5;   (joint_neutral(1,4)^2+joint_neutral(1,5)^2+joint_neutral(1,6)^2)^0.5]
input_skeleton = [joint_neutral(1,1:3);0 0 0;joint_neutral(1,4:6)]
[UAF_CS,E_CS,LAF_CS] = determine_local_CS (input_skeleton,length_UA_LA)

%% 4. requesting specific angle to be modelled
arm_angle_ext = num2str(arm_angle_range(1,1));
arm_angle_flex = num2str(arm_angle_range(2,1));

'NEUTRAL______________________________________________________________________________________________________________'
any_angle = arm_angle_range(1,1);
[new_UAF_CS_neutral, LAF_CS_neutral, E_CS_neutral, profile_coordinates_neutral,all_Cross_Sec_coordinates_neutral,distances_neutral,carrying_angle_neutral] = calculation_of_each_key_posture_FDM_validation_phase_1(arm_angle_range(1,1),arm_angle_range(2,1),any_angle,joint_max,arm_angle_range,joint_neutral,subject_filename,length_UA_LA,input_skeleton,UAF_CS,E_CS,LAF_CS);

'135______________________________________________________________________________________________________________'
any_angle = 135;
[new_UAF_CS_135, LAF_CS_135, E_CS_135,profile_coordinates_135,all_Cross_Sec_coordinates_135,distances_135,carrying_angle_135l] = calculation_of_each_key_posture_FDM_validation_phase_1(arm_angle_range(1,1),arm_angle_range(2,1),any_angle,joint_max,arm_angle_range,joint_neutral,subject_filename,length_UA_LA,input_skeleton,UAF_CS,E_CS,LAF_CS);

'90______________________________________________________________________________________________________________'
any_angle = 90;
[new_UAF_CS_90, LAF_CS_90, E_CS_90,profile_coordinates_90,all_Cross_Sec_coordinates_90,distances_90,carrying_angle_90] = calculation_of_each_key_posture_FDM_validation_phase_1(arm_angle_range(1,1),arm_angle_range(2,1),any_angle,joint_max,arm_angle_range,joint_neutral,subject_filename,length_UA_LA,input_skeleton,UAF_CS,E_CS,LAF_CS);

'max______________________________________________________________________________________________________________'
any_angle = arm_angle_range(2,1);
[new_UAF_CS_max, LAF_CS_max, E_CS_max,profile_coordinates_max,all_Cross_Sec_coordinates_max,distances_max,carrying_angle_max] = calculation_of_each_key_posture_FDM_validation_phase_1(arm_angle_range(1,1),arm_angle_range(2,1),any_angle,joint_max,arm_angle_range,joint_neutral,subject_filename,length_UA_LA,input_skeleton,UAF_CS,E_CS,LAF_CS);

UAF_3D = [all_Cross_Sec_coordinates_neutral(:,1:3) all_Cross_Sec_coordinates_135(:,1:3) all_Cross_Sec_coordinates_90(:,1:3)    all_Cross_Sec_coordinates_max(:,1:3)]
UAM_3D = [all_Cross_Sec_coordinates_neutral(:,4:6)  all_Cross_Sec_coordinates_135(:,4:6)  all_Cross_Sec_coordinates_90(:,4:6)   all_Cross_Sec_coordinates_max(:,4:6)]
E_3D = [all_Cross_Sec_coordinates_neutral(:,7:9)  all_Cross_Sec_coordinates_135(:,7:9)  all_Cross_Sec_coordinates_90(:,7:9)  all_Cross_Sec_coordinates_max(:,7:9)]
LAM_3D = [all_Cross_Sec_coordinates_neutral(:,10:12)  all_Cross_Sec_coordinates_135(:,10:12)  all_Cross_Sec_coordinates_90(:,10:12)  all_Cross_Sec_coordinates_max(:,10:12)]
LAF_3D = [all_Cross_Sec_coordinates_neutral(:,13:15)  all_Cross_Sec_coordinates_135(:,13:15)  all_Cross_Sec_coordinates_90(:,13:15)  all_Cross_Sec_coordinates_max(:,13:15)]
new_UAF_CS = new_UAF_CS_neutral
LAF_CS_all = [LAF_CS_135;LAF_CS_90;LAF_CS_max]
E_CS_all = [E_CS_135;E_CS_90;E_CS_max]

%%%_______________________________ SIDE TRANSLATION CS _______________________________
%% ***neu
[CS_bspline_neu,center_neu] = creating_CS_bspline(UAF_3D(:,1:3),UAM_3D(:,1:3),E_3D(:,1:3),LAM_3D(:,1:3),LAF_3D(:,1:3));
[CS_bspline_neu_max] = determining_inside_outside_points([CS_bspline_neu(:,2:3) CS_bspline_neu(:,5:6)  CS_bspline_neu(:,8:9)  CS_bspline_neu(:,11:12)  CS_bspline_neu(:,14:15)],new_UAF_CS,E_CS,LAF_CS);
% [CS_bspline_neu_max_front] = determining_front_view_inside_outside_points([CS_bspline_neu(:,1:2) CS_bspline_neu(:,4:5)  CS_bspline_neu(:,7:8)  CS_bspline_neu(:,10:11)  CS_bspline_neu(:,13:14)], new_UAF_CS, E_CS, LAF_CS);
clear CS_bspline_neu
%% ***135
[CS_bspline_135,center_135] = creating_CS_bspline(UAF_3D(:,4:6),UAM_3D(:,4:6),E_3D(:,4:6),LAM_3D(:,4:6),LAF_3D(:,4:6));
[CS_bspline_135_max] = determining_inside_outside_points([CS_bspline_135(:,2:3) CS_bspline_135(:,5:6)  CS_bspline_135(:,8:9)  CS_bspline_135(:,11:12)  CS_bspline_135(:,14:15)],new_UAF_CS,E_CS_all(1:3,:),LAF_CS_all(1:3,:));
% [CS_bspline_135_max_front] = determining_front_view_inside_outside_points([CS_bspline_135(:,1:2) CS_bspline_135(:,4:5)  CS_bspline_135(:,7:8)  CS_bspline_135(:,10:11)  CS_bspline_135(:,13:14)],new_UAF_CS,E_CS_all(1:3,:),LAF_CS_all(1:3,:));
clear CS_bspline_135
%% *** 90
[CS_bspline_90,center_90] = creating_CS_bspline(UAF_3D(:,7:9),UAM_3D(:,7:9),E_3D(:,7:9),LAM_3D(:,7:9),LAF_3D(:,7:9));
[CS_bspline_90_max] = determining_inside_outside_points([CS_bspline_90(:,2:3) CS_bspline_90(:,5:6)  CS_bspline_90(:,8:9)  CS_bspline_90(:,11:12)  CS_bspline_90(:,14:15)],new_UAF_CS,E_CS_all(4:6,:),LAF_CS_all(4:6,:));
% [CS_bspline_90_max_front] = determining_front_view_inside_outside_points([CS_bspline_90(:,1:2) CS_bspline_90(:,4:5)  CS_bspline_90(:,7:8)  CS_bspline_90(:,10:11)  CS_bspline_90(:,13:14)],new_UAF_CS,E_CS_all(4:6,:),LAF_CS_all(4:6,:));
clear CS_bspline_90
%% ***max
[CS_bspline_max,center_max] = creating_CS_bspline(UAF_3D(:,10:12),UAM_3D(:,10:12),E_3D(:,10:12),LAM_3D(:,10:12),LAF_3D(:,10:12));
[CS_bspline_max_max] = determining_inside_outside_points([CS_bspline_max(:,2:3) CS_bspline_max(:,5:6)  CS_bspline_max(:,8:9)  CS_bspline_max(:,11:12)  CS_bspline_max(:,14:15)],new_UAF_CS,E_CS_all(7:9,:),LAF_CS_all(7:9,:));
% [CS_bspline_max_max_front] = determining_front_view_inside_outside_points([CS_bspline_max(:,1:2) CS_bspline_max(:,4:5)  CS_bspline_max(:,7:8)  CS_bspline_max(:,10:11)  CS_bspline_max(:,13:14)],new_UAF_CS,E_CS_all(7:9,:),LAF_CS_all(7:9,:));
clear CS_bspline_max


%%% ***neu
CrossSec_neu = [UAF_3D(:,1:3) UAM_3D(:,1:3) E_3D(:,1:3) LAM_3D(:,1:3) LAF_3D(:,1:3)];
vector_coordinates_sytem = [new_UAF_CS(3,:)  new_UAF_CS(3,:)  E_CS(3,:)  LAF_CS(3,:)  LAF_CS(3,:)];
bone_coordinates_system = [new_UAF_CS(2,:)  new_UAF_CS(2,:)   0 0 0    LAF_CS(2,:)  LAF_CS(2,:)];
[vector_coordinates_sytem] = modify_vector_coordinates_sytem(vector_coordinates_sytem,profile_coordinates_neutral,CS_bspline_neu_max); %%,distances_135,bone_coordinates_system
[new_CrossSec_neu,new_center_neu,new_CS_bspline_neu_max,translation_magnitude_neu] = translating_CS(profile_coordinates_neutral,vector_coordinates_sytem,CS_bspline_neu_max(:,3:4),CrossSec_neu,CS_bspline_neu_max,center_neu);
%%% *** 135
CrossSec_135 = [UAF_3D(:,4:6) UAM_3D(:,4:6) E_3D(:,4:6) LAM_3D(:,4:6) LAF_3D(:,4:6)];
vector_coordinates_sytem = [new_UAF_CS(3,:)  new_UAF_CS(3,:)  E_CS_all(3,:)  LAF_CS_all(3,:)  LAF_CS_all(3,:)];
bone_coordinates_system = [new_UAF_CS(2,:)  new_UAF_CS(2,:)   0 0 0    LAF_CS_all(2,:)  LAF_CS_all(2,:)];
[vector_coordinates_sytem] = modify_vector_coordinates_sytem(vector_coordinates_sytem,profile_coordinates_135,CS_bspline_135_max); %%,distances_135,bone_coordinates_system
[new_CrossSec_135,new_center_135,new_CS_bspline_135_max,translation_magnitude_135] = translating_CS(profile_coordinates_135,vector_coordinates_sytem,CS_bspline_135_max(:,3:4),CrossSec_135,CS_bspline_135_max,center_135);
%%% *** 90
CrossSec_90 = [UAF_3D(:,7:9) UAM_3D(:,7:9) E_3D(:,7:9) LAM_3D(:,7:9) LAF_3D(:,7:9)];
vector_coordinates_sytem = [new_UAF_CS(3,:)  new_UAF_CS(3,:)  E_CS_all(6,:)  LAF_CS_all(6,:)  LAF_CS_all(6,:)];
bone_coordinates_system = [new_UAF_CS(2,:)  new_UAF_CS(2,:)   0 0 0    LAF_CS_all(5,:)  LAF_CS_all(5,:)];
[vector_coordinates_sytem] = modify_vector_coordinates_sytem(vector_coordinates_sytem,profile_coordinates_90,CS_bspline_90_max); %%,distances_90,bone_coordinates_system
[new_CrossSec_90,new_center_90,new_CS_bspline_90_max,translation_magnitude_90] = translating_CS(profile_coordinates_90,vector_coordinates_sytem,CS_bspline_90_max(:,3:4),CrossSec_90,CS_bspline_90_max,center_90);
%%% *** max
CrossSec_max = [UAF_3D(:,10:12) UAM_3D(:,10:12) E_3D(:,10:12) LAM_3D(:,10:12) LAF_3D(:,10:12)];
vector_coordinates_sytem = [new_UAF_CS(3,:)  new_UAF_CS(3,:)  E_CS_all(9,:)  LAF_CS_all(9,:)  LAF_CS_all(9,:)];
bone_coordinates_system = [new_UAF_CS(2,:)  new_UAF_CS(2,:)   0 0 0    LAF_CS_all(8,:)  LAF_CS_all(8,:)];
[vector_coordinates_sytem] = modify_vector_coordinates_sytem(vector_coordinates_sytem,profile_coordinates_max,CS_bspline_max_max); %%,distances_max,bone_coordinates_system
[new_CrossSec_max,new_center_max,new_CS_bspline_max_max,translation_magnitude_max] = translating_CS_maximum_flexion(profile_coordinates_max,vector_coordinates_sytem,CS_bspline_max_max(:,3:4),CrossSec_max,CS_bspline_max_max,center_max);


% % %%%_______________________________ FRONT TRANSLATION CS (special case for neutral)_______________________________ 
%  
% profile = [profile_in profile_out]
[new_CrossSec_neu] = adjusting_CSneu_front_view_FDM_validation_phase_1(new_CrossSec_neu,distances_neutral, new_UAF_CS_neutral, E_CS_neutral, LAF_CS_neutral, profile_in, profile_out) 


% % %%%_______________________________ FRONT TRANSLATION CS _______________________________
%  
[new_CrossSec_135,new_CrossSec_90,new_CrossSec_max] = adjusting_CrossSec_for_front_view_version_2(new_CrossSec_135,new_CrossSec_90,new_CrossSec_max,new_CrossSec_neu(:,1:3),new_CrossSec_neu(:,4:6),new_CrossSec_neu(:,7:9),new_CrossSec_neu(:,10:12),new_CrossSec_neu(:,13:15),distances_135,distances_90,distances_max,new_UAF_CS,E_CS,LAF_CS,E_CS_all,LAF_CS_all,profile_in, profile_out) 

%%___________________________ FINAL SAMPLING AND SAVING MAGNITUDES ________________________
%% This has to be done once the front and side views of the cross sections
%% are completed
% % % % distance_neutral = [UAF_distance_neutral;UAM_distance_neutral;LAM_distance_neutral;LAF_distance_neutral]
load('C:\MATLAB7\work\INITIAL INPUT\unit_vector.mat')
% % % % load ('C:\MATLAB7\work\OUTPUT\CS.mat')
% 
% % [magnitude_CrossSec_neutral] = resample_profile_CS_finalize_neutral_only(UAF_3D(:,1:3),UAM_3D(:,1:3),E_3D(:,1:3),LAM_3D(:,1:3),LAF_3D(:,1:3),UAF_CS,E_CS,LAF_CS,distance_neutral)  %%ORIGINAL
[new_CrossSec_neu,magnitude_CrossSec_neutral] = resample_profile_CS_finalize(new_UAF_CS,E_CS    ,LAF_CS    ,new_CrossSec_neu ,distances_neutral,unit_vector);
[new_CrossSec_135,magnitude_CrossSec_135] = resample_profile_CS_finalize(new_UAF_CS,E_CS_all(1:3,:),LAF_CS_all(1:3,:),new_CrossSec_135,distances_135,unit_vector);
[new_CrossSec_90,magnitude_CrossSec_90] = resample_profile_CS_finalize(new_UAF_CS,E_CS_all(4:6,:),LAF_CS_all(4:6,:),new_CrossSec_90,distances_90,unit_vector);
[new_CrossSec_max,magnitude_CrossSec_max] = resample_profile_CS_finalize(new_UAF_CS,E_CS_all(7:9,:),LAF_CS_all(7:9,:),new_CrossSec_max,distances_max,unit_vector);
 
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\CrossSec_magnitudes.mat','magnitude_CrossSec_neutral','magnitude_CrossSec_135','magnitude_CrossSec_90','magnitude_CrossSec_max')
