function [UAF_CS,E_CS,LAF_CS] = determine_local_CS (input_skeleton,length_UA_LA)

vector_UA = input_skeleton(1,:) - input_skeleton(2,:);
vector_UA = vector_UA/length_UA_LA(1,:);
z_vector = cross([1 0 0],vector_UA);
z_vector = z_vector/(dot(z_vector,z_vector)^0.5);
x_vector = cross(vector_UA,z_vector);
x_vector = x_vector/(dot(x_vector,x_vector)^0.5);
UAF_CS = [x_vector;vector_UA;z_vector];

vector_LA = input_skeleton(3,:) - input_skeleton(2,:);
vector_LA = vector_LA/length_UA_LA(2,:);
z_vector = cross(vector_LA,[1 0 0]);
z_vector = z_vector/(dot(z_vector,z_vector)^0.5);
x_vector = cross(z_vector,vector_LA);
x_vector = x_vector/(dot(x_vector,x_vector)^0.5);
LAF_CS = [x_vector;vector_LA;z_vector];

% normal of the bijective plane, [0 0 1] and then cross product
sum_vector = vector_UA + vector_LA;
sum_vector = sum_vector/(dot(sum_vector,sum_vector)^0.5);
cross_vector = cross(vector_LA,vector_UA);
cross_vector= cross_vector/(dot(cross_vector,cross_vector)^0.5);
normal_vector = cross(cross_vector,sum_vector);
normal_vector= normal_vector/(dot(normal_vector,normal_vector)^0.5);
z_vector = cross([1 0 0],normal_vector);
z_vector = z_vector/(dot(z_vector,z_vector)^0.5);
x_vector = cross(normal_vector,z_vector);
x_vector = x_vector/(dot(x_vector,x_vector)^0.5);
E_CS = [x_vector;normal_vector;z_vector];
