clear all

%% 1. requesting subject name or ID
subject_filename = input ('Subject ID:', 's');

%% 2. reading the file for the arm range (contains the fully extended and
%% flexed angle for the arm)
arm_angle_range_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Arm Angle Range\*.txt')); 
[row col] = size(arm_angle_range_files);

for i = 1:row
    file_to_read = (arm_angle_range_files(i).name);
    file_to_match = strcat(subject_filename,'.txt');
    string_comparison = strcmp(file_to_read,file_to_match);
    if string_comparison == 1
    fid = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Arm Angle Range\',file_to_read)));
    arm_angle_range = fscanf(fid,'%g %g ',[2,inf]);
    fclose(fid);
    fid2 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Joint length 3D\',file_to_read)));
    joint_neutral = fscanf(fid2,'%g %g %g %g %g %g',[6,inf]);
    joint_neutral = joint_neutral';
    fclose(fid2);
    fid3 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Joint Coordinates Maximum Flexion\',file_to_read)));
    joint_max = fscanf(fid3,'%g %g %g %g %g %g',[6,inf]);
    joint_max = joint_max';
    fclose(fid3);
    break
    end
end

%% 3. calculating CS for joint neutral and skeleton length
length_UA_LA = [(joint_neutral(1,1)^2+joint_neutral(1,2)^2+joint_neutral(1,3)^2)^0.5;   (joint_neutral(1,4)^2+joint_neutral(1,5)^2+joint_neutral(1,6)^2)^0.5];
input_skeleton = [joint_neutral(1,1:3);0 0 0;joint_neutral(1,4:6)];
[UAF_CS,E_CS,LAF_CS] = determine_local_CS (input_skeleton,length_UA_LA);

%% 4. requesting specific angle to be modelled
correct_value = 0;
while correct_value == 0    
    arm_angle_ext = num2str(arm_angle_range(1,1));
    arm_angle_flex = num2str(arm_angle_range(2,1));
    any_angle = input(['Enter any angle. (The value must be between:',arm_angle_flex,' and ',arm_angle_ext,') ']);
    if any_angle<arm_angle_range(2,1) | any_angle>arm_angle_range(1,1)
        ['Value is not correct, the value must be between:',arm_angle_flex,' and ',arm_angle_ext]
    else
        correct_value = 1;
    end
end


%% 5. deciding the index number to open the related files and ratio for CS and
%% profile interpolation
if (any_angle>=135)
    index_number_for_file = [1 2];
    ratio = (any_angle-arm_angle_range(1,1))/(135-arm_angle_range(1,1));
elseif (any_angle>90 & any_angle<135);
    index_number_for_file = [2 3];
    ratio = (any_angle-135)/(90-135);
else
    index_number_for_file = [3 4];
    ratio = (any_angle-90)/(arm_angle_range(2,1)-90);
end

%% 6.1. reading the file sources for the cross sec magnitudes
%% 6.2. reading the profile distance files
%% 6.3. reading the location of the cross sections files
profile_mag_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Profile Magnitudes\*.txt')) ;
cross_sec_loc_files = dir(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Cross Section Location\*.txt')) ;
[row col] = size(profile_mag_files);
count = 0;
for i = 1:row
    file_to_read = (profile_mag_files(i).name);
    if i == 1
       index_of_file = 1;
    else
       index_of_file = count + 1;
    end
    index_hyphen = findstr(file_to_read,'_');
    file_to_match = file_to_read(1,1:(index_hyphen-1));
    string_comparison = strcmp(subject_filename,file_to_match);
    index_to_match = str2num(file_to_read(1,index_hyphen+1:index_hyphen+2));
    if (string_comparison == 1 & ismember(index_to_match,index_number_for_file))
        count = count + 1;
        fid2 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Profile Magnitudes\',file_to_read)));
        fid3 = fopen(char(fullfile(matlabroot,'work\Subject_Data_FDM_phase_1\Cross Section Location\',file_to_read)));
        count_line = 0;
     
        count_line2 = 0;
        while feof(fid2) == 0
            count_line2 = count_line2 + 1;
            tline2 = fgetl(fid2);
            profile_distances(count_line2, count) = str2num(tline2);
        end
        fclose(fid2);
        
        while feof(fid3) == 0
            tline3 = fgetl(fid3);
            cross_sec_loc(1:5, count) = str2num(tline3);
        end
        fclose(fid3);        
    end 
    if count == 2, break
    end
end

%% 7. rearranging and dividing the cross sec magnitudes matrices into the
%% upper and lower bound for CS interpolation

load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\CrossSec_magnitudes.mat')
if index_number_for_file == [1 2]
   base_magnitude =  magnitude_CrossSec_neutral
   upper_bound_magnitude = magnitude_CrossSec_135
elseif index_number_for_file == [2 3]
   base_magnitude =  magnitude_CrossSec_135
   upper_bound_magnitude = magnitude_CrossSec_90 
else
   base_magnitude =  magnitude_CrossSec_90
   upper_bound_magnitude = magnitude_CrossSec_max
end

base_distance = profile_distances(:,1);
upper_bound_distance = profile_distances(:,2);
%% 8.  interpolate the position for the CS (2 MARCH 2010) and create the
%% UAF_CS_any, LAF_CS_any and E_CS_any
UAF_distance_any = ( cross_sec_loc(1,2)-cross_sec_loc(1,1) )*ratio + cross_sec_loc(1,1)
UAM_distance_any = ( cross_sec_loc(2,2)-cross_sec_loc(2,1) )*ratio + cross_sec_loc(2,1)
LAM_distance_any = ( cross_sec_loc(4,2)-cross_sec_loc(4,1) )*ratio + cross_sec_loc(4,1)
LAF_distance_any = ( cross_sec_loc(5,2)-cross_sec_loc(5,1) )*ratio + cross_sec_loc(5,1)
distances_any = [UAF_distance_any;UAM_distance_any;LAM_distance_any;LAF_distance_any];

%% 9. calculate the carrying angle for neutral and maximum flexion
normal_plane = cross((input_skeleton(1,:)/length_UA_LA(1,:)),[0 0 1]);
max_carrying_angle = asin(dot(normal_plane,input_skeleton(3,:))/(dot(normal_plane,normal_plane)^0.5*length_UA_LA(2,:)))*180/pi %% fully extended
%% min_carrying_angle = calculate from the joint for maximum flexion
length_UA_LA_max = [(joint_max(1,1)^2+joint_max(1,2)^2+joint_max(1,3)^2)^0.5;   (joint_max(1,4)^2+joint_max(1,5)^2+joint_max(1,6)^2)^0.5]
input_skeleton_max = [joint_max(1,1:3);0 0 0;joint_max(1,4:6)]
normal_plane = cross((input_skeleton_max(1,:)/length_UA_LA_max(1,:)),[0 0 1]);
min_carrying_angle = asin(dot(normal_plane,input_skeleton_max(3,:))/(dot(normal_plane,normal_plane)^0.5*length_UA_LA_max(2,:)))*180/pi %% fully extended
carrying_angle = [min_carrying_angle max_carrying_angle];


%% 9. calculate the carrying angle, flexion angle, CS for the wanted angle
if abs(any_angle - str2num(arm_angle_ext))>0.001
    %% part 1
    new_X = cross(UAF_CS(2,:),[0 0 1]);
    new_X = new_X/(dot(new_X,new_X)^0.5);
    new_Z = cross(new_X,UAF_CS(2,:));
    new_Z = new_Z/(dot(new_Z,new_Z)^0.5);
    new_UAF_CS = [new_X;UAF_CS(2,:);new_Z];

    %% part 2
    [carrying_angle_any,flexion_angle_any] = calculate_carrying_and_flexion_FDM_validation_phase_1(carrying_angle,arm_angle_range,any_angle);

    %% part 3
    [euler_matrix] = create_euler_matrix(flexion_angle_any,carrying_angle_any,0);
    new_vector_LA_any = [0 -1 0]*euler_matrix*new_UAF_CS;

    %% part 4
    [LAF_CS_any]= local_CS_other_key_postures (new_vector_LA_any);

    %% part 5
    [E_CS_any] = determine_E_CS_for_any_posture(new_UAF_CS(2,:),new_vector_LA_any);
    %%%% SUB FUNCTION
else
    new_UAF_CS = UAF_CS;
    LAF_CS_any = LAF_CS;
    E_CS_any = E_CS;
%     distances_any = [UAF_distance_neutral;UAM_distance_neutral;LAM_distance_neutral;LAF_distance_neutral];
end

load ('C:\MATLAB7\work\INITIAL INPUT\all_locations_fda')

LAF_W = find(all_locations_fda(2,:) == 6);
S_UAF = find(all_locations_fda(2,:) == 1);
[unused col_LAF_W] = size(LAF_W);
[unused col_S_UAF] = size(S_UAF);

S = UAF_CS(2,:)*length_UA_LA(1,:);
UAF = UAF_CS(2,2:3)*UAF_distance_any;
UAM = UAF_CS(2,2:3)*UAM_distance_any;
LAM = LAF_CS_any(2,2:3)*LAM_distance_any;
LAF = LAF_CS_any(2,2:3)*LAF_distance_any;
W = LAF_CS_any(2,:)*length_UA_LA(2,:);
joint_length_any = [(dot(S(2:3),S(2:3)))^0.5  (dot(UAF,UAF))^0.5   (dot(UAM,UAM))^0.5  0  (dot(LAM,LAM))^0.5   (dot(LAF,LAF))^0.5 (dot(W(2:3),W(2:3)))^0.5]; %% this one is when using all_locations_FDA
% joint_length_any = [length_UA_LA(1,:) length_UA_LA(1,:)*2/3 length_UA_LA(1,:)*1/3      0   length_UA_LA(2,:)*1/3 length_UA_LA(2,:)*2/3 length_UA_LA(2,:)];
arm_vector_any = [S W];

[sampling_all_any]= vector_prev_segment(joint_length_any,arm_vector_any,all_locations_fda);  
[row_sampled unused] = size(sampling_all_any);

for j=1:row_sampled
    total_distance =  ratio*(upper_bound_distance(j,1)-base_distance(j,1))+base_distance(j,1);
    profile_coordinates(j,:) = sampling_all_any(j,1:2)+sampling_all_any(j,3:4)*total_distance;
    list_total_distance(j,:) = total_distance;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
    total_distance_all(j,1)=total_distance;
end

reduced_total_distance_all = total_distance_all((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
reduced_profile_coordinates = profile_coordinates((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
reduced_sampling_all_any = sampling_all_any((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);
[row_reduced_sampled unused] = size(reduced_profile_coordinates);

reduced_profile_coordinates_any = [zeros(row_reduced_sampled,1) reduced_profile_coordinates];
profile_coordinates_any = [zeros(row_sampled,1) profile_coordinates];
reduced_total_distance_all = total_distance_all((col_S_UAF+2):(row_sampled-col_LAF_W-1),:);


%% SAVE THE FILE OF SAMPLING ANY CENTER AND VECTOR
savefile = strcat('C:\MATLAB7\work\PROFILE VALIDATION\PROFILE PREDICTION\sampling_all_any_',num2str(any_angle),'.mat')
save(savefile,'sampling_all_any')

load('C:\MATLAB7\work\INITIAL INPUT\unit_vector.mat')

if (any_angle<=91 & any_angle>=36)
    for i = 1:5
        if i <= 2
            CS_transform = new_UAF_CS;
            translation_distance = distances_any(i,:);
        elseif i==3
            CS_transform = E_CS_any;
            translation_distance = 0;
        else
            CS_transform = LAF_CS_any;
            translation_distance = distances_any(i-1,:);
        end        
        
        if i ~= 3
            for j=1:16  
                total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);%% simplified from above
                Cross_Sec_coordinates_scaled(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
            end     
            ratio
            Cross_Sec_coordinates_scaled
            for j=1:16 
                ratio_zero = 0;
                total_magnitude =  ratio_zero*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);%% simplified from above
                Cross_Sec_coordinates_unscaled(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude;%%sampling_all_135(j,1:2)+sampling_all_135(j,3:4)*total_distance;
            end  
            for j = 1:2
                if j == 1
                    index = [2 3 4 5 6 7 8];
                    old_length = max(Cross_Sec_coordinates_unscaled(:,1));
                    new_length = max(Cross_Sec_coordinates_scaled(:,1));
                else
                    index = [10 11 12 13 14 15 16];
                    old_length = min(Cross_Sec_coordinates_unscaled(:,1));
                    new_length = min(Cross_Sec_coordinates_scaled(:,1));
                end
                    ratio_front_view = new_length/old_length;
                for k = index
                    Cross_Sec_coordinates_unscaled(k,1) = Cross_Sec_coordinates_unscaled(k,1)*ratio_front_view;
                end
            end            
            for j=1:16  
                Cross_Sec_coordinates(j,:) = Cross_Sec_coordinates_unscaled(j,:)*CS_transform + CS_transform(2,:)*translation_distance;
            end
        else         
            for j=1:16  
                total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
                Cross_Sec_coordinates(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude*CS_transform + CS_transform(2,:)*translation_distance;
            end
        end
        
        if i==1
            all_Cross_Sec_coordinates = Cross_Sec_coordinates;
        else
            all_Cross_Sec_coordinates = [all_Cross_Sec_coordinates Cross_Sec_coordinates];
        end
        
    end    
else
    for i = 1:5
        if i <= 2
            CS_transform = new_UAF_CS;
            translation_distance = distances_any(i,:);
        elseif i==3
            CS_transform = E_CS_any;
            translation_distance = 0;
        else
            CS_transform = LAF_CS_any;
            translation_distance = distances_any(i-1,:);
        end 
        for j=1:16
            total_magnitude =  ratio*(upper_bound_magnitude(j,i)-base_magnitude(j,i))+base_magnitude(j,i);
            Cross_Sec_coordinates(j,:) = [unit_vector(j,1) 0 unit_vector(j,2)]*total_magnitude*CS_transform + CS_transform(2,:)*translation_distance;
        end
        if i==1
            all_Cross_Sec_coordinates = Cross_Sec_coordinates;
        else
            all_Cross_Sec_coordinates = [all_Cross_Sec_coordinates Cross_Sec_coordinates];
        end
    end
end

%%%_____________________________ TRANSLATION CS_____________________________________  
[CS_bspline_any,center_any] = creating_CS_bspline(all_Cross_Sec_coordinates(:,1:3),all_Cross_Sec_coordinates(:,4:6),all_Cross_Sec_coordinates(:,7:9),all_Cross_Sec_coordinates(:,10:12),all_Cross_Sec_coordinates(:,13:15));
[bspline_any_max] = bspline_max_side_view(CS_bspline_any,new_UAF_CS,E_CS_any,LAF_CS_any,distances_any);


if any_angle >35 
    vector_coordinates_sytem = [new_UAF_CS(3,:)  new_UAF_CS(3,:)  E_CS_any(3,:)  LAF_CS_any(3,:)  LAF_CS_any(3,:)];
    bone_coordinates_system = [new_UAF_CS(2,:)  new_UAF_CS(2,:)  0 0 0  LAF_CS_any(2,:)  LAF_CS_any(2,:)];
    [vector_coordinates_sytem] = modify_vector_coordinates_sytem(vector_coordinates_sytem,profile_coordinates_any,bspline_any_max); 
    [all_Cross_Sec_coordinates,new_center_135,new_CS_bspline_135_max,translation_magnitude_135] = translating_CS(profile_coordinates_any,vector_coordinates_sytem,bspline_any_max(:,3:4),all_Cross_Sec_coordinates,bspline_any_max,center_any);
    [CS_bspline_any,center_any] = creating_CS_bspline(all_Cross_Sec_coordinates(:,1:3),all_Cross_Sec_coordinates(:,4:6),all_Cross_Sec_coordinates(:,7:9),all_Cross_Sec_coordinates(:,10:12),all_Cross_Sec_coordinates(:,13:15));
    [bspline_any_max,bspline_max_index] = bspline_max_side_view(CS_bspline_any,new_UAF_CS,E_CS_any,LAF_CS_any,distances_any);

    UAF_profile_point = CS_bspline_any(bspline_max_index(1,2),1:3)
    UAM_profile_point = CS_bspline_any(bspline_max_index(2,2),4:6)
    E_profile_point = CS_bspline_any(bspline_max_index(3,2),7:9)
    LAM_profile_point = CS_bspline_any(bspline_max_index(4,2),10:12)
    LAF_profile_point = CS_bspline_any(bspline_max_index(5,2),13:15)
    attach_profile = [UAF_profile_point;UAM_profile_point;E_profile_point;LAM_profile_point;LAF_profile_point];
else
    [CS_bspline_any,center_any] = creating_CS_bspline(all_Cross_Sec_coordinates(:,1:3),all_Cross_Sec_coordinates(:,4:6),all_Cross_Sec_coordinates(:,7:9),all_Cross_Sec_coordinates(:,10:12),all_Cross_Sec_coordinates(:,13:15));
    [bspline_any_max,bspline_max_index] = bspline_max_side_view(CS_bspline_any,new_UAF_CS,E_CS_any,LAF_CS_any,distances_any);

    UAF_profile_point = CS_bspline_any(bspline_max_index(1,2),1:3)
    UAM_profile_point = CS_bspline_any(bspline_max_index(2,2),4:6)
    E_profile_point = CS_bspline_any(bspline_max_index(3,2),7:9)
    LAM_profile_point = CS_bspline_any(bspline_max_index(4,2),10:12)
    LAF_profile_point = CS_bspline_any(bspline_max_index(5,2),13:15)
    attach_profile = [UAF_profile_point;UAM_profile_point;E_profile_point;LAM_profile_point;LAF_profile_point] ;  
end

save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\attach_profile.mat','attach_profile')
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\all_Cross_Sec_coordinates.mat','all_Cross_Sec_coordinates')
vector_coordinates_system = [new_UAF_CS E_CS_any  LAF_CS_any];
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\vector_coordinates_system.mat','vector_coordinates_system')
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\distances_any.mat','distances_any')
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\sampling_all_any.mat','sampling_all_any')
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\profile_coordinates_any.mat','profile_coordinates_any')

list_points_at_elbow = find(sampling_all_any(:,1) == 0)

[row_list col_list] = size(list_points_at_elbow);
index_profile(1,1:2) = [1 list_points_at_elbow(1,1) + (row_list-rem(row_list,2))*0.5];
[row_profile_coordinates_any  unused] = size(profile_coordinates_any);
index_profile(2,1:2) = [index_profile(1,2)+1 row_profile_coordinates_any];
profile_coordinates_modified_any =   profile_coordinates_any;

save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\profile_coordinates_modified_any.mat','profile_coordinates_modified_any')
save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\index_profile.mat','index_profile')

save('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\any_angle.mat','any_angle')

savefile_profile_validation = strcat('C:\MATLAB7\work\PROFILE VALIDATION\PROFILE PREDICTION\',subject_filename,'_',num2str(any_angle),'.mat')
save(savefile_profile_validation,'reduced_profile_coordinates_any','reduced_sampling_all_any')


all_Cross_Sec_coordinates_validation = [distances_any(1,:)*vector_coordinates_system(2,1:3)  distances_any(2,:)*vector_coordinates_system(2,1:3) 0 0 0   distances_any(3,:)*vector_coordinates_system(2,7:9)   distances_any(4,:)*vector_coordinates_system(2,7:9);all_Cross_Sec_coordinates];

save('C:\MATLAB7\work\CROSS SECS VALIDATION\all_Cross_Sec_coordinates_validation.mat','all_Cross_Sec_coordinates_validation')

