function [bezier] = create_bezier(points)

[rowpoints col] = size(points);

id_size   = rowpoints;
identity = 4*eye(id_size);
[rowid ol]=size(identity);
for i=1:rowid
	if i == 1
	    identity(i,i+1) = 1;
	elseif i == rowid
	    identity(i,i-1) = 1;
	else	
	    identity(i,i-1) = 1;
	    identity(i,i+1) = 1;
	end
end

identity(1,rowid) = 1;
identity(rowid,1) = 1;

for i = 1:rowid    
	S_S(i,:) = 6*points(i,:);	
end
B= inv(identity)*S_S;
[row col] = size(B);


count=0;
for i=1:rowpoints
        count = count + 1;
        step  = (count-1)*4;
    if i==rowpoints
        i;
        step;
        bezier(step+1,:) = points(i,:);
        c = B(i,:) + 1/3*(B(1,:)-B(i,:));
        bezier(step+2,:) = c;
        c =B(i,:) + 2/3*(B(1,:)-B(i,:));
        bezier(step+3,:) = c;
        bezier(step+4,:) = points(1,:);
    else
        bezier(step+1,:) = points(i,:);
        c = B(i,:) + 1/3*(B(i+1,:)-B(i,:));
        bezier(step+2,:) = c;
        c =B(i,:) + 2/3*(B(i+1,:)-B(i,:));
        bezier(step+3,:) = c;
        bezier(step+4,:) = points(i+1,:);
    end
end

bezier;

