clear all

[coordinates_UAF,coordinates_UAM,coordinates_E,coordinates_LAM,coordinates_LAF,attach_profile,bezier_loc_all,t_all,lngth_cum_all,lngth_index]  = preparing_cross_sec_for_flesh_deformation_FDM_phase_1_V2;

attach_profile = [attach_profile(1,:);attach_profile(3,:);attach_profile(5,:)] ;

% %%calculate the length for each cross section and find out the length for each value of t
three_cross_sections = [coordinates_UAF coordinates_UAM coordinates_E coordinates_LAM coordinates_LAF];

[row col]=size(three_cross_sections);
result = zeros(row,col);
count = 0;
for i=1:3:col
    count = count+1;
    [bezier] = create_bezier(three_cross_sections(1:row,i:i+2));
    if i==1
        [rowbez colbez]=size(bezier);
    end
    lngth_cum = continuous_subdivision(bezier);
    [rowlngth collngth]=size(lngth_cum);
    total_cross_sec_lngth = lngth_cum(rowlngth,2);
    lngth_increment=lngth_cum(rowlngth,2)/16;
    loc_bezier_for_t = bezier_loc_all((count-1)*2+1,:);
    lngth_cum_partial = lngth_cum;
    [tf loc_start] = ismember((loc_bezier_for_t-4),lngth_cum_partial(:,3));
    if loc_start == 0
        loc_start =1
    end
    [tf loc_end]   = ismember(loc_bezier_for_t,lngth_cum_partial(:,3));
    t = t_all(count,:);
    lngth_cum_partial = lngth_cum(loc_start+1:loc_end,:);
    [rowlngthpartial collngthpartial] = size(lngth_cum_partial);
    for j=1:rowlngthpartial
        if lngth_cum_partial(j,1)>t 
           if j==1
              line = 1
           else
              line = j-1
           end
           break
        end
    end
    if line==1
       ratio = t/lngth_cum_partial(1,1);
       lngth = lngth_cum(loc_start,2)+(lngth_cum_partial(1,2)-lngth_cum(loc_start,2))*ratio;
    else
       ratio = (t-lngth_cum_partial(line,1))/(lngth_cum_partial(line+1,1) - lngth_cum_partial(line,1));
       lngth = lngth_cum_partial(line,2)+(lngth_cum_partial(line+1,2)-lngth_cum_partial(line,2))*ratio;
    end
    
    added = lngth_cum(loc_start+1:loc_end,:);
    count_2 = 0;
    for k= 1:16 
        count_2 = count_2+1;
        if k==1
            lngth = lngth;
        else
            lngth=lngth+lngth_increment;
        end
        if lngth>=total_cross_sec_lngth
           lngth = lngth-total_cross_sec_lngth;
        end
        if k==1
            start_m = loc_bezier_for_t;
        elseif m == (rowbez-3)
           start_m = 1;  
        else
           start_m = m;
        end
        for m=start_m:4:64

                [possible_locs_max] = find(lngth_cum(:,2)>lngth);
                [possible_locs_min] = find(lngth_cum(:,2)<=lngth);
                possible_start = lngth_cum(max(possible_locs_min),3);
                possible_end = lngth_cum(min(possible_locs_max),3);
                if possible_start == possible_end

                   loc_search_start = min(find(lngth_cum(:,3)==possible_start));
                   loc_search_end = max(find(lngth_cum(:,3)==possible_start));
                   val_lngth_min = lngth_cum(loc_search_start,2);
                   val_lngth_max = lngth_cum(loc_search_end,2);
                else

                   loc_search_start = max(possible_locs_min);
                   loc_search_end = max(find(lngth_cum(:,3)==possible_end));
                   val_lngth_min = lngth_cum(loc_search_start,2);
                   val_lngth_max = lngth_cum(loc_search_end,2) ;
                end
            
            if (lngth>=val_lngth_min & lngth<=val_lngth_max)
               lngth_cum_partial_2 = lngth_cum(loc_search_start:loc_search_end,:) ;
               [rowlngthpartial_2 collngthpartial_2] = size(lngth_cum_partial_2);

               for n=1:rowlngthpartial_2
                  if lngth_cum_partial_2(n,2)>lngth
                    if n==1
                        line_2 = 0;
                    else
                        line_2 = n-1;
                    end
                    break    
                  end
               end
               break
            end            
        end
        
         
        possible_start = lngth_cum_partial_2(1,3);
        possible_end = lngth_cum_partial_2(rowlngthpartial_2,3);
        if possible_start == possible_end
            [possible_locations] = find(lngth_cum_partial_2(:,2)>lngth);
            lngth_upper_value = lngth_cum_partial_2(min(possible_locations),2);
            lngth_lower_value = lngth_cum_partial_2(min(possible_locations)-1,2);
            u_upper_value = lngth_cum_partial_2(min(possible_locations),1)    ;        
            u_lower_value = lngth_cum_partial_2(min(possible_locations)-1,1);
            ratio = (lngth-lngth_lower_value)/(lngth_upper_value-lngth_lower_value);
            u = u_lower_value + (u_upper_value-u_lower_value)*ratio;
        else
            [possible_locations] = find(lngth_cum_partial_2(:,2)>lngth);
            lngth_upper_value = lngth_cum_partial_2(min(possible_locations),2);
            lngth_lower_value = lngth_cum_partial_2(min(possible_locations)-1,2);
            u_upper_value = lngth_cum_partial_2(min(possible_locations),1);
            ratio = (lngth-lngth_lower_value)/(lngth_upper_value-lngth_lower_value);
            u = u_upper_value*ratio;
        end
        
        bezier_partial = bezier(lngth_cum_partial_2(2,3):(lngth_cum_partial_2(2,3)+3),:);

        [coefficient]=calculate_poly_bezier(bezier_partial);
        result(count_2,i:i+2) = transpose(coefficient*[u^3;u^2;u;1]);
    end
end    

clear lngth_cum_all lngth_cum

[rowcoord col]  = size(coordinates_UAF); 
for h=1:2
    if h==1
       start_index = 1;
       three_cross_sections_partial =  [result(:,1:3) result(:,4:6) result(:,7:9)];
    else
       index_bezier = [start_index row];
       start_index = row+1;
       three_cross_sections_partial =  [result(:,7:9) result(:,10:12) result(:,13:15)];
    end
    for i=1:rowcoord
        [bezier,knots,t_parameter]=bspline_interpolation_quadratic([three_cross_sections_partial(i,1:3);three_cross_sections_partial(i,4:6);three_cross_sections_partial(i,7:9)]);
        [lngth_cum] = continuous_subdivision_quadratic(bezier);
        [rowlngth col] = size(lngth_cum);
        lngth_cum = [lngth_cum i*ones(rowlngth,1) h*ones(rowlngth,1)];
        [rowbez col] = size(bezier);
        bezier = [bezier i*ones(rowbez,1)];
        if h==1 & i==1
            bezier_all = bezier;
            lngth_cum_all = lngth_cum;
        else
            lngth_cum_all = [lngth_cum_all;lngth_cum];
            bezier_all = [bezier_all;bezier];
        end
    end
    [row col] = size(bezier_all);
end

index_bezier = [index_bezier;start_index row];


% %%1/3 of the upper/lower part
for k=1:2
for h=1:2
    if k==1 & h==1
       factor = 1/3;
    elseif k==1 & h==2
       factor = 2/3;
    elseif k==2 & h==1
        factor = 2/3;
    elseif k==2 & h==2
        factor = 1/3;
    end        
    bezier_all_partial = bezier_all(index_bezier(h,1):index_bezier(h,2),:);
    if h==1
    [tf h_previous]= ismember(h,lngth_cum_all(:,5));
    lngth_cum_all_partial = lngth_cum_all(1:h_previous,:)  ;
    else
    start_h = h_previous+1;
    [tf h_previous]= ismember(h,lngth_cum_all(:,5));
    lngth_cum_all_partial = lngth_cum_all(start_h:h_previous,:) ;     
    end
    count_1 = 0;
    count_2 = 0;
    for i=1:rowcoord
    	[tf loc_end] = ismember(i,lngth_cum_all_partial(:,4));
    	if i==1
       		loc_start = 1 ;
       		loc_start_bezier = 1;
        else
       		[tf loc_start_bezier] = ismember((i-1),bezier_all_partial(:,4));
       		loc_start_bezier = loc_start_bezier+1;
       		[tf loc_start] = ismember((i-1),lngth_cum_all_partial(:,4));
       	loc_start = loc_start+1;
        end
    	lngth_cum_all_partial_2 = lngth_cum_all_partial(loc_start:loc_end,:);
    	if h==1
            [tf loc_start]= ismember(1,lngth_cum_all_partial_2(:,3));
            [loc_end unused] = size(lngth_cum_all_partial_2);
            origin_lngth = lngth_cum_all_partial_2(loc_start,2);
            lngth_total = lngth_cum_all_partial_2(loc_end,2)-lngth_cum_all_partial_2(loc_start,2);
   
            lngth_partial = factor*lngth_total+origin_lngth;
    		lngth_cum_all_partial_2 = lngth_cum_all_partial_2(loc_start+1:loc_end,:);
        else            
            [tf loc_start]= ismember(1,lngth_cum_all_partial_2(:,3));
            [loc_end unused] = size(lngth_cum_all_partial_2);
            origin_lngth = 0;
            lngth_total = lngth_cum_all_partial_2(loc_start,2);
    
            lngth_partial = factor*lngth_total;
    		lngth_cum_all_partial_2 = lngth_cum_all_partial_2(1:loc_start,:);
        end
    	[loc_end unused] = size(lngth_cum_all_partial_2);
    	[tf loc_end_bezier] = ismember(i,bezier_all_partial(:,4));
    	bezier_all_partial_2 = bezier_all_partial(loc_start_bezier:loc_end_bezier,:);  
        for j=1:loc_end
            if lngth_cum_all_partial_2(j,2)>lngth_partial                
                if j==1
                    ratio = (lngth_partial-origin_lngth)/(lngth_cum_all_partial_2(j,2)-origin_lngth);
                    u = ratio*(lngth_cum_all_partial_2(j,1));
                else
                    ratio = (lngth_partial-lngth_cum_all_partial_2(j-1,2))/(lngth_cum_all_partial_2(j,2)-lngth_cum_all_partial_2(j-1,2));
                    u = ratio*(lngth_cum_all_partial_2(j,1)-lngth_cum_all_partial_2(j-1,1))+lngth_cum_all_partial_2(j-1,1) ;
                end
                if h==1 
                    chosen_bezier = bezier_all_partial_2(4:6,1:3);
                else
                    chosen_bezier = bezier_all_partial_2(1:3,1:3);
                end
                [coefficient]=calculate_poly_bezier_quadratic(chosen_bezier);
                additional_cross_sections(i,1:3) = transpose(coefficient*[u^2;u;1]);
                break
            end
        end
    end
    if h==1 
        additional_cross_sections_all = additional_cross_sections;
    else
        additional_cross_sections_all = [additional_cross_sections_all;additional_cross_sections];
    end
end
    if k ==1
    added_cross_sections = additional_cross_sections_all;;
    else
    added_cross_sections = [added_cross_sections;additional_cross_sections_all];;
    end
end

[row col] = size(added_cross_sections);
added_cross_sections = [added_cross_sections(1:row/4,:);added_cross_sections(row/2+1:3*row/4,:);added_cross_sections(3*row/4+1:row,:);added_cross_sections(row/4+1:row/2,:)];

load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\profile_coordinates_modified_any.mat')
load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\index_profile.mat')
[profile_additional_points] = bezier_for_profile_version_2_FDM_phase_1;

load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\any_angle.mat')

if any_angle>=135
[val index_max] = max(added_cross_sections(1:16,1));
[val index_min] = min(added_cross_sections(1:16,1));
additional_CS_1 = [added_cross_sections(1:(index_max+1),:);profile_additional_points(1,:);added_cross_sections((index_min-1):16,:);added_cross_sections(1,:)]
[val index_max] = max(added_cross_sections(17:32,1));
[val index_min] = min(added_cross_sections(17:32,1));
additional_CS_2 = [added_cross_sections(17:index_max+17,:);profile_additional_points(2,:);added_cross_sections(index_min+15:32,:);;added_cross_sections(17,:)]
[val index_max] = max(added_cross_sections(33:48,1));
[val index_min] = min(added_cross_sections(33:48,1));
additional_CS_3 = [added_cross_sections(33:index_max+33,:);profile_additional_points(3,:);added_cross_sections(index_min+31:48,:);;added_cross_sections(33,:)]
[val index_max] = max(added_cross_sections(49:64,1));
[val index_min] = min(added_cross_sections(49:64,1));
additional_CS_4 = [added_cross_sections(49:index_max+49,:);profile_additional_points(4,:);added_cross_sections(index_min+47:64,:);added_cross_sections(49,:)]
else
[val index_max] = max(added_cross_sections(1:16,1));
[val index_min] = min(added_cross_sections(1:16,1));
additional_CS_1 = [added_cross_sections(1:(index_max),:);profile_additional_points(1,:);added_cross_sections((index_min):16,:);added_cross_sections(1,:)]
[val index_max] = max(added_cross_sections(17:32,1));
[val index_min] = min(added_cross_sections(17:32,1));
additional_CS_2 = [added_cross_sections(17:index_max+16,:);profile_additional_points(2,:);added_cross_sections(index_min+16:32,:);;added_cross_sections(17,:)]
[val index_max] = max(added_cross_sections(33:48,1));
[val index_min] = min(added_cross_sections(33:48,1));
additional_CS_3 = [added_cross_sections(33:index_max+32,:);profile_additional_points(3,:);added_cross_sections(index_min+32:48,:);;added_cross_sections(33,:)]
[val index_max] = max(added_cross_sections(49:64,1));
[val index_min] = min(added_cross_sections(49:64,1));
additional_CS_4 = [added_cross_sections(49:index_max+48,:);profile_additional_points(4,:);added_cross_sections(index_min+48:64,:);added_cross_sections(49,:)]
end

load('C:\MATLAB7\work\CROSS SECS VALIDATION\all_Cross_Sec_coordinates_validation.mat')
all_Cross_Sec_coordinates_validation(2:17,:) = [result(:,1:3) result(:,4:6)  result(:,7:9)  result(:,10:12)  result(:,13:15)];
save('C:\MATLAB7\work\CROSS SECS VALIDATION\all_Cross_Sec_coordinates_validation.mat','all_Cross_Sec_coordinates_validation')

coordinates_UAF = [result(:,1:3); result(1,1:3)]
coordinates_UAM = [result(:,4:6); result(1,4:6)]
coordinates_E = [result(:,7:9); result(1,7:9)]
coordinates_LAM = [result(:,10:12); result(1,10:12)]
coordinates_LAF = [result(:,13:15); result(1,13:15)]

