function [coordinates_UAF,coordinates_UAM,coordinates_E,coordinates_LAM,coordinates_LAF,attach_profile,bezier_loc_all,t_all,lngth_cum_all,lngth_index]  = preparing_cross_sec_for_flesh_deformation_FDM_phase_1_V2

load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\all_Cross_Sec_coordinates.mat');
load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\vector_coordinates_system.mat');
load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\distances_any.mat');
load('C:\MATLAB7\work\OUTPUT\FDM VALIDATION PHASE 1\attach_profile.mat');

%% create bezier of CS in 2D
UAF_2D_coordinates = all_Cross_Sec_coordinates(:,1:3)*transpose(vector_coordinates_system(:,1:3));
UAM_2D_coordinates = all_Cross_Sec_coordinates(:,4:6)*transpose(vector_coordinates_system(:,1:3));
E_2D_coordinates = all_Cross_Sec_coordinates(:,7:9)*transpose(vector_coordinates_system(:,4:6));
LAM_2D_coordinates = all_Cross_Sec_coordinates(:,10:12)*transpose(vector_coordinates_system(:,7:9));
LAF_2D_coordinates = all_Cross_Sec_coordinates(:,13:15)*transpose(vector_coordinates_system(:,7:9));
all_2D_coordinates = [UAF_2D_coordinates UAM_2D_coordinates E_2D_coordinates LAM_2D_coordinates LAF_2D_coordinates];

UAF_center = distances_any(1,:)*vector_coordinates_system(2,1:3)*transpose(vector_coordinates_system(:,1:3));
UAM_center = distances_any(2,:)*vector_coordinates_system(2,1:3)*transpose(vector_coordinates_system(:,1:3));
LAM_center = distances_any(3,:)*vector_coordinates_system(2,7:9)*transpose(vector_coordinates_system(:,7:9));
LAF_center = distances_any(4,:)*vector_coordinates_system(2,7:9)*transpose(vector_coordinates_system(:,7:9));

new_CrossSec = all_2D_coordinates;

%% UAF-UAM_________________________________________________________________
%%create the common plane (calculate the normal)
normal_common_plane = cross(vector_coordinates_system(2,1:3),vector_coordinates_system(2,7:9));

normal_CS_plane = vector_coordinates_system(2,1:3);

%%calculate the coordinates for the intersection between common plane and CS plane
intersection_direction = cross(normal_common_plane,normal_CS_plane);
intersection_point = intersection_direction*100+distances_any(1,:)*vector_coordinates_system(2,1:3);

%%transform the coordinates into 2D
intersection_point_2D = intersection_point*transpose(vector_coordinates_system(:,1:3));

%%calculate the unit vector in 2D
for i=1:16
    rotating_z_axis = rotation_about_Y_axis([intersection_point_2D(1,1) 0 intersection_point_2D(1,3)],(i-1)*(2*pi/16));
    unit_vector_UAF_UAM(i,:) = rotating_z_axis;
end

unit_vector_UAF_UAM = [unit_vector_UAF_UAM(:,1) unit_vector_UAF_UAM(:,3)];

%% E_______________________________________________________________________
%%create the common plane (calculate the normal)
normal_CS_plane = vector_coordinates_system(2,4:6);

%%calculate the coordinates for the intersection between common plane and CS plane
intersection_direction = cross(normal_common_plane,normal_CS_plane);
intersection_point = intersection_direction*100+distances_any(1,:)*vector_coordinates_system(2,4:6);

%%transform the coordinates into 2D
intersection_point_2D = intersection_point*transpose(vector_coordinates_system(:,4:6));

%%calculate the unit vector in 2D
for i=1:16
    unit_vector_E(i,:) = rotation_about_Y_axis([intersection_point_2D(1,1) 0 intersection_point_2D(1,3)],(i-1)*(2*pi/16));
end

unit_vector_E = [unit_vector_E(:,1) unit_vector_E(:,3)];

%% LAM-LAF_______________________________________________________________________
%%create the common plane (calculate the normal)
normal_CS_plane = vector_coordinates_system(2,7:9);

%%calculate the coordinates for the intersection between common plane and CS plane
% intersection_direction = cross(normal_common_plane,normal_CS_plane)
intersection_direction = cross(normal_CS_plane,normal_common_plane);
intersection_point = intersection_direction*100+distances_any(1,:)*vector_coordinates_system(2,7:9);

%%transform the coordinates into 2D
intersection_point_2D = intersection_point*transpose(vector_coordinates_system(:,7:9));

%%calculate the unit vector in 2D
for i=1:16
    unit_vector_LAM_LAF(i,:) = rotation_about_Y_axis([intersection_point_2D(1,1) 0 intersection_point_2D(1,3)],(i-1)*(2*pi/16));
end

unit_vector_LAM_LAF = [unit_vector_LAM_LAF(:,1) unit_vector_LAM_LAF(:,3)];

for i=1:5
    [new_CrossSec(:,3*i-2)  new_CrossSec(:,3*i);new_CrossSec(1,3*i-2)  new_CrossSec(1,3*i)];
    [bezier]=bspline_to_bezier([new_CrossSec(:,3*i-2)  new_CrossSec(:,3*i);new_CrossSec(1,3*i-2)  new_CrossSec(1,3*i)]);
    if i<= 2
        unit_vector = unit_vector_UAF_UAM;
    elseif i == 3
        unit_vector = unit_vector_E;
    else
        unit_vector = unit_vector_LAM_LAF;
    end
    for j = 1:16
        vector_line = unit_vector(j,1:2);
        [intersection,sub_bezier_with_int] = bezier_line_intersection(bezier,vector_line);
        new_CrossSec(j,3*i-2:3*i)= [intersection(1,1) new_CrossSec(j,3*i-1) intersection(1,2)];
    end
end

for i=1:16
    new_CrossSec(i,1:3) = new_CrossSec(i,1:3)*vector_coordinates_system(:,1:3);
    new_CrossSec(i,4:6) = new_CrossSec(i,4:6)*vector_coordinates_system(:,1:3);
    new_CrossSec(i,7:9) = new_CrossSec(i,7:9)*vector_coordinates_system(:,4:6);
    new_CrossSec(i,10:12) = new_CrossSec(i,10:12)*vector_coordinates_system(:,7:9);
    new_CrossSec(i,13:15) = new_CrossSec(i,13:15)*vector_coordinates_system(:,7:9);
end;

attach_profile_2D(1,1:3) = new_CrossSec(1,1:3)*transpose(vector_coordinates_system(:,1:3));
attach_profile_2D(2,1:3) = new_CrossSec(1,4:6)*transpose(vector_coordinates_system(:,1:3));
attach_profile_2D(3,1:3) = new_CrossSec(1,7:9)*transpose(vector_coordinates_system(:,4:6));
attach_profile_2D(4,1:3) = new_CrossSec(1,10:12)*transpose(vector_coordinates_system(:,7:9));
attach_profile_2D(5,1:3) = new_CrossSec(1,13:15)*transpose(vector_coordinates_system(:,7:9));

count = 0;
row_prev = 0;
for i=1:5    
    [control_points] = create_bezier([all_2D_coordinates(:,3*i) all_2D_coordinates(:,3*i-2)]); %%defining control points to create bezier curves
    %% measure the length of CS in 2D
    [lngth_cum,subbezier] =continuous_subdivision_2D_FDM_phase_1(control_points);
    [row_control_points unused] = size(control_points);
    count_bezier_min = 0;
    for j=1:4:(row_control_points+1)  %% finding control point that is closest to the attach profile
        if j == (row_control_points+1)
            j = row_control_points;
        end
        vector = control_points(j,:)- [attach_profile_2D(i,3) attach_profile_2D(i,1)];
        count_bezier_min = count_bezier_min+1;
        length(count_bezier_min,1:2) = [dot(vector,vector)^0.5 j];
    end
    [val index] = min(length(:,1))
    length
    control_points
    if (index-1)==0
        bezier_loc = [length(index,2) length(index,2)+3]
    else
        if length(index-1,1)<length(index+1,1)
            bezier_loc = [length(index,2)-4 length(index,2)-1];
        else
            bezier_loc = [length(index,2) length(index,2)+3];
        end
    end
    bezier = control_points(bezier_loc(1,1):bezier_loc(1,2),:);
    [bezier_chosen,t,intersection] = compare_bezier_V2(bezier,[attach_profile_2D(i,3) attach_profile_2D(i,1)]); %%the cross section is on the x-z plane, %%subdivide the control points into smaller segment 
    [val rowbezier] = min(bezier_chosen(:,1)); 

    [row col] = size(lngth_cum);
    lngth_cum_all((row_prev+1):(row+row_prev),1:col) = lngth_cum;
    lngth_index(i,1:2) = [row_prev+1 row+row_prev];
    row_prev = row;
end

coordinates_UAF = all_Cross_Sec_coordinates(:,1:3);
coordinates_UAM = all_Cross_Sec_coordinates(:,4:6);
coordinates_E = all_Cross_Sec_coordinates(:,7:9);
coordinates_LAM = all_Cross_Sec_coordinates(:,10:12);
coordinates_LAF = all_Cross_Sec_coordinates(:,13:15);


for i=1:5  
     [control_points] = create_bezier(all_2D_coordinates(:,(3*i-2):(3*i)));
     start_bezier = bezier_loc_all(2*i-1,1);
     end_bezier = bezier_loc_all(2*i,1);
     bezier = control_points(start_bezier:end_bezier,:);
     P0=bezier(1,:);
     P1=bezier(2,:);
     P2=bezier(3,:);
     P3=bezier(4,:);
     t_3_x = -P0(1,1) + 3*P1(1,1) - 3*P2(1,1) + P3(1,1);
     t_2_x = 3*P0(1,1) - 6*P1(1,1) + 3*P2(1,1);
     t_1_x = -3*P0(1,1) + 3*P1(1,1);
     t_0_x = P0(1,1);
 
     t_3_y = -P0(1,2) + 3*P1(1,2) - 3*P2(1,2) + P3(1,2);
     t_2_y = 3*P0(1,2) - 6*P1(1,2) +3*P2(1,2);
     t_1_y = -3*P0(1,2) + 3*P1(1,2);
     t_0_y = P0(1,2);
 
     t_3_z = -P0(1,3) + 3*P1(1,3) - 3*P2(1,3) + P3(1,3);
     t_2_z = 3*P0(1,3) - 6*P1(1,3) +3*P2(1,3);
     t_1_z = -3*P0(1,3) + 3*P1(1,3);
     t_0_z = P0(1,3);
     
     t = t_all(i,1);
     
     x =( t^3)*t_3_x + ( t^2 )*t_2_x + ( t )*t_1_x + t_0_x;
     y =( t^3)*t_3_y + ( t^2 )*t_2_y + ( t )*t_1_y + t_0_y;
     z =( t^3)*t_3_z + ( t^2 )*t_2_z + ( t )*t_1_z + t_0_z;  
     
     if i<=2
         starting_point(i,1:3) = [x y z]*vector_coordinates_system(:,1:3);
     elseif i == 3
     starting_point(i,1:3) = [x y z]*vector_coordinates_system(:,4:6) ;   
     else 
     starting_point(i,1:3) = [x y z]*vector_coordinates_system(:,7:9);
     end
    
end
